<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

class fwfmHtmlfwView {
	static function orderingListLinks($params) {
		ob_start();
?>
<div class="input-group input-group-sm fwa-order-input">
<?php
		if (!empty($params['display_up'])) {
?>
	<span class="input-group-prepend">
		<a href="javascript:" onclick="return listItemTask('cb<?php echo $params['num']; ?>','orderup')" class="btn btn-outline-secondary form-control" id="btnGroupAddon"><i class="fal fa-angle-up"></i></a>
	</span>
<?php
		}
?>
	<input class="form-control" placeholder="0" size="4" aria-describedby="btnGroupAddon" type="text" name="order[]" value="<?php echo $params['value']; ?>">
<?php
		if (!empty($params['display_down'])) {
?>
	<span class="input-group-append">
		<a href="javascript:" onclick="return listItemTask('cb<?php echo $params['num']; ?>','orderdown')" class="btn btn-outline-secondary form-control" id="btnGroupAddon"><i class="fal fa-angle-down"></i></a>
	</span>
<?php
		}
?>
</div>
<?php
		return ob_get_clean();
	}
	static function radioListLinks($params) {
		ob_start();
?>
<div class="btn-group mb-1 <?php if (!empty($params['wrapper_class'])) echo $params['wrapper_class']; ?>" role="group">
<?php
		$row = $params['row'];
		foreach ($params['buttons'] as $button) {
			$key = $button['name'];
			$is_checked = $row->$key;
			$classes = array('btn', 'btn-outline-secondary', 'btn-sm');
			if ($is_checked) {
				$classes[] = 'active';
				if (!empty($button['active_class'])) {
					$classes[] = $button['active_class'];
				}
			}
?>
	<a href="javascript:" onclick="return listItemTask('cb<?php echo $params['num']; ?>','<?php echo $is_checked?$button['task_off']:$button['task_on']; ?>')" class="<?php echo implode(' ', $classes); ?>" title="<?php echo fwfmText::_($is_checked?$button['title_off']:$button['title_on']); ?>"><i class="<?php echo $button['icon_class']; ?>"></i></a>
<?php
		}
?>
</div>
<?php
		return ob_get_clean();
	}
	static function booleanListLink($params) {
		ob_start();
?>
<a href="javascript:" onclick="return listItemTask('cb<?php echo $params['num']; ?>','<?php echo $params['value']?$params['task_off']:$params['task_on']; ?>')" title="<?php echo fwfmText::_($params['value']?$params['title_off']:$params['title_on']); ?>"><span class="badge badge-pill badge-<?php echo $params['value']?'success':'danger'; ?>"><i class="fal fa-<?php echo $params['value']?'check':'times'; ?>"></i></span></a>
<?php
		return ob_get_clean();
	}
	static function menuItem($params) {
		ob_start();
?>
<li class="fwa-menu-item<?php if (!empty($params['active'])) { ?> active<?php } ?>">
	<a href="<?php echo $params['link']; ?>"><i class="<?php echo $params['icon_class']; ?>"></i> <?php echo $params['name']; ?></a>
</li>
<?php
		return ob_get_clean();
	}
	static function radioGroup($name, $value, $params) {
		ob_start();
?>
<div class="btn-group<?php if (!empty($params['wrapper_class'])) { ?> <?php echo $params['wrapper_class']; } ?>" role="group">
<?php
		foreach ($params['buttons'] as $button) {
			$classes = array('btn');
			if (!empty($button['class'])) {
				$classes[] = $button['class'];
			}
			if ($value == $button['value']) {
				$classes[] = 'active';
				if (!empty($button['active_class'])) {
					$classes[] = $button['active_class'];
				}
			}
?>
	<button type="button" class="<?php echo implode(' ', $classes) ?>" data-name="<?php echo $name; ?>" data-value="<?php echo htmlspecialchars($button['value']); ?>" data-active-class="<?php echo htmlspecialchars($button['active_class']); ?>"><?php if (!empty($button['icon_class'])) { ?><i class="fa <?php echo $button['icon_class']; ?>"></i><?php } if (!empty($button['title'])) { echo $button['title']; } ?></button>
<?php
		}
?>
</div>
<input type="hidden" name="<?php echo $name; ?>" value="<?php echo htmlspecialchars($value); ?>" />
<?php
		if (!defined('FW_RADIO_HANDLER_LOADED')) {
			define('FW_RADIO_HANDLER_LOADED', 1);
			fwfmHtml::_('jquery.framework');
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('.btn-group button').click(function() {
		var $button = $(this);
		var $input = $('input[name="'+$button.data('name')+'"]');
		if ($input.length && $input.val() != $button.data('value')) {
			$('button', $button.closest('.btn-group')).attr('class', 'btn');
			$button.addClass($button.data('active-class')).addClass('active');
			$input.val($button.data('value')).change();
		}
	});
	})(jQuery);
});
</script>
<?php
		}
		return ob_get_clean();
	}
	static function handleUploadButton($params) {
		ob_start();
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
<?php
		if (!defined('FWVIEW_UPLOAD_HANDLER_LOADED')) {
			define('FWVIEW_UPLOAD_HANDLER_LOADED', true);
?>
	$(document).on('change', '.fwcss input[type="file"]', function() {
		var $inp = $(this);
		var files = $inp.prop('files');
		if (files && files.length) {
			var buff = [];
			for (var i = 0; i < files.length; i++) {
				var file = files[i];
				if ('name' in file) {
					buff.push(file.name);
				} else {
					buff.push(file.fileName);
				}
			}
			$inp.next().html(buff.join(','));
		} else {
			$inp.next().html('<?php echo fwfmText::_('FWFM_CHOOSE_FILE', false); ?>');
		}
	});
	$('.fwcss input[type="file"]').change();
<?php
		}
?>
	$(document).on('click', '<?php echo $params['button']; ?>', function() {
		var form = this.form;
		var $button = $(this);
		var $input = $('<?php echo $params['input']; ?>');
		var filename = $input.val();
		if (filename != '') {
			var exts = [<?php if (!empty($params['exts'])) { ?>'<?php echo implode("','", $params['exts']); ?>'<?php } ?>];
			if (exts) {
				var ext = filename.split('.').pop().toLowerCase();
				var ext_found = false;
				for (var i = 0; i < exts.length; i++) {
					if (exts[i] == ext) {
						ext_found = true;
						break;
					}
				}
				if (!ext_found) {
					alert('<?php echo fwfmText::sprintf('FWFM_MENU_EXTENSIONS_ALLOWED', implode(", ", $params['exts'])); ?>');
					return;
				}
			}
<?php
		if (!empty($params['submit_code'])) echo $params['submit_code'];
?>
			var formdata = new FormData(form);
			<?php if (!empty($params['view'])) { ?>formdata.append('view', '<?php echo $params['view']; ?>');<?php } ?>
			formdata.append('layout', '<?php echo $params['layout']; ?>');
			formdata.append('format', 'json');
<?php
		if (!empty($params['post_data'])) {
			foreach ($params['post_data'] as $key=>$val) {
?>
			formdata.append('<?php echo $key ?>', '<?php echo $val; ?>');
<?php
			}
		}
?>
			var $progress_bar = $('<div class="progress"><div class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div></div>');
			$button.attr('disabled', true).after($progress_bar);

			$.ajax({
				xhr: function() {
					var xhr = new window.XMLHttpRequest();

					xhr.upload.addEventListener("progress", function(evt) {
						if (evt.lengthComputable) {
							var percentComplete = evt.loaded / evt.total;
							percentComplete = parseInt(percentComplete * 100);
							$progress_bar.find('.progress-bar').css('width', percentComplete+'%');
						}
					}, false);

					return xhr;
				},
				url: <?php if (empty($params['url'])) { ?>form.action<?php } else { ?>'<?php echo $params['url']; ?>'<?php } ?>,
				type: "POST",
				data: formdata,
				dataType: 'json',
				contentType: false,
				processData: false,
				success: <?php if (empty($params['callback'])) { ?>function(data) {
					$progress_bar.remove();
					$button.attr('disabled', false);
					$input.next().html('<?php echo fwfmText::_('FWFM_CHOOSE_FILE', false); ?>');
					var $parent = $input.parent();
					var input_html = $parent.html();
					$parent.html(input_html);
					if (data.id) {
						$('input[name="id"]').val(data.id);
					}
					if (data.image) {
						$('<?php echo $params['image']; ?>').attr('src', data.image).parent().show();
					}
					if (data.msg) {
						alert(data.msg);
					}
				}
<?php
				} else echo $params['callback'];
?>
			});
		}
	});
	})(jQuery);
});
</script>
<?php
		return ob_get_clean();
	}
	static function handleRemoveButton($params) {
		ob_start();
?>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$(document).on('click', '<?php echo $params['button']; ?>', function() {
		var form = this.form;
		var $button = $(this);
		if (form.id.value > 0) {
			var $img = $('<img/>', {
				src: '<?php echo fwfmURI::root(true); ?>/components/com_fwfoodmenu/assets/images/ajax-loader.gif',
				style: 'margin: 0 0 0 6px;'
			});
			$button.attr('disabled', true).after($img);
			$.ajax({
				url: <?php if (empty($params['url'])) { ?>form.action<?php } else { ?>'<?php echo $params['url']; ?>'<?php } ?>,
				type: 'post',
				dataType: 'json',
				data: {
					format: 'json',
					id: form.id.value,
					button_id: $button.data('id'),
					<?php if (!empty($params['view'])) { ?>view: '<?php echo $params['view']; ?>',<?php } ?>
					layout: '<?php echo $params['layout']; ?>'<?php if (!empty($params['add_request_params'])) echo $params['add_request_params']; ?>
				},
				success: <?php if (empty($params['callback'])) { ?>function(data) {
					$img.remove();
					$button.attr('disabled', false);

					if (data.result) {
						$('<?php echo $params['image']; ?>').parent().hide();
					}
					if (data.image) {
						$('<?php echo $params['image']; ?>').attr('src', data.image);
					}
					if (data.msg) {
						alert(data.msg);
					}
				}
<?php
				} else echo $params['callback'];
?>
			});
		}
	});
	})(jQuery);
});
</script>
<?php
		return ob_get_clean();
	}
}
