<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined('_FWFM_EXEC') or die('Restricted access');

if (!function_exists('com_install')) {
	function com_install() {
		com_fwfoodmenuInstallerScript :: update($adaptor = null);
	}
}

if (!class_exists('com_fwfoodmenuInstallerScript')) {
	class com_fwfoodmenuInstallerScript {
		function install($adaptor) {
			return $this->update($adaptor);
		}
		function update($adaptor) {
			$db = fwfmFactory :: getDBO();
			$tables = $db->getTableList();

			if (in_array($db->getPrefix().'fwfoodmenu_badge', $tables)) {
				$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_badge');
				$fields = $db->loadColumn();
				if (!in_array('lang', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_badge` ADD COLUMN `lang` CHAR(5)');
					$db->execute();
				}
			} else {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_badge` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`ordering` INT(10) UNSIGNED NOT NULL DEFAULT 0,
	`name` VARCHAR(50) NULL DEFAULT NULL,
	`icon` VARCHAR(50) NULL DEFAULT NULL,
	`color` VARCHAR(6) NULL DEFAULT NULL,
	`lang` CHAR(5) NOT NULL DEFAULT \'en-GB\',
	PRIMARY KEY (`id`),
	INDEX `ordering` (`ordering`)
)'
				);
				if ($db->execute()) {
					$db->setQuery("INSERT INTO `#__fwfoodmenu_badge` (name, icon, ordering) VALUES ('vegan', 'fas fa-seeding', 1), ('healthy food', 'fas fa-child', 2), ('organic', 'fas fa-pagelines', 3), ('farm fresh', 'far fa-tractor', 4), ('spicy', 'fas fa-papper-hot', 5), ('eco', 'fas fa-leaf', 6)");
					$db->execute();
					
				}
			}

			if (in_array($db->getPrefix().'fwfoodmenu_translations', $tables)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_translations` MODIFY `lang` CHAR(5) NOT NULL');
				$db->execute();
				$db->setQuery('SELECT DISTINCT `lang` FROM `#__fwfoodmenu_translations`');
				if ($buff = $db->loadColumn()) {
					$langs = array('en'=>'en-GB', 'ar'=>'ar-AA', 'de'=>'de-DE', 'el'=>'el-GR', 'es'=>'es-ES', 'fr'=>'fr-FR', 'it'=>'it-IT', 'pt'=>'pt-PT', 'ru'=>'ru-RU', 'tr'=>'tr-TR', 'uk'=>'uk-UA', 'zh'=>'zh-CN');
					foreach ($buff as $ln) {
						if (!empty($langs[$ln])) {
							$db->setQuery('UPDATE `#__fwfoodmenu_translations` SET `lang` = '.$db->quote($langs[$ln]).' WHERE `lang` = '.$db->quote($ln));
							$db->execute();
						}
					}
				}
			} else {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_translations` (
	`obj_id` INT(10) UNSIGNED NOT NULL,
	`key` VARCHAR(50) NOT NULL,
	`lang` CHAR(5) NOT NULL,
	`text` TEXT NULL,
	INDEX (`obj_id`),
	INDEX(`key`),
	INDEX(`lang`)
)'
				);
				$db->execute();
			}
			if (!in_array($db->getPrefix().'fwfoodmenu_menu_badge', $tables)) {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_menu_badge` (
	`menu_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`badge_id` INT(10) UNSIGNED NOT NULL DEFAULT 0,
	INDEX (`menu_id`),
	INDEX (`badge_id`)
)'
				);
				$db->execute();
			}
			if (in_array($db->getPrefix().'fwfoodmenu_menu_price', $tables)) {
				$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_menu_price');
				$fields = $db->loadColumn();
				if (!in_array('lang', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu_price` ADD COLUMN `lang` CHAR(5)');
					$db->execute();
				}
			} else {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_menu_price` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`menu_id` INT(10) UNSIGNED NULL DEFAULT NULL,
	`ordering` INT(10) UNSIGNED NOT NULL DEFAULT 0,
	`name` VARCHAR(50) NULL DEFAULT NULL,
	`size` VARCHAR(50) NULL DEFAULT NULL,
	`price` DECIMAL(10,2) NULL DEFAULT NULL,
	`special_price` DECIMAL(10,2) NULL DEFAULT NULL,
	`energy` VARCHAR(20) NULL DEFAULT NULL,
	`lang` CHAR(5) NOT NULL DEFAULT \'en-GB\',
	PRIMARY KEY (`id`),
	INDEX `name` (`name`),
	INDEX `ordering` (`ordering`),
	INDEX `menu_id` (`menu_id`)
)'
				);
				if ($db->execute()) {
					$db->setQuery('INSERT INTO `#__fwfoodmenu_menu_price` (menu_id, size, price, special_price, energy) SELECT id, weight, price, special_price, energy FROM `#__fwfoodmenu_menu`');
					$db->execute();
				}
			}
			if (!in_array($db->getPrefix().'fwfoodmenu_cart', $tables)) {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_cart` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`created` TIMESTAMP NOT NULL DEFAULT NOW(),
	`menu_price_id` INT(10) UNSIGNED NULL DEFAULT NULL,
	`session_id` VARCHAR(192) NULL,
	`qty` INT UNSIGNED NOT NULL DEFAULT 0,
	PRIMARY KEY (`id`),
	INDEX `menu_price_id` (`menu_price_id`),
	INDEX `session_id` (`session_id`)
)'
				);
				$db->execute();
			}
			if (in_array($db->getPrefix().'fwfoodmenu_order', $tables)) {
				$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_order');
				$fields = $db->loadColumn();

				if (!in_array('payment_gate_id', $fields)) {
					/* cash = 1, paypal - 2, stripe - 3 */
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `payment_gate_id` INT UNSIGNED NULL');
					$db->execute();
				}
				if (!in_array('delivery_option', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `delivery_option` VARCHAR(100) NULL');
					$db->execute();
				}
				if (!in_array('address', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `address` TEXT NULL');
					$db->execute();
				}
				if (!in_array('lang', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `lang` CHAR(5)');
					$db->execute();
				}
				if (!in_array('delivery', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `delivery` DECIMAL(12,2) NOT NULL DEFAULT 0');
					$db->execute();
				}
				if (!in_array('tax', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `tax` DECIMAL(12,2) NOT NULL DEFAULT 0');
					$db->execute();
				}
				if (!in_array('paid', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `paid` datetime NULL');
					$db->execute();
				}
				if (in_array('status', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` CHANGE COLUMN `status` `status` ENUM(\'pending\', \'paid\', \'prepared\', \'shipped\', \'delivered\', \'completed\', \'cancelled\', \'refunded\') NOT NULL DEFAULT \'pending\'');
					$db->execute();
				} else {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order` ADD COLUMN `status` ENUM(\'pending\', \'paid\', \'prepared\', \'shipped\', \'delivered\', \'completed\', \'cancelled\', \'refunded\') NOT NULL DEFAULT \'pending\'');
					$db->execute();
				}
			} else {
				$db->setQuery('CREATE TABLE `#__fwfoodmenu_order` (
					`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
					`created` datetime NOT NULL,
					`payment_gate_id` INT UNSIGNED NULL,
					`delivery_option` VARCHAR(100),
					`booked_on` datetime NOT NULL,
					`paid` datetime NULL,
					`status` ENUM(\'pending\', \'paid\', \'prepared\', \'shipped\', \'delivered\', \'completed\', \'cancelled\', \'refunded\') NOT NULL DEFAULT \'pending\',
					`amount` DECIMAL(12,2) NOT NULL,
					`delivery` DECIMAL(12,2) NOT NULL DEFAULT 0,
					`tax` DECIMAL(12,2) NOT NULL DEFAULT 0,
					`name` VARCHAR(100) NULL,
					`email` VARCHAR(200) NULL,
					`phone` VARCHAR(100) NULL,
					`address` TEXT NULL,
					`comments` TEXT NULL,
					`lang` CHAR(5) NOT NULL DEFAULT \'en-GB\',
					PRIMARY KEY (`id`),
					INDEX `created` (`created`),
					INDEX `booked_on` (`booked_on`))'
				);
				$db->execute();
			}
			if (in_array($db->getPrefix().'fwfoodmenu_order_items', $tables)) {
				$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_order_items');
				$fields = $db->loadColumn();
				if (!in_array('subname', $fields)) {
					$db->setQuery('ALTER TABLE `#__fwfoodmenu_order_items` ADD COLUMN subname VARCHAR(200) NULL');
					$db->execute();
				}
			} else {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_order_items` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`order_id` INT(10) UNSIGNED NOT NULL,
	`menu_price_id` INT(10) UNSIGNED NOT NULL,
	`name` VARCHAR(200) NOT NULL,
	`subname` VARCHAR(200) NULL,
	`qty` INT UNSIGNED NOT NULL DEFAULT 0,
	`price` decimal(12,2) not null,
	PRIMARY KEY (`id`),
	INDEX `order_id` (`order_id`)
)'
				);
				$db->execute();
			}

			$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_category');
			$fields = $db->loadColumn();

			if (!in_array('lang', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN `lang` CHAR(5)');
				$db->execute();
			}
			if (!in_array('image', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN image VARCHAR(200)');
				$db->execute();
			}
			if (!in_array('image_size', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN image_size INT UNSIGNED DEFAULT NULL');
				$db->execute();
			}
			if (!in_array('parent', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN parent int unsigned not null default 0, add index(parent)');
				$db->execute();
			}
			if (!in_array('params', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN params TEXT NULL');
				$db->execute();
			}
			if (!in_array('alias', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN alias VARCHAR(200) NULL');
				if ($db->execute()) {
					$db->setQuery('SELECT id, name FROM `#__fwfoodmenu_category`');
					if ($list = $db->loadObjectList()) {
						foreach ($list as $row) {
							if (!$row->name) continue;
							$db->setQuery('UPDATE `#__fwfoodmenu_category` SET alias = '.$db->quote(fwfmFilterOutput::stringURLSafe($row->name)).' WHERE id = '.(int)$row->id);
							$db->execute();
						}
					}
				}
			}
			if (!in_array('short_description', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN short_description varchar(250) null');
				$db->execute();
			}
			if (!in_array('pdf_menu', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN pdf_menu varchar(250) null');
				$db->execute();
			}

			if (!in_array('metadescr', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN metadescr varchar(250) null');
				$db->execute();
			}
			if (!in_array('metakey', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_category` ADD COLUMN metakey varchar(250) null');
				$db->execute();
			}

			$db->setQuery('SHOW FIELDS FROM #__fwfoodmenu_menu');
			$fields = $db->loadColumn();

			if (!in_array('lang', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu` ADD COLUMN `lang` CHAR(5)');
				$db->execute();
			}
			if (!in_array('params', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu` ADD COLUMN params TEXT NULL');
				$db->execute();
			}
			if (!in_array('is_new', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu` ADD COLUMN is_new tinyint unsigned default NULL');
				$db->execute();
			}
			if (!in_array('is_recommended', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu` ADD COLUMN is_recommended tinyint unsigned default NULL');
				$db->execute();
			}
			if (!in_array('image_size', $fields)) {
				$db->setQuery('ALTER TABLE `#__fwfoodmenu_menu` ADD COLUMN image_size int unsigned default NULL');
				$db->execute();
				$db->setQuery('SELECT id, `image` FROM `#__fwfoodmenu_menu` WHERE image IS NOT NULL');
				if ($list = $db->loadObjectList()) {
					$path = FWFM_PATH_SITE.'/media/com_fwfoodmenu/menu/';
					foreach ($list as $row) {
						if ($row->image and file_exists($path.$row->image)) {
							$db->setQuery('UPDATE `#__fwfoodmenu_menu` SET image_size = '.(int)filesize($path.$row->image).' WHERE id = '.(int)$row->id);
							$db->execute();
						}
					}
				}
			}
			if (!in_array($db->getPrefix().'fwfoodmenu_menu_image', $tables)) {
				$db->setQuery('
CREATE TABLE `#__fwfoodmenu_menu_image` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`menu_id` INT(10) UNSIGNED NULL DEFAULT NULL,
	`image` varchar(200) default NULL,
	`image_size` int unsigned default NULL,
	`ordering` INT(10) UNSIGNED NOT NULL DEFAULT 0,

	PRIMARY KEY (`id`),
	INDEX `menu_id` (`menu_id`),
	INDEX `ordering` (`ordering`)
)'
				);
				if ($db->execute()) {
					$db->setQuery('SELECT id, `image`, image_size FROM `#__fwfoodmenu_menu` WHERE image IS NOT NULL');
					if ($list = $db->loadObjectList()) {
						$path = FWFM_PATH_SITE.'/media/com_fwfoodmenu/menu/';
						foreach ($list as $row) {
							if ($row->image and file_exists($path.$row->image)) {
								$db->setQuery('INSERT INTO `#__fwfoodmenu_menu_image` SET ordering = 1, `image` = '.$db->quote($row->image).', image_size = '.(int)$row->image_size.', menu_id = '.(int)$row->id);
								$db->execute();
							}
						}
					}
				}
			}

			jimport('joomla.filesystem.file');
			$path = FWFM_PATH_SITE.'/components/com_fwfoodmenu/views/menu/tmpl/grid.xml';
			if (file_exists($path)) {
				fwfmFile::delete($path);
			}

			$db->setQuery('UPDATE `#__extensions` SET enabled = 1 WHERE manifest_cache LIKE \'%Fastw3b%\' AND (name LIKE \'%fwfm%\' OR name LIKE \'%food%\')');
			$db->execute();

			$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
			if ($params and $update_code = $params->get('verified_code')) {
				$db->setQuery('UPDATE `#__update_sites` SET extra_query = '.$db->quote('code='.urlencode(trim($update_code))).', last_check_timestamp = 0 WHERE name LIKE \'FW Food%\'');
				$db->execute();
			}

			return true;
		}
	}
}
