<?php
/**
 * FW Food Menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined('_FWFM_EXEC') or die('Restricted access');

fwfmHtml::_('bootstrap.popover', '[data-toggle="popover"]');
fwfmHtml::_('bootstrap.tooltip', '[data-toggle="tooltip"]');

$menus = array(
    'menu',
	'addon',
	'category',
    'items',
    'orders',
    'badges',
	'data',
    'css',
    'translation',
    'settings'
);
$icons = array(
    'menu' => 'fa-fw fal fa-tachometer-alt',
    'category' => 'fa-fw fal fa-folders',
    'items' => 'fa-fw fal fa-utensils',
    'orders' => 'fa-fw fal fa-shopping-basket',
    'addon' => 'fa-fw fal fa-puzzle-piece',
    'badges' => 'fa-fw fal fa-badge',
	'data' => 'fa-fw fal fa-database',
    'translation' => 'fa-fw fal fa-globe',
    'css' => 'fa-fw fal fa-file-code',
    'settings' => 'fa-fw fal fa-sliders-h'
);
$titles = array(
    'menu' => 'DASHBOARD',
    'addon' => 'ADDONS',
    'category' => 'CATEGORIES',
    'items' => 'MEALS',
    'orders' => 'ORDERS',
    'badges' => 'BADGES',
	'data' => 'DATA',
    'css' => 'CSS',
    'translation' => 'LANG',
    'settings' => 'SETTINGS',
);

$view = $displayData['view'];

$update_code = $view->params->get('update_code');
$verified_code = $view->params->get('verified_code');
$user_name = $view->params->get('user_name');
$user_avatar = $view->params->get('user_avatar');
$user_email = $view->params->get('user_email');

$account_verified = ($update_code and $update_code == $verified_code);
?>
<!-- Temp common menu layout start -->
<div id="fw-admin" class="container-fluid fwcss fw-admin">
    <div class="d-flex">
        <div id="fwaSidebarWrapper" class="fwa-sidebar-wrapper<?php if ($view->app->input->cookie->get('fwfm_hide_left_sidebar')) { ?> collapsed<?php } ?>">
            <div class="fwa-sidebar">
                <a id="toggleSidebarMenu" class="fwa-sidebar-toggle">
                    <i id="toggleSidebarIcon" class="far <?php if ($view->app->input->cookie->get('fwfm_hide_left_sidebar')) { ?>fa-bars<?php } else { ?>fa-arrow-left<?php } ?> px-2 mr-2"></i>
                    <?php echo fwfmText::_('COM_FWFOODMENU'); ?>
                    <img src="<?php echo FWFM_ADMIN_ASSETS_URI; ?>images/icon_fw_food_menu_200.png" />
                </a>
                <div class="fwa-account">
                    <button class="btn fwa-user-no-login" data-toggle="modal" data-target="#fwfm-login-register"<?php if ($account_verified) { ?> style="display:none" <?php } ?>>
                        <i class="fal fa-user-lock"></i>
                        <span><?php echo fwfmText::_('FWFM_VERIFY_ACCOUNT'); ?></span>
                        <div><?php echo fwfmText::_('FWFM_VERIFY_ACCOUNT_HINT'); ?></div>
                    </button>
                    <div class="d-flex fwa-account-user fwa-user-logged-in"<?php if (!$account_verified) { ?> style="display:none!important;"<?php } ?>>
                        <div class="fwa-account-photo">
                            <a href="#fwfm-logout" data-toggle="modal" title="<?php echo esc_attr($user_name); ?>">
                                <img src="<?php echo esc_attr($user_avatar); ?>"> 
                            </a>
                        </div>
                        <div class="fwa-account-user-info">
                            <div class="fwa-account-user-info-name">
                                <a href="#fwfm-logout" data-toggle="modal" title="<?php echo esc_attr($user_name); ?>">
                                    <?php echo fwfmFilterOutput::cleanText($user_name); ?>
                                </a>
                            </div>
                            <div class="fwa-account-user-info-verified"><?php echo fwfmText::_('FWFM_VERIFIED_ACCOUNT_HINT'); ?></div>
                        </div>
                    </div>
                </div>
                <div id="fwaSidebarRightBtn" class="fwa-sidebar-right-btn">
                    <i class="fal fa-magic">
                        <span class="badge"></span>
                    </i>
                    <?php echo fwfmText::_('FWFM_PRODUCT_WIZARD'); ?>
                </div>

                <ul class="fwa-sidebar-menu">
<?php
foreach ($menus as $menu) {
	$name = fwfmText::_('FWFM_DOC_ADMIN_'.(empty($titles[$menu])?$menu:$titles[$menu]));
    echo fwfmHtml::_('fwView.menuItem', array(
        'active' => ($menu == $view->menu),
        'link' => 'index.php?option=com_fwfoodmenu&view='.$menu,
        'icon_class' => $icons[$menu],
        'name' => $name,
        'menu' => $menu
    ));
}
?>
                </ul>
            </div>
        </div>
        <div class="fwa-main">
            <div class="d-flex fwa-main-header">
                <div class="fwa-main-header-text">
                    <h2><i class="<?php echo esc_attr($icons[$view->menu]); ?> mr-2"></i> <?php echo esc_html($displayData['title']); ?></h2>
                </div>
<?php
$buttons = fwfmButtons::getInstance()->getButtons();
if ($buttons) {
?>
                <div class="fwa-toolbar-wrapper">
                    <div class="fwa-toolbar">
<?php
	foreach ($buttons as $button) {
		$onclick = '';
		if ($button->listSelect) {
			if (is_string($button->listSelect)) {
				$onclick = "if (document.adminForm.boxchecked.value == 0) { fwfm_alert('".fwfmText::_('JLIB_HTML_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST', true)."'); } else { if (confirm('".fwfmText::_($button->listSelect, true)."')) { Joomla.submitbutton('".$button->task."'); } }";
			} else {
				$onclick = "if (document.adminForm.boxchecked.value == 0) { fwfm_alert('".fwfmText::_('JLIB_HTML_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST', true)."'); } else { Joomla.submitbutton('".$button->task."'); }";
			}
		} else {
			$onclick = "Joomla.submitbutton('".esc_js($button->task)."');";
		}
?>
						<button type="button"<?php if ($button->task == 'add') { ?> id="fwfm-add-button"<?php } ?> class="btn<?php if (!empty($button->color)) { ?> btn-<?php echo esc_attr($button->color); } ?>" onclick="<?php echo esc_attr($onclick); ?>" role="button">
							<i class="<?php echo esc_attr($button->icon); ?>"></i>
							<span><?php echo esc_html($button->alt); ?></span>
						</button>
<?php
	}
?>
                    </div>
                </div>
<?php
}
?>
            </div>
            <div class="fwa-main-body">
