<?php
/**
 * FW Food Menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined('_FWFM_EXEC') or die('Restricted access');

$view = $displayData['view'];
?>
<div id="fwfm-quick-categories" class="modal fade" data-animation="false">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">
			<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK'); ?>
			<div class="modal-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_HINT'); ?></div>
		</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
	    <div class="mb-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo esc_attr(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_CATEGORY_HINT')); ?>">
			<?php echo fwfmHtml::_('fwfCategory.parent', (object)array('category'=>empty($view->category)?0:$view->category), 'category', 'class="form-control form-control-sm advancedSelect"', 'FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_CATEGORY'); ?>
		</div>
        <div><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_TEXT'); ?></div>
		<textarea name="quick_categories" class="form-control" placeholder="<?php echo esc_attr(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_TEXT_HINT')); ?>"></textarea>
	  </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-outline-secondary" data-dismiss="modal"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_BTN_CLOSE'); ?></button>
        <button type="button" class="btn btn-success"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_QUICK_BTN_PROCESS'); ?></button>
      </div>
    </div>
  </div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('#fwfm-quick-categories').on('show', function() {
		$(this).addClass('show');
		$(this).find('textarea').val('');
	}).on('hide', function() {
		$(this).removeClass('show');
	});
	$('#fwfm-quick-categories button.btn-success').click(function() {
		var $popup = $('#fwfm-quick-categories');

		var $text = $popup.find('textarea');
		var buff = $text.val().split('\n');
		var qty = 0;
		for (var i = 0; i < buff.length; i++) {
			buff[i] = buff[i].trim();
			if (buff[i].length) {
				qty++;
			}
		}
		if (qty == 0) {
			alert('<?php echo fwfmText::_('FWFM_NOTHING_TO_PROCESS', true); ?>');
			return;
		}

		var $btn = $(this).attr('disabled', true);
		var $wait = $('<div class="fwfm-quick-progress"><i class="fas fa-sync fa-spin"></i> '+qty+' <?php echo fwfmText::_('FWFM_CATEGORY_ROWS_PROCESSING', true); ?></div>');
		$btn.parent().prepend($wait);

		$.ajax({
			type: 'post',
			dataType: 'json',
			data: {
				format: 'json',
				task: '',
				view: 'category',
				layout: 'quick_categories',
				category: $popup.find('select[name="category"]').val(),
				text: $text.val()
			}
		}).done(function(data) {
			$btn.attr('disabled', false);
			$wait.remove();
			if (data.msg) {
				alert(data.msg);
			}
			if (data.result) {
				location=location.toString().replace('#.*$', '')+'<?php if (!empty($view->extra_link)) echo str_replace('&amp;', '&', $view->extra_link); ?>';
			}
		});
	});
	})(jQuery);
});
</script>
