<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

class MenuModelMenu extends fwfmModelLegacy {
	function localStat() {
		$db = fwfmFactory::getDBO();
		$query = '
SELECT
	(SELECT COUNT(*) FROM `#__fwfoodmenu_category`) AS ct,
	(SELECT COUNT(*) FROM `#__fwfoodmenu_category` WHERE published = 1) AS cp,
	(SELECT COUNT(*) FROM `#__fwfoodmenu_menu`) AS mt,
	(SELECT COUNT(*) FROM `#__fwfoodmenu_menu` WHERE published = 1) AS mp,
	'.(class_exists('JVersion')?'(SELECT COUNT(*) FROM #__menu WHERE `client_id` = 0 AND `link` LIKE \'%com_fwfoodmenu%\')':'1').' AS menus_qty,
	(SELECT SUM(`image_size`) FROM `#__fwfoodmenu_menu` WHERE `image_size` IS NOT NULL) AS `is`';

		$db->setQuery($query);
		$data = $db->loadObject();

		$size = 0;
		foreach ($data as $key=>$val) {
			/* sum up all sizes */
			if ($key[strlen($key) - 1] == 's') {
				$size += $val;
				unset($data->$key);
			}
		}
		$data->fs = $size;

		return $data;
	}
	function quickCheck() {
		$data = new stdclass;
		jimport('joomla.filesystem.file');
		$path = FWFM_PATH_SITE.'/media/';
		if (!file_exists($path)) {
			fwfmFile::write($path.'index.html', $html='<html><body></body></html>');
		}
		$data->media_folder_exists = file_exists($path);
		$path .= 'com_fwfoodmenu/';
		if (!file_exists($path)) {
			fwfmFile::write($path.'index.html', $html='<html><body></body></html>');
		}
		$data->gallery_folder_exists = file_exists($path);
		$data->gallery_folder_writeable = is_writable($path);
		$data->gd_installed = function_exists('gd_info');
		$data->exif_installed = function_exists('exif_read_data');
		$data->version = $this->getVersion();

		$data->test_passed = true;
		foreach ($data as $key=>$val) {
			if (!$val) {
				$data->test_passed = false;
				break;
			}
		}

		return $data;
	}
	function loadParamsObj() {
		return (object)array(
			'params' => fwfmComponentHelper::getParams('com_fwfoodmenu')
		);
	}
    function save() {
    	$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$input = fwfmFactory::getApplication()->input;
		$data = (array)$input->getVar('config');

    	$fields = array(
			'display_descr_gallery',
		);
		foreach ($fields as $field) $data[$field] = $input->getVar($field);

	   	$params->loadArray($data);

		return $this->store($params);
	}
	function store($params) {
		$cache = fwfmFactory::getCache('_system', 'callback');
    	$cache->clean();

    	$db = fwfmFactory::getDBO();
		$db->setQuery('UPDATE `#__update_sites` SET extra_query = '.$db->quote('code='.urlencode(trim($params->get('update_code')))).' WHERE name LIKE \'FW Food%\'');
		$db->execute();
		$db->setQuery('TRUNCATE TABLE #__updates');
		$db->execute();
		$db->setQuery('UPDATE `#__update_sites` SET last_check_timestamp = 0');
		$db->execute();

    	$db->setQuery('UPDATE `#__extensions` SET params = '.$db->quote($params->toString()).' WHERE `element` = \'com_fwfoodmenu\' AND `type` = \'component\'');
    	return $db->execute();
	}
	function getDescription() {
		$buff = file_get_contents(FWFM_PATH_COMPONENT_ADMINISTRATOR.'/fwfoodmenu.xml');
		if (preg_match('#<description><\!\[CDATA\[(.*?)\]\]></description>#msi', $buff, $match)) {
			return $match[1];
		}
	}
	function getVersion() {
		$buff = file_get_contents(FWFM_PATH_COMPONENT_ADMINISTRATOR.'/fwfoodmenu.xml');
		if (preg_match('#<version>(.*?)</version>#msi', $buff, $match)) {
			return $match[1];
		}
	}
	function checkUpdate() {
		$data = new stdclass;
		$data->loc_version = $this->getVersion();
		$data->need_update = false;
		if ($buff = fwFoodMenuHelper::request(FWA_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=package&format=raw&package='.FWA_UPDATE_NAME.'&dummy=extension.xml')) {
			if (preg_match('#<extension.*version="([^"]*)"#', $buff, $match)) {
				$data->rem_version = $match[1];

				if ($data->loc_version != 'x.x.x') {
					$rem_buff = explode('.', $data->rem_version);
					$loc_buff = explode('.', $data->loc_version);
					if (count($rem_buff) == 3 and count($loc_buff) == 3 and ($rem_buff[0] > $loc_buff[0] or ($rem_buff[0] == $loc_buff[0] and $rem_buff[1] > $loc_buff[1]) or ($rem_buff[0] == $loc_buff[0] and $rem_buff[1] == $loc_buff[1] and $rem_buff[2] > $loc_buff[2]))) {
						$data->need_update = true;
					}
				}
			}
		} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));

		return $data;
	}
	function verifyCode() {
		$result = new stdclass;
		$input = fwfmFactory::getApplication()->input;
		if ($code = $input->getString('code')) {
			$db = fwfmFactory::getDBO();
			$j_version = $langs_qty = '';
			if (class_exists('JVersion')) {
				$jv = new JVersion();
				$j_version = $jv->getShortVersion();
			} else {
				global $wp_version;
			}

			$lang = fwfmFactory::getLanguage();
			$langs = fwfmLanguageHelper::getKnownLanguages();

			$db->setQuery('SELECT COUNT(*) FROM `#__fwfoodmenu_category` AS c WHERE EXISTS(SELECT * FROM `#__fwfoodmenu_menu` AS p WHERE p.published=1 AND p.category_id = c.id)');
			$categories_qty = $db->loadResult();
			$db->setQuery('SELECT COUNT(*) FROM `#__fwfoodmenu_menu` WHERE published=1');
			$menu_qty = $db->loadResult();

			$data = (object)array(
				'code' => $code,
				'package' => FWA_UPDATE_NAME,
				'host' => fwfmURI::root(false),
				'params' => array(
					'joomla_version' => $j_version,
					'wp_version' => empty($wp_version)?'':$wp_version,
					'version' => $this->getVersion(),
					'language' => $lang->getTag(),
					'langs_qty' => count($langs),
					'categories_qty' => $categories_qty,
					'menu_qty' => $menu_qty,
					'exts' => array()
				)
			);
			$db->setQuery('
SELECT
	`name`,
	`element`,
	`type`,
	`type` AS subtype,
	`folder`,
	`enabled`
FROM
	#__extensions
WHERE
	manifest_cache LIKE \'%Fastw3b%\'
	AND
	NOT `type` IN (\'package\', \'template\')
ORDER BY
	`type`,
	`folder`,
	`name`'
			);
			if ($list = $db->loadObjectList()) {
				foreach ($list as $i=>$row) {
					$filename = "";
					if ($row->type == "component") {
						$filename = FWFM_PATH_ADMINISTRATOR."/components/".$row->element."/".str_replace("com_", "", $row->element).".xml";
					} elseif ($row->type == "plugin") {
						$filename = FWFM_PATH_SITE."/plugins/".$row->folder."/".$row->element."/".$row->element.".xml";
					} elseif ($row->type == "module") {
						$filename = FWFM_PATH_SITE."/modules/".$row->element."/".$row->element.".xml";
					}
					if ($filename and file_exists($filename)) {
						$buff = file_get_contents($filename);
						if (preg_match("#<version>(.*?)</version>#msi", $buff, $match)) {
							$list[$i]->loc_version = $match[1];
						}
					}
				}
				$data->params["exts"] = $list;
			}
			if ($buff = fwFoodMenuHelper::request(FWA_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=verify_code&format=raw', 'post', $data)) {
				$tmp = json_decode($buff);
				if ($tmp) {
					if (!empty($tmp->msg)) $this->setError($tmp->msg);
					$result->user_name = empty($tmp->user_name)?'':$tmp->user_name;
					$result->user_avatar = empty($tmp->user_avatar)?'':$tmp->user_avatar;
					$result->user_email = empty($tmp->user_email)?'':$tmp->user_email;
					if (!empty($tmp->verified)) {
						$result->verified = 1;
						$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
						$params->set('update_code', $code);
						$params->set('verified_code', $code);
						$params->set('user_name', $result->user_name);
						$params->set('user_avatar', $result->user_avatar);
						$params->set('user_email', $result->user_email);
						$this->store($params);
					}
				} elseif (preg_match('#<title>([^<]+)<#msi', $buff, $match)) {
					$this->setError($match[1]);
				}
			} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
		}  else $this->setError(fwfmText::_('FWFM_NO_CODE_TO_VERIFY'));
		return $result;
	}
	function getChangelog() {
		if ($buff = fwFoodMenuHelper::request(FWA_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=changelog&format=raw&package='.FWA_UPDATE_NAME)) {
			$tmp = json_decode($buff);
			if (!empty($tmp->msg)) $this->setError($tmp->msg);
			if ($tmp->result) {
				return $tmp->result;
			}
		}
	}
	function revokeCode() {
		$data = new stdclass;
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$params->set('verified_code', '');
		$params->set('update_code', '');
		$data->result = $this->store($params);
		return $data;
	}
	function updatePackage() {
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$code = $params->get('update_code');
		$result = false;
		if ($code) {
			if ($code == $params->get('verified_code')) {
				if ($buff = fwFoodMenuHelper::request(FWA_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=package&format=raw&package='.FWA_UPDATE_NAME.'&dummy=extension.xml')) {
					if (preg_match('#detailsurl="([^"]*)"#', $buff, $match)) {
						$url = str_replace('&amp;', '&', $match[1]);
						if ($buff = fwFoodMenuHelper::request($url)) {
							if (preg_match('#<downloadurl[^>]*>([^<]+)</downloadurl>#', $buff, $match)) {
								$url = str_replace('&amp;', '&', $match[1]).'&code='.urlencode($code);
								if ($buff = fwFoodMenuHelper::request($url)) {
									jimport('joomla.filesystem.file');
									jimport('joomla.filesystem.folder');
									$path = FWFM_PATH_SITE.'/tmp/';

									$filename = '';
									do {
										$filename = 'inst'.rand().'.zip';
									} while (file_exists($path.$filename));

									if (fwfmFile::write($path.$filename, $buff)) {
										$package = fwfmInstallerHelper::unpack($path.$filename, true);
										if (!empty($package['dir'])) {
											$installer = fwfmInstaller::getInstance();
											if ($result = $installer->install($package['dir'])) {
												$this->setError(fwfmText::_('FWFM_UPDATED_SUCCESFULLY'));
											} else {
												$this->setError(fwfmText::_('FWFM_NOT_UPDATED'));
											}
										}
										if (file_exists($path.$filename)) fwfmFile::delete($path.$filename);
										if (file_exists($package['dir'])) fwfmFolder::delete($package['dir']);
									} else $this->setError(fwfmText::_('FWFM_CANT_WRITE_FILE'));
								} else $this->setError(fwfmText::_('FWFM_SERVER_REFUSES_DOWNLOAD'));
							} else $this->setError(fwfmText::_('FWFM_WRONG_RESPONSE_FORMAT_FROM_REMOTE_SERVER'));
						} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
					} else $this->setError(fwfmText::_('FWFM_WRONG_RESPONSE_FORMAT_FROM_REMOTE_SERVER'));
				} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
			} else $this->setError(fwfmText::_('FWFM_CODE_NOT_VERIFIED'));
		} else $this->setError(fwfmText::_('FWFM_NO_UPDATE_CODE'));
		return $result;
	}
	function getAddons() {
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		if ($code = $params->get('verified_code')) {
			fwfmFactory::getApplication()->input->set('code', $code);
			$this->verifyCode();
		}
		$model = fwfmModelLegacy::getInstance('addon', 'menuModel');
		return $model->getPluginsData();
	}
	function checkNotInstalled($list) {
		$model = fwfmModelLegacy::getInstance('addon', 'menuModel');
		return $model->checkNotInstalled($list);
	}
	function checkNotUpdated($list) {
		$model = fwfmModelLegacy::getInstance('addon', 'menuModel');
		return $model->checkNotUpdated($list);
	}
	function loadWizards() {
		$data = array(
			'wizards'=>array(),
			'install'=>array(),
			'update'=>array()
		);
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$update_code = $params->get('update_code');
		$input = fwfmFactory::getApplication()->input;
		if (!$update_code) {
			$dismissed = $input->cookie->get('fwfm_dismissed_1');
			$data['wizards'][] = (object)array(
				'ordering'=>1+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_VERIFY'),
				'title'=>fwfmText::_('FWFM_WIZARD_VERIFY_TITLE'),
				'icon'=>'fal fa-user-lock',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(1);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<button type="button" class="btn btn-action" onclick="jQuery(\'.fwa-user-no-login\').click()">'.fwfmText::_('FWFM_VERIFY_ACCOUNT').'</button>'
			);
		}
		$quickcheck = $this->quickCheck($check_orphans=false);
		if (!$quickcheck->test_passed) {
			$dismissed = $input->cookie->get('fwfm_dismissed_2');
			$data['wizards'][] = (object)array(
				'ordering'=>2+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_QUICKCHECK'),
				'title'=>fwfmText::_('FWFM_WIZARD_QUICKCHECK_TITLE'),
				'icon'=>'fal fa-tasks',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(2);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<a class="btn btn-action" href="index.php?option=com_fwfoodmenu&view=menu#quick-check">'.fwfmText::_('FWFM_QUICK_CHECK').'</a>'
			);
		}
		$stat = $this->localStat();
		if (empty($stat->ct)) {
			$dismissed = $input->cookie->get('fwfm_dismissed_3');
			$data['wizards'][] = (object)array(
				'ordering'=>3+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_CATEGORIES'),
				'title'=>fwfmText::_('FWFM_WIZARD_CATEGORIES_TITLE'),
				'icon'=>'fal fa-folders',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(3);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<button type="button" class="btn btn-action" onclick="jQuery(\'#fwfm-quick-categories\').modal(\'show\');">'.fwfmText::_('FWFM_QUICK_CATEGORIES').'</button>'
			);
		}
		if (empty($stat->mt)) {
			$dismissed = $input->cookie->get('fwfm_dismissed_4');
			$data['wizards'][] = (object)array(
				'ordering'=>4+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_FILES'),
				'title'=>fwfmText::_('FWFM_WIZARD_FILES_TITLE'),
				'icon'=>'fal fa-utensils',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(4);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<button type="button" class="btn btn-action" onclick="jQuery(\'#fwfm-quick-meals\').modal(\'show\');">'.fwfmText::_('FWFM_QUICK_MEALS').'</button>'
			);
		}
		if (empty($stat->menus_qty)) {
			$dismissed = $input->cookie->get('fwfm_dismissed_5');
			$data['wizards'][] = (object)array(
				'ordering'=>5+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_MENU'),
				'title'=>fwfmText::_('FWFM_WIZARD_MENU_TITLE'),
				'icon'=>'fal fa-desktop',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(5);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<a class="btn btn-action" href="index.php?option=com_menus&view=item&client_id=0&layout=edit">'.fwfmText::_('FWFM_CREATE_MENU').'</a>'
			);
		}
		if ($update_code) {
			$addons = $this->getAddons(false);
			if ($addons) {
				foreach ($addons as $row) {
					if ($row->loc_version and $row->rem_version and $row->loc_version != 'x.x.x' and $row->loc_version != $row->rem_version) {
						$data['update'][] = (object)array('name'=>$row->name, 'update_name'=>$row->update_name);
					}
					if (empty($row->installed) and !empty($row->installable)) {
						$data['install'][] = (object)array('name'=>$row->name, 'update_name'=>$row->update_name);
					}
				}
			}
			$has_current_subscr = false;
			if ($subscr = json_decode($params->get('subscr_data')) and is_array($subscr)) {
				$now = time();
				foreach ($subscr as $row) {
					if ($row->time_end > $now) {
						$has_current_subscr = true;
						break;
					}
				}
			}
			if (!$has_current_subscr) {
				$dismissed = $input->cookie->get('fwfm_dismissed_6');
				$data['wizards'][] = (object)array(
					'ordering'=>6+($dismissed?10:0),
					'active'=>$dismissed?0:1,
					'text'=>fwfmText::_('FWFM_WIZARD_ADDONS'),
					'title'=>fwfmText::_('FWFM_WIZARD_ADDONS_TITLE'),
					'icon'=>'fal fa-puzzle-piece',
					'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(6);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<a class="btn btn-action" href="https://fastw3b.net/products/fw-gallery#deals" target="_blank">'.fwfmText::_('FWFM_CHOOSE').'</a>'
				);
    		}
			$dismissed = $input->cookie->get('fwfm_dismissed_7');
			$data['wizards'][] = (object)array(
				'ordering'=>7+($dismissed?10:0),
				'active'=>$dismissed?0:1,
				'text'=>fwfmText::_('FWFM_WIZARD_CUSTOM'),
				'title'=>fwfmText::_('FWFM_WIZARD_CUSTOM_TITLE'),
				'icon'=>'fal fa-code',
				'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(7);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<a class="btn btn-action" href="https://fastw3b.net/services/hire-joomla-developer" target="_blank">'.fwfmText::_('FWFM_ORDER').'</a>'
			);
			if ($data['update']) {
				$dismissed = $input->cookie->get('fwfm_dismissed_8');
				$data['wizards'][] = (object)array(
					'ordering'=>8+($dismissed?10:0),
					'active'=>$dismissed?0:1,
					'text'=>fwfmText::_('FWFM_WIZARD_UPDATE'),
					'title'=>fwfmText::_('FWFM_WIZARD_UPDATE_TITLE'),
					'icon'=>'fal fa-sync',
					'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(8);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<button type="button" class="btn btn-action" onclick="jQuery(\'#fwfm-update\').modal(\'show\');">'.fwfmText::_('FWFM_UPDATE').'</button>'
				);
			}
			if ($data['install']) {
				$dismissed = $input->cookie->get('fwfm_dismissed_9');
				$data['wizards'][] = (object)array(
					'ordering'=>9+($dismissed?10:0),
					'active'=>$dismissed?0:1,
					'text'=>fwfmText::_('FWFM_WIZARD_INSTALL'),
					'title'=>fwfmText::_('FWFM_WIZARD_INSTALL_TITLE'),
					'icon'=>'fal fa-download',
					'buttons'=>($dismissed?'':'<button type="button" class="btn btn-secondary" onclick="fwfm_dismiss_wizard(9);">'.fwfmText::_('FWFM_DISMISS').'</button>').'<button type="button" class="btn btn-action" onclick="jQuery(\'#fwfm-install\').modal(\'show\');">'.fwfmText::_('FWFM_INSTALL').'</button>'
				);
		    }
		}
		fwfmArrayHelper::sortObjects($data['wizards'], 'ordering');
		return $data;
	}
}
