<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

class MenuModelSettings extends fwfmModelLegacy {
	function uploadPDF() {
		$input = fwfmFactory::getApplication()->input;
		if ($file = $input->files->get('pdf_file') and empty($file['error']) and !empty($file['name'])) {
			$file['name'] = fwfmFile::makeSafe($file['name']);
			$path = FWFM_PATH_SITE.'/media/com_fwfoodmenu/';
			jimport('joomla.filesystem.file');
			if (fwfmFile::copy($file['tmp_name'], $path.$file['name'])) {
				$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
				if ($pdf = $params->get('pdf_file') and $pdf != $file['name'] and file_exists($path.$pdf)) {
					fwfmFile::delete($path.$pdf);
				}
				$params->set('pdf_file', $file['name']);
				if (fwFoodMenuHelper::storeConfig($params)) {
					return $file['name'];
				}
			}
		}
	}
	function deletePDF() {
		jimport('joomla.filesystem.file');
		$path = FWFM_PATH_SITE.'/media/com_fwfoodmenu/';
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		if ($pdf = $params->get('pdf_file') and file_exists($path.$pdf)) {
			fwfmFile::delete($path.$pdf);
			$params->set('pdf_file', '');
			if (fwFoodMenuHelper::storeConfig($params)) {
				return true;
			}
		}
	}
	function loadObject() {
		return (object)array(
			'params' => fwfmComponentHelper::getParams('com_fwfoodmenu')
		);
	}
    function save() {
    	$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$input = fwfmFactory::getApplication()->input;
		$data = (array)$input->getRaw('config');

    	$fields = array(
			'display_descr_gallery',
		);
		foreach ($fields as $field) $data[$field] = $input->getVar($field);

	   	$params->loadArray($data);

		fwfmFactory::getApplication()->triggerEvent('onAfterConfigDataBinding', array('com_fwfoodmenu', &$params, $data));

		if (fwFoodMenuHelper::storeConfig($params)) {
			fwFoodMenuHelper::addMessage(fwfmText::_('FWFM_SETTINGS_SUCCESFULLY_STORED'), 'success');
			return true;
		} else {
			fwFoodMenuHelper::addMessage(fwfmText::_('FWFM_SETTINGS_NOT_STORED'), 'warning');
		}
	}
	function getDescription() {
		$buff = file_get_contents(FWFM_PATH_COMPONENT_ADMINISTRATOR.'/fwfoodmenu.xml');
		if (preg_match('#<description><\!\[CDATA\[(.*?)\]\]></description>#msi', $buff, $match)) {
			return $match[1];
		}
	}
	function getVersion() {
		$buff = file_get_contents(FWFM_PATH_COMPONENT_ADMINISTRATOR.'/fwfoodmenu.xml');
		if (preg_match('#<version>(.*?)</version>#msi', $buff, $match)) {
			return $match[1];
		}
	}
	function checkUpdate() {
		$data = new stdclass;
		$data->loc_version = $this->getVersion();
		if ($buff = fwFoodMenuHelper::request('http://fastw3b.net/index.php?option=com_fwsales&view=updates&layout=package&format=raw&package=FW+Food+Menu&dummy=extension.xml')) {
			if (preg_match('#<extension.*version="([^"]*)"#', $buff, $match)) {
				$data->rem_version = $match[1];
			}
		} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));

		return $data;
	}
	function verifyCode() {
		$data = new stdclass;
		$input = fwfmFactory::getApplication()->input;
		if ($code = $input->getString('code')) {
			if ($buff = fwFoodMenuHelper::request('http://fastw3b.net/index.php?option=com_fwsales&view=updates&layout=verify_code&format=raw&package=FW+Food+Menu&code='.urlencode($code).'&host='.urlencode(fwfmURI::root(false)))) {
				$tmp = json_decode($buff);
				if ($tmp) {
					if (!empty($tmp->msg)) $this->setError($tmp->msg);
					if (!empty($tmp->user_name)) $data->user_name = $tmp->user_name;
					if (!empty($tmp->membership)) $data->membership = fwfmText::_('FWFM_'.$tmp->membership);
					if (!empty($tmp->status)) $data->status = fwfmText::_('FWFM_'.$tmp->status);
					if (!empty($tmp->expires)) $data->expires = fwfmHtml::date($tmp->expires);
					if (isset($tmp->expired)) $data->expired = $tmp->expired;
					if (!empty($tmp->suggestion_link)) $data->suggestion_link = $tmp->suggestion_link;
					if (!empty($tmp->bug_link)) $data->bug_link = $tmp->bug_link;
					if (!empty($tmp->is_version)) $data->is_version = $tmp->is_version;
					if (!empty($tmp->discount)) $data->discount = $tmp->discount;
					if (!empty($tmp->version)) {
						$data->rem_version = $tmp->version;
						$data->loc_version = $this->getVersion();
					}
					if (!empty($tmp->purchased_version)) {
						$data->purchased_version = $tmp->purchased_version;
						$buff = explode('.', $tmp->purchased_version);
						if (count($buff) > 1) {
							$buff[1]++;
							$data->next_version = $buff[0].'.'.$buff[1].'.0';
						}
					}
					if (!empty($tmp->verified)) {
						$data->verified = 1;
						$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
						$params->set('update_code', $code);
						$params->set('verified_code', $code);
						fwFoodMenuHelper::storeConfig($params);
					}
				}
			} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
		} else $this->setError(fwfmText::_('FWFM_NO_CODE_TO_VERIFY'));
		return $data;
	}
	function revokeCode() {
		$data = new stdclass;
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$params->set('verified_code', '');
		$data->result = fwFoodMenuHelper::storeConfig($params);
		return $data;
	}
	function updatePackage() {
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$code = $params->get('update_code');
		$result = false;
		if ($code) {
			if ($code == $params->get('verified_code')) {
				if ($buff = fwFoodMenuHelper::request('http://fastw3b.net/index.php?option=com_fwsales&view=updates&layout=package&format=raw&package=FW+Food+Menu&dummy=extension.xml')) {
					if (preg_match('#detailsurl="([^"]*)"#', $buff, $match)) {
						$url = str_replace('&amp;', '&', $match[1]);
						if ($buff = fwFoodMenuHelper::request($url)) {
							if (preg_match('#<downloadurl[^>]*>([^<]+)</downloadurl>#', $buff, $match)) {
								$url = str_replace('&amp;', '&', $match[1]).'&code='.urlencode($code);
								if ($buff = fwFoodMenuHelper::request($url)) {
									jimport('joomla.filesystem.file');
									jimport('joomla.filesystem.folder');
									$path = FWFM_PATH_SITE.'/tmp/';

									$filename = '';
									do {
										$filename = 'inst'.rand().'.zip';
									} while (file_exists($path.$filename));

									if (fwfmFile::write($path.$filename, $buff)) {
										$package = fwfmInstallerHelper::unpack($path.$filename, true);
										if (!empty($package['dir'])) {
											$installer = fwfmInstaller::getInstance();
											if ($result = $installer->install($package['dir'])) {
												$this->setError(fwfmText::_('FWFM_UPDATED_SUCCESFULLY'));
											} else {
												$this->setError(fwfmText::_('FWFM_NOT_UPDATED'));
											}
										}
										if (file_exists($path.$filename)) fwfmFile::delete($path.$filename);
										if (file_exists($package['dir'])) fwfmFolder::delete($package['dir']);
									} else $this->setError(fwfmText::_('FWFM_CANT_WRITE_FILE'));
								} else $this->setError(fwfmText::_('FWFM_SERVER_REFUSES_DOWNLOAD'));
							} else $this->setError(fwfmText::_('FWFM_WRONG_RESPONSE_FORMAT_FROM_REMOTE_SERVER'));
						} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
					} else $this->setError(fwfmText::_('FWFM_WRONG_RESPONSE_FORMAT_FROM_REMOTE_SERVER'));
				} else $this->setError(fwfmText::_('FWFM_NO_RESPONSE_FROM_REMOTE_SERVER'));
			} else $this->setError(fwfmText::_('FWFM_CODE_NOT_VERIFIED'));
		} else $this->setError(fwfmText::_('FWFM_NO_UPDATE_CODE'));
		return $result;
	}
}
