<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

class TableOrder extends fwfmTable {
    var $id = null,
		$created = null,
        $booked_on = null,
    	$name = null,
    	$email = null,
    	$phone = null,
    	$comments = null,
    	$amount = null,
        $tax = null,
        $delivery = null,
        $address = null,
        $payment_gate_id = null,
        $paid = null,
        $status = null,
        $delivery_option = null,
        $lang = null;

    var $_items_qty = 0,
        $_items = array();

    function __construct(&$db) {
        parent::__construct('#__fwfoodmenu_order', 'id', $db);
    }

	function load($oid = null, $reset = null) {
		if ($oid) {
            $db = fwfmFactory::getDBO();
            $db->setQuery('
SELECT
    o.*,
    (SELECT COUNT(*) FROM `#__fwfoodmenu_order_items` AS oi WHERE oi.order_id = o.id) AS _items_qty
FROM
    `#__fwfoodmenu_order` AS o
WHERE
    o.id = '.(int)$oid
            );
            if ($obj = $db->loadObject()) {
                foreach ($obj as $key=>$val) {
                    $this->$key = $val;
                }
                if ($this->_items_qty) {
                    $db->setQuery('SELECT * FROM `#__fwfoodmenu_order_items` WHERE order_id = '.(int)$this->id);
                    $this->_items = $db->loadObjectList();
                }
	            return true;
            }
		}
    }

    function bind($data, $skip=array()) {
        if ($data) {
            $app = fwfmFactory::getApplication();
            $app->triggerEvent('onBindOrder', array('com_fwfoodmenu', $data, &$skip, $this));

            $keys = array_keys($this->getProperties());
            foreach ($data as $key=>$val) {
                if (!in_array($key, $keys) or ($skip and in_array($key, $skip))) {
                    continue;
                }
                $this->$key = $val;
            }
        }
        return true;
    }
    function check() {
        if (!$this->amount) {
			$this->setError(fwfmText::_('FWFM_NO_MEAL_IN_THE_ORDER'));
            return;
        }
		if (!$this->name) {
			$this->setError(fwfmText::_('FWFM_ENTER_YOUR_NAME'));
			return;
		}
		if (!$this->email and !$this->phone) {
			$this->setError(fwfmText::_('FWFM_ENTER_YOUR_PHONE_OR_EMAIL'));
			return;
		}
        if ($this->status and !in_array($this->status, array('pending', 'paid', 'prepared', 'shipped', 'delivered', 'completed', 'cancelled', 'refunded'))) {
			$this->setError(fwfmText::_('FWFM_UNKNOWN_STATUS'));
			return;
        }
		if (!$this->booked_on) {
			$this->setError(fwfmText::_('FWFM_ENTER_ORDER_DATE_TIME'));
			return;
		} else {
            $time = strtotime(fwFoodMenuHelper::encodeDate($this->booked_on));
            $this->booked_on = fwfmFactory::getDate($time)->toSql();
        }
        if (!$this->id) {
            $this->created = fwfmFactory::getDate()->toSql();
        }
        $app = fwfmFactory::getApplication();
        $app->triggerEvent('onCheckOrder', array('com_fwfoodmenu', $this));
        return true;
    }
    function delete($id=null) {
        if (parent::delete($id)) {
            $db = fwfmFactory::getDBO();
            $db->setQuery('DELETE FROM `#__fwfoodmenu_order_items` WHERE order_id = '.(int)$id);
            $db->execute();
            $app = fwfmFactory::getApplication();
            $app->triggerEvent('onDeleteOrder', array('com_fwfoodmenu', $id, $this));
            return true;
        }
    }
}
