<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');
fwfmHtml::_('formbehavior.chosen');

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_CATEGORIES_TOOLBAR_TITLE'), ' fal fa-folders');

fwfmButtonsHelper::addNew('add', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_NEW');
fwfmButtonsHelper::custom('fal fa-upload', '', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_QUICKCATEGORIES', 'quick', false);
fwfmButtonsHelper::publish('publish', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_PUBLISH');
fwfmButtonsHelper::unpublish('unpublish', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_UNPUBLISH');
fwfmButtonsHelper::custom('fal fa-box-check', '', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_BATCH', 'batch', true);
fwfmButtonsHelper::editList('edit', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_EDIT');
fwfmButtonsHelper::custom('fal fa-copy', '', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_COPY', 'copy', true);
fwfmButtonsHelper::deleteList(fwfmText::_('FWFM_ADMIN_CATEGORIES_TOOLBAR_BTN_DELETE_MSG'), 'remove', 'FWFM_DOC_ADMIN_CATEGORIES_TOOLBAR_BTN_DELETE');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
?>
<form id="adminForm" name="adminForm" method="post" action="index.php?option=com_fwfoodmenu&view=category">
    <div class="fwa-filter-bar p-3 clearfix">
        <div class="float-left" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_FILTER_CATEGORY_HINT')); ?>">
            <div class="d-inline-block">
                <?php echo
                fwfmHtml::_('fwfCategory.getCategories', 'category', $this->category, 'class="form-control form-control-sm advancedSelect" onchange="with(this.form){limitstart.value=0;submit();}"', false, 'FWFM_DOC_ADMIN_CATEGORIES_FILTER_CATEGORY', true); ?>
            </div>
        </div>
        <div class="float-left w-25 ml-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_FILTER_SEARCH_HINT')); ?>">
            <div class="input-group">
                <input class="form-control" placeholder="<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_FILTER_SEARCH'); ?>" type="text" name="search" value="<?php echo $this->escape($this->search); ?>" />
                <div class="input-group-append">
                    <button class="btn btn-outline-secondary" type="button" onclick="with(this.form){limitstart.value=0;search.value='';submit();}"><i class="fal fa-times"></i></button>
                </div>
                <div class="input-group-append">
                    <button class="btn btn-primary" type="submit"><i class="fal fa-search"></i></button>
                </div>
            </div>
        </div>
        <div class="float-left ml-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_FILTER_STATE_HINT')); ?>">
			<?php echo fwfmHtml::_('select.genericlist', array(
				fwfmHtml::_('select.option', '', fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_FILTER_STATE'), 'id', 'name'),
				fwfmHtml::_('select.option', 'published', fwfmText::_('FWFM_ADMIN_PUBLISHED'), 'id', 'name'),
				fwfmHtml::_('select.option', 'unpublished', fwfmText::_('FWFM_ADMIN_UNPUBLISHED'), 'id', 'name'),
			), 'state', 'class="form-control form-control-sm advancedSelect" onchange="with(this.form){limitstart.value=0;submit();}"', 'id', 'name', $this->state); ?>
        </div>
<?php
$this->app->triggerEvent('onShowCategoryListFilters', array('com_fwfoodmenu', $this));
$this->app->triggerEvent('onShowLanguageFilters', array('com_fwfoodmenu', $this));
?>
    </div>
	
	<div class="table-responsive">
	<table class="table table-striped">
		<thead>
			<tr>
				<th style="width:20px;"><input name="toggle" value="" onclick="Joomla.checkAll(this);" type="checkbox"></th>
				<th class="text-center" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_ID_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_ID'); ?>
				</th>
				<th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_CATEGORY_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_CATEGORY'); ?>
				</th>
				<th class="text-center" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_CATEGORIES_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_CATEGORIES'); ?>
				</th>
				<th class="text-center" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_MEALS_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_MEALS'); ?>
				</th>
<?php
$this->app->triggerEvent('onShowCategoryListBeginExtraHeaders', array('com_fwfoodmenu', $this));
?>
				<th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_ORDER_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_ORDER'); ?><a href="javascript:saveorder(<?php echo count((array)$this->list) - 1; ?>, 'saveorder')" rel="tooltip" class="saveorder btn btn-warning btn-sm" title="<?php echo $this->escape(fwfmText::_('FWFM_CATEGORY_Save_Order')); ?>"><span class="fal fa-save"></span></a></th>
				<th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_PUBLISHED_HINT')); ?>">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_COLUMN_PUBLISHED'); ?></th>
<?php
$this->app->triggerEvent('onShowCategoryListEndExtraHeaders', array('com_fwfoodmenu', $this));
?>
			</tr>
		</thead>
		<tbody>
<?php
if ($this->list) {
	foreach ($this->list as $num=>$row) {
		$description = strip_tags($row->description);
		$total = strlen($description);
		if ($total > 200) $description = mb_substr($description, 0, 196).'...('.$total.')';
?>
			<tr>
				<td><?php echo fwfmHtml :: _('grid.id', $num, $row->id); ?></td>
				<td class="text-center"><?php echo $row->id; ?></td>
				<td>
					<a href="index.php?option=com_fwfoodmenu&amp;view=category&amp;task=edit&amp;cid[]=<?php echo $row->id.$this->extra_link; ?>">
						<?php echo $row->treename; ?>
					</a> 
					<?php if (strlen($row->short_description)) : ?>
						- <span class="text-muted font-italic"><?php echo $row->short_description; ?></span>
					<?php endif; ?>
					<div><?php echo $description; ?></div>
				</td>
                <td class="text-center">
					<i class="fal fa-folder-tree mr-1"></i>
                	<a href="index.php?option=com_fwfoodmenu&view=category&category=<?php echo $row->id; ?>">
                		<?php echo fwFoodMenuHelper::countCategoriesQty($row->id); ?>
                	</a>
				</td>
                <td class="text-center">
					<i class="fal fa-utensils mr-1"></i>
                	<a href="index.php?option=com_fwfoodmenu&view=items&category=<?php echo $row->id; ?>">
                		<?php echo fwFoodMenuHelper::countMealsQty($row->id); ?>
                	</a>
				</td>
<?php
$this->app->triggerEvent('onShowCategoryListBeginExtraColumns', array('com_fwfoodmenu', $this, $row, $num));
?>
				<td class="order">
					<?php echo fwfmHtmlfwView::orderingListLinks(array(
						'num' => $num,
						'value' => $row->ordering,
						'display_up' => fwFoodMenuHelper::checkPrevCategory($row),
						'display_down' => fwFoodMenuHelper::checkNextCategory($row)
					)); ?>
				</td>
				<td>
					<?php echo fwfmHtmlfwView::booleanListLink(array(
						'num' => $num,
						'value' => $row->published,
						'task_on' => 'publish',
						'task_off' => 'unpublish',
						'title_on' => fwfmText::_('FWFM_CATEGORY_PUBLISH'),
						'title_off' => fwfmText::_('FWFM_CATEGORY_UNPUBLISH')
					)); ?>
				</td>
<?php
$this->app->triggerEvent('onShowCategoryListEndExtraColumns', array('com_fwfoodmenu', $this, $row, $num));
?>
			</tr>
<?php
	}
} else {

}
?>
		</tbody>
	</table>
	</div>
	<div class="row">
		<div class="col-md-2 mt-4 text-center">
			<?php echo $this->pagination->getResultsCounter(); ?>
		</div>
		<div class="col-md-8">
			<?php echo $this->pagination->getListFooter(); ?>
		</div>
		<div class="col-md-2 mt-4 text-center pagination-limit">
			<div class="d-inline-block mr-3">
				<?php echo $this->pagination->getLimitBox(); ?>
			</div>
		</div>
	</div>
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="task" value="" />
</form>
<div class="modal fade" id="fwfm-batch-operations" data-animation="false">
	<div class="modal-dialog modal-lg" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH'); ?>
					<div class="modal-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH_HINT'); ?></div>
				</h5>
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
			</div>
			<form action="index.php?option=com_fwfoodmenu&amp;view=category" method="post" name="operationsForm" id="operationsForm">
				<div class="modal-body">
					<div class="row mx-0">
						<div class="col-md-8 mb-3">
							<label for="fwfm-category-batch"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH_CATEGORY'); ?></label>
							<i class="ml-3 fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH_CATEGORY_HINT')); ?>"></i>
							<?php echo fwfmHtml::_('fwfCategory.parent', array('category_id' => -1), 'category_id', 'class="form-control advancedSelect"', 'FWFM_ADMIN_CATEGORIES_MODAL_BATCH_CATEGORY_ROOT', false, null, 'FWFM_ADMIN_CATEGORIES_MODAL_BATCH_CATEGORY_SAME', -1); ?>
						</div>
<?php
$this->app->triggerEvent('onShowCategoriesBachProcessingExtraFields', array('com_fwfoodmenu', $this));
?>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn" data-dismiss="modal"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH_BTN_CANCEL'); ?></button>
					<button type="submit" class="btn btn-success"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORIES_MODAL_BATCH_BTN_PROCESS'); ?></button>
				</div>
				<input type="hidden" name="task" value="dobatch" />
<?php
foreach ($this->fields as $field) {
	if ($this->$field) {
?>
				<input type="hidden" name="<?php echo $field; ?>" value="<?php echo $this->escape($this->$field); ?>" />
<?php
	}
}
?>
			</form>
		</div>
	</div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	Joomla.submitbutton = function(pressbutton) {
		if (pressbutton == 'quick') {
			$('#fwfm-quick-categories').modal('show');
		} else if (pressbutton == 'batch') {
			$('#fwfm-batch-operations').modal('show');
		} else {
			document.adminForm.task.value=pressbutton;
			document.adminForm.submit();
		}
	}
	$('#fwfm-batch-operations').on('show show.bs.modal', function() {
		var $form = $(this).find('form');
		$form.find('input[name="cid[]"]').remove();
		var $cids = $('#adminForm input[name="cid[]"]:checked').each(function() {
			var $inp = $('<input />', {
				type: 'hidden',
				name: 'cid[]',
				'value': this.value
			});
			$form.append($inp);
		});
	}).on('show', function() {
		$(this).addClass('show');
	}).on('hide', function() {
		$(this).removeClass('show');
	});
	$('#toolbar-upload button').addClass('btn-primary');
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
