<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');
fwfmHtml::_('formbehavior.chosen');
fwFoodMenuHelper::colorpicker();

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_CATEGORYEDIT_TOOLBAR_TITLE'), ' fal fa-folder');

fwfmButtonsHelper::apply('apply', 'FWFM_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVE');
fwfmButtonsHelper::save('save', 'FWFM_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVECLOSE');
fwfmButtonsHelper::save2New('save2new', 'FWFM_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVENEW');
fwfmButtonsHelper::save2Copy('save2copy', 'FWFM_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_SAVECOPY');
fwfmButtonsHelper::cancel('cancel', 'FWFM_DOC_ADMIN_CATEGORYEDIT_TOOLBAR_BTN_CANCEL');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => $this->object->id?fwfmText::sprintf('FWFM_ADMIN_CATEGORYEDIT_EDIT', $this->object->name):fwfmText::_('FWFM_ADMIN_CATEGORYEDIT_NEW'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_HINT'),
	'view' => $this), FWFM_PATH_COMPONENT);
$editor = fwFoodMenuHelper::getEditor();
?>
<form id="adminForm" name="adminForm" method="post" action="index.php?option=com_fwfoodmenu&view=category" enctype="multipart/form-data">
	<div class="fwa-filter-bar fwa-filter-bar-float row">
<?php
$this->app->triggerEvent('onShowLanguageFiltersEdit', array('com_fwfoodmenu', $this));
?>
    </div>
    <div class="fwa-filter-bar">
        <ul class="nav nav-tabs" role="tablist">
            <li class="nav-item">
                <a class="nav-link active" data-toggle="tab" href="#fwg-menu-general" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL'); ?></a>
            </li>
            <li class="nav-item">
                <a class="nav-link" data-toggle="tab" href="#fwg-menu-category-design" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN'); ?></a>
            </li>
        </ul>
    </div>
    <div class="tab-content">
        <div class="tab-pane active" id="fwg-menu-general" role="tabpanel">
			<div class="row fwa-mb-cardbox">
				<div class="col-lg-6 col-sm-12">
					<div class="card">
						<div class="card-header">
							<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL'); ?></h4>
						</div>
						<div class="card-body">
							<div class="form-group row">
								<div class="col-sm-5 col-form-label clearfix">
									<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_PUBLISHED'); ?>
									<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_PUBLISHED_HINT')); ?>"></i>
								</div>
								<div class="col-sm-7">
									<?php echo fwfmHtmlfwView::radioGroup('published', $this->object->id?$this->object->published:1, array(
										'wrapper_class' => 'mr-2',
										'buttons' => array(array(
											'active_class' => 'btn-success',
											'title' => fwfmText::_('JYES'),
											'value' => 1
										), array(
											'active_class' => 'btn-danger',
											'title' => fwfmText::_('JNO'),
											'value' => 0
										))
									)); ?>
								</div>
							</div>
							<div class="form-group row">
								<div class="col-sm-5 col-form-label clearfix" for="fwfm-name">
									<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_NAME'); ?>
									<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_NAME_HINT')); ?>"></i>
								</div>
								<div class="col-sm-7">
									<input class="form-control" value="<?php echo $this->escape($this->object->name); ?>" id="fwfm-name" type="text" name="name"/>
								</div>
							</div>
							<div class="form-group row">
								<div class="col-sm-5 col-form-label clearfix" for="fwfm-alias">
									<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_ALIAS'); ?>
									<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_ALIAS_HINT')); ?>"></i>
								</div>
								<div class="col-sm-7">
									<input class="form-control" value="<?php echo $this->escape($this->object->alias); ?>" id="fwfm-alias" type="text" name="alias"/>
								</div>
							</div>
							<div class="form-group row">
								<div class="col-sm-5 col-form-label clearfix">
									<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_CATEGORY'); ?>
									<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_CATEGORY_HINT')); ?>"></i>
								</div>
								<div class="col-sm-7">
									<?php echo fwfmHtml::_('fwfCategory.parent', $this->object->id?$this->object:(object)array('parent'=>$this->category), 'parent', 'class="form-control advancedSelect"'); ?>
								</div>
							</div>
<?php
$this->app->triggerEvent('onShowCategoryEditExtraFields', array('com_fwfoodmenu', $this));
?>
							<div class="form-group row">
								<div class="col-sm-5 col-form-label clearfix" for="fwfm-name">
									<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_DESCRIPTION'); ?>
									<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_GENERAL_DESCRIPTION_HINT')); ?>"></i>
								</div>
								<div class="col-sm-7">
									<textarea class="form-control" id="fwfm-short_description" cols="60" rows="4" name="short_description"><?php echo $this->escape($this->object->short_description); ?></textarea>
								</div>
							</div>
						</div>
					</div>
<?php
$this->app->triggerEvent('onShowCategoryEditExtraCards', array('com_fwfoodmenu', $this));
?>
				</div>
				<div class="col-lg-6 col-sm-12">
					<div class="card">
						<div class="card-header">
							<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_DESCRIPTION'); ?></h4>
							<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_GENERAL_SECTION_DESCRIPTION_DESCRIPTION_HINT'); ?></div>
						</div>
						<div class="card-body">
							<div class="form-group row">
								<div class="col">
									<?php echo $editor->display('description', $this->object->description, 600, 300, 60, 10, $buttons = false); ?>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="tab-pane" id="fwg-menu-category-design" role="tabpanel">
			<div class="">
				<div class="row no-gutters fwa-mb-cardbox">
                        <div class="card">
                            <div class="card-header">
                                <h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY'); ?></h4>
                                <div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_HINT'); ?></div>
                            </div>
                            <div class="card-body">
								<div class="form-group row">
									<div class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_THEME'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_THEME_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtml::_('select.genericlist', array_merge(array(
											fwfmHtml::_('select.option', 'def', fwfmText::_('FWFM_DEFAULT'), 'id', 'name')
										), fwFoodMenuHelper::getThemesList()), 'params[template]', ' class="form-control"', 'id', 'name', $this->object->params->get('template', 'def')); ?>
									</div>
								</div>
								<div class="form-group row">
									<div class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_SHOWTITLE'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_SHOWTITLE_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtmlfwView::radioGroup('params[display_category_title]', $this->object->params->get('display_category_title', 'def'), array(
											'wrapper_class' => 'mr-2',
											'buttons' => array(array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('JYES'),
												'value' => '1'
											), array(
												'active_class' => 'btn-danger',
												'title' => fwfmText::_('JNO'),
												'value' => '0'
											))
										)); ?>
									</div>
								</div>
								<div class="form-group row">
									<div class="col-sm-5">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_SHORTDESCRIPTION'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_SHORTDESCRIPTION_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtmlfwView::radioGroup('params[display_category_shortdescription]', $this->object->params->get('display_category_shortdescription', 'def'), array(
											'wrapper_class' => 'mr-2',
											'buttons' => array(array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_SHOW'),
												'value' => '1'
											), array(
												'active_class' => 'btn-danger',
												'title' => fwfmText::_('FWFM_HIDE'),
												'value' => '0'
											))
										)); ?>
									</div>
								</div>
								<div class="form-group row">
									<div class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_POSITION'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_POSITION_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtmlfwView::radioGroup('params[category_descr_position]', $this->object->params->get('category_descr_position', 'def'), array(
											'wrapper_class' => 'mr-2',
											'buttons' => array(array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_TOP'),
												'value' => 'top'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_LEFT'),
												'value' => 'left'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_RIGHT'),
												'value' => 'right'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_BOTTOM'),
												'value' => 'bottom'
											))
										)); ?>
									</div>
								</div>
								<div class="form-group row">
									<div class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_ALIGNMENT'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_CATEGORY_ALIGNMENT_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtmlfwView::radioGroup('params[category_text_alignment]', $this->object->params->get('category_text_alignment', 'def'), array(
											'wrapper_class' => 'mr-2',
											'buttons' => array(array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_LEFT'),
												'value' => 'left'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_CENTER'),
												'value' => 'center'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_RIGHT'),
												'value' => 'right'
											))
										)); ?>
									</div>
								</div>
<?php
$this->app->triggerEvent('onShowCategoryEditDesignCategoryExtraSettings', array('com_fwfoodmenu', $this));
?>
							</div>
						</div>
<?php
$this->app->triggerEvent('onShowCategoryEditDesignCategoryExtraCards', array('com_fwfoodmenu', $this));
?>
                        <div class="card">
                            <div class="card-header">
                                <h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_MEALLAYOUT'); ?></h4>
                                <div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_MEALLAYOUT_HINT'); ?></div>
                            </div>
                            <div class="card-body">
								<div class="form-group row">
									<div class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_MEALLAYOUT_MEALCONTENT'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_CATEGORYEDIT_TAB_DESIGN_SECTION_MEALLAYOUT_MEALCONTENT_HINT')); ?>"></i>
									</div>
									<div class="col-sm-7">
										<?php echo fwfmHtmlfwView::radioGroup('params[meal_text_alignment]', $this->object->params->get('meal_text_alignment', 'def'), array(
											'wrapper_class' => 'mr-2',
											'buttons' => array(array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_DEFAULT'),
												'value' => 'def'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_LEFT'),
												'value' => 'left'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_CENTER'),
												'value' => 'center'
											), array(
												'active_class' => 'btn-success',
												'title' => fwfmText::_('FWFM_RIGHT'),
												'value' => 'right'
											))
										)); ?>
									</div>
								</div>
<?php
$this->app->triggerEvent('onShowCategoryEditDesignMenuExtraSettings', array('com_fwfoodmenu', $this));
?>
							</div>
						</div>
				</div>
			</div>
		</div>
	</div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="view" value="category" />
	<input type="hidden" name="id" value="<?php echo $this->object->id; ?>" />
	<input type="hidden" name="limitstart" value="<?php echo $this->input->getInt('limitstart'); ?>" />
<?php
foreach ($this->fields as $field) {
	if ($this->$field) {
?>
    <input type="hidden" name="<?php echo $field; ?>" value="<?php echo $this->escape($this->$field); ?>" />
<?php
	}
}
?>
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('button.btn-outline-secondary:has(".fa-paint-brush")').click(function() {
        $(this).closest('.row').find('input').focus();
    });
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
