<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_CSS_TOOLBAR_TITLE'), ' fal fa-file-code');
fwfmButtonsHelper::apply('apply', 'FWFM_DOC_ADMIN_CSS_TOOLBAR_BTN_SAVE');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_CSS'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_CSS_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
?>
				<form id="adminForm" name="adminForm" class="css-styles" method="post" action="index.php?option=com_fwfoodmenu&view=css" enctype="multipart/form-data">
                    <div class="fwa-filter-bar">
                        <ul class="nav nav-tabs" role="tablist">
                            <li class="nav-item"><a class="nav-link active" data-toggle="tab" href="#fwfm-custom-css" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_CUSTOM') ?></a></li>
    						<li class="nav-item"><a class="nav-link" data-toggle="tab" href="#fwfm-foodmenu-css" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_FWFM') ?></a></li>
<?php
if ($this->contents) {
	foreach ($this->contents as $row) {
?>
    						<li class="nav-item"><a class="nav-link" data-toggle="tab" href="#fwfm-foodmenu-<?php echo $row->element; ?>" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_'.$row->element); ?></a></li>
<?php
	}
}
?>
    					</ul>
                    </div>
					<div class="tab-content">
                        <div class="tab-pane active" id="fwfm-custom-css" role="tabpanel" aria-expanded="false">
							<div class="row fwa-mb-cardbox">
								<div class="col-12">
									<div class="card">
										<div class="card-header">
											<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_CUSTOM_HINT'); ?></div>
										</div>
										<div class="card-body">
											<?php echo $this->editor->display('config[additional_css]', $this->object->params->get('additional_css'), 600, 400, 80, 7, false); ?>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="tab-pane" id="fwfm-foodmenu-css" role="tabpanel" aria-expanded="true">
							<div class="row fwa-mb-cardbox">
								<div class="col-12">
									<div class="card">
										<div class="card-header">
											<div class="card-subtitle pb-2"><?php echo fwfmText::sprintf('FWFM_DOC_ADMIN_CSS_TAB_FWFM_HINT'); ?></div>
                                            <div class="card-subtitle"><em><?php echo str_replace('\\', '/', $this->path); ?></em></div>
										</div>
										<div class="card-body">
											<?php echo $this->editor->display('none', $this->content, '100%', 400, 80, 7, false); ?>
										</div>
									</div>
								</div>
							</div>
						</div>
<?php
if ($this->contents) {
	foreach ($this->contents as $row) {
?>
						<div class="tab-pane" id="fwfm-foodmenu-<?php echo $row->element; ?>" role="tabpanel" aria-expanded="true">
							<div class="row fwa-mb-cardbox">
								<div class="col-12">
									<div class="card">
										<div class="card-header">
											<div class="card-subtitle pb-2">
												<span class="float-right badge badge-default ml-2"><i class="fal fa-puzzle-piece mr-1"></i><?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_'.$row->element.'_TITLE'); ?></span>
												<?php echo fwfmText::_('FWFM_DOC_ADMIN_CSS_TAB_'.$row->element.'_HINT'); ?>
											</div>
                                            <div class="card-subtitle"><em><?php echo str_replace('\\', '/', $row->path); ?></em></div>
										</div>
										<div class="card-body">
											<?php echo $this->editor->display($row->element, $row->content, '100%', 400, 80, 7, false); ?>
										</div>
									</div>
								</div>
							</div>
						</div>
<?php
	}
}
?>
					</div>
					<input type="hidden" name="task" value="" />
					<input type="hidden" name="id" value="1" />
				</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('a[data-toggle="tab"]').on('show', function() {
		var $link = $(this);
		$link.closest('ul').find('.active').removeClass('active');
		$link.addClass('active');
	});
	$('a[data-toggle="tab"]').click(function() {
		$('.CodeMirror').each(function(i, el){
			setTimeout(function() {
				el.CodeMirror.refresh();
			}, 100);
		});
	});
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
