<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined('_FWFM_EXEC') or die('Restricted access');

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_DATA_TOOLBAR_TITLE'), ' fal fa-database');

fwfmHtml::_('formbehavior.chosen');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_DATA'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_DATA_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
?>
<div class="fwa-filter-bar">
    <ul class="nav nav-tabs" role="tablist">
    	<li class="nav-item">
    		<a class="nav-link active" data-toggle="tab" href="#fwfm-restore" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_RESTORE'); ?></a>
    	</li>
    	<li class="nav-item">
    		<a class="nav-link" data-toggle="tab" href="#fwfm-backup" role="tab"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP'); ?></a>
    	</li>
<?php
if ($this->plugins) {
?>
    	<li class="nav-item">
    		<a class="nav-link" data-toggle="tab" href="#fwfm-data" role="tab"><?php echo fwfmText::_('FWFM_ADMIN_DATA_TAB_ADDONS'); ?></a>
    	</li>
<?php
}
?>
    </ul>
</div>
<div class="tab-content">
	<div class="tab-pane active" id="fwfm-restore" role="tabpanel">
		<div class="container-fluid fwa-main-body">
			<form action="index.php?option=com_fwfoodmenu&amp;view=data" method="post" name="adminForm">
				<div class="row fwa-mb-cardbox">
					<div class="col-lg-6 col-sm-12">
						<div class="card">
							<div class="card-header">
								<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_RESTORE_RESTORE'); ?></h4>
								<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_RESTORE_RESTORE_HINT'); ?></div>
								<div class="card-subtitle"><em><?php echo fwfmText::_('FWFM_ADMIN_DATA_TAB_RESTORE_RESTORE_HINT'); ?> <?php echo str_replace('\\', '/', FWFM_PATH_SITE); ?>/media/com_fwfoodmenu/backups</em></div>
							</div>
							<div class="card-body">
								<div class="table-responsive">
								<table class="table">
									<tbody id="fwfm-import-files">
<?php
if ($this->backups) {
	foreach ($this->backups as $file) {
?>
										<tr>
											<td><a href="<?php echo fwfmURI::root(true); ?>/media/com_fwfoodmenu/backups/<?php echo $file; ?>"><?php echo $file; ?></a></td>
											<td>
												<button type="button" class="btn btn-primary"><?php echo fwfmText::_('FWFM_RESTORE'); ?></button>
												<button type="button" class="btn btn-danger"><?php echo fwfmText::_('FWFM_DELETE'); ?></button>
											</td>
										</tr>
<?php
	}
}
?>
									</tbody>
								</table>
								</div>

								<div class="mt-5"><?php echo fwfmText::_('FWFM_IMPORT_UPLOAD_HINT'); ?></div>
                                <div class="input-group mb-3">
									<div class="custom-file">
										<input type="file" class="custom-file-input" id="fwfm-input-import" name="upload" />
										<label class="custom-file-label" for="fwfm-input-import"><?php echo fwfmText::_('FWFM_CHOOSE_FILE'); ?></label>
									</div>
									<div class="input-group-append">
										<button type="button" class="btn btn-success" id="fwfm-import-upload"><i class="fal fa-upload mr-1"></i><?php echo fwfmText::_('FWFM_UPLOAD'); ?></button>
									</div>
								</div>
								<div class="mt-2 fwfm-data-import-result"></div>
								<?php echo fwfmHtml::_('fwView.handleUploadButton', array(
									'button' => '#fwfm-import-upload',
									'input' => '#fwfm-input-import',
									'image' => '',
									'exts' => array('zip'),
									'layout' => 'backup_upload',
									'callback' => 'function(data) {
	$progress_bar.remove();
	$button.attr(\'disabled\', false);
	$input.next().html(\''.fwfmText::_('FWFM_CHOOSE_FILE', false).'\');

	var $parent = $input.parent();
	var input_html = $parent.html();
	$parent.html(input_html);

	var $cont = $(\'#fwfm-import-files\');

	if (data.result) {
		$(\'.fwfm-data-import-result\').html(\''.fwfmText::_('FWFM_EXPORT_FILE_CREATED', true).'\'+data.result);
		var $row = $(\'<tr>\\
	<td><a href="'.fwfmURI::root(true).'/media/com_fwfoodmenu/backups/\'+data.result+\'">\'+data.result+\'</a></td>\\
	<td>\\
		<button type="button" class="btn btn-primary">'.fwfmText::_('FWFM_RESTORE', true).'</button>\\
		<button type="button" class="btn btn-danger">'.fwfmText::_('FWFM_DELETE', true).'</button>\\
	</td>\\
</tr>\');
		$(\'#fwfm-import-files\').append($row);
	}
	if (data.msg) fwfm_alert(data.msg);
}'
								)); ?>
							</div>
						</div>
					</div>
				</div>
                <input type="hidden" name="view" value="data" />
			</form>
		</div>
	</div>
	<div class="tab-pane" id="fwfm-backup" role="tabpanel">
		<div class="container-fluid fwa-main-body">
			<form action="index.php?option=com_fwfoodmenu&amp;view=data" method="post" name="adminForm">
				<div class="row fwa-mb-cardbox">
					<div class="col-lg-6 col-sm-12">
						<div class="card">
							<div class="card-header">
								<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_BACKUP'); ?></h4>
								<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_BACKUP_HINT'); ?></div>
								<div class="card-subtitle"><em><?php echo fwfmText::_('FWFM_ADMIN_DATA_TAB_BACKUP_BACKUP_HINT'); ?> <?php echo str_replace('\\', '/', FWFM_PATH_SITE); ?>/media/com_fwfoodmenu/backups</em></div>
							</div>
							<div class="card-body">
								<div class="form-group row">
									<label class="col-sm-5 col-form-label clearfix" for="fwfm-category-id">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_CATEGORY'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_CATEGORY_HINT')); ?>"></i>
									</label>
									<div class="col-sm-7">
										<?php echo fwfmHtml::_('fwfCategory.parent', null, 'cids[]', 'class="form-control advancedSelect" multiple="multiple"', null); ?>
									</div>
								</div>
								<div class="form-group row">
									<label class="col-sm-5 col-form-label clearfix">
										<?php echo fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_OPTIONS'); ?>
										<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DATA_TAB_BACKUP_OPTIONS_HINT')); ?>"></i>
									</label>
									<div class="col-sm-7">
										<div class="form-group">
											<input type="checkbox" id="fwfm-pdata" name="pdata" value="1" checked="checked" disabled="disabled" />
											<label for="fwfm-pdata"><?php echo fwfmText::_('FWFM_MENU_DATA'); ?></label>
										</div>
<?php
$this->app->triggerEvent('onShowExportFormExportExtraOptions', array('com_fwfoodmenu', $this));
?>
									</div>
								</div>
								<button type="button" id="fwfm-data-export" class="btn btn-success"><i class="fal fa-upload mr-1"></i><?php echo fwfmText::_('FWFM_BACKUP'); ?></button>
								<div class="mt-2 fwfm-data-export-result"></div>
							</div>
						</div>
					</div>
				</div>
                <input type="hidden" name="view" value="data" />
			</form>
		</div>
	</div>
<?php
if ($this->plugins) {
?>
	<div class="tab-pane" id="fwfm-data" role="tabpanel">
		<div class="container-fluid fwa-main-body fwa-mb-cardbox">
			<div class="card">
				<div class="card-header">
					<h4 class="card-title"><?php echo fwfmText::_('FWFM_DATA_IMPORT_PLUGINS'); ?></h4>
					<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DATA_IMPORT_PLUGINS_HINT'); ?></div>
				</div>
				<div class="card-body">
					<div class="row">
						<div class="col-lg-6 col-sm-12">
<?php
	foreach ($this->plugins as $i=>$plugin) {
		if ($i and $i%2 == 0) {
?>
						</div>
						<div class="col-lg-6 col-sm-12">
<?php
		}
		if ($plugin) {
?>
							<fieldset class="adminform">
								<?php echo $plugin; ?>
							</fieldset>
<?php
		}
	}
?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
<?php
}
?>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
	$('#fwfm-import-files').on('click', '.btn-primary', function() {
		var $row = $(this).closest('tr');
		var file = $(this).closest('td').prev().find('a').html();
		if (confirm('<?php echo fwfmText::_('FWFM_ARE_YOU_SURE_BACKUP_RESTORE', true); ?> '+file)) {
			$('#fwfm-import-files').find('button').attr('disabled', true);
			fwfm_alert('<?php echo fwfmText::_('FWFM_BACKUP_UNPACKING_AND_APPLYING', true); ?>');
			$.ajax({
				dataType: 'json',
				data: {
					format: 'json',
					view: 'data',
					layout: 'backup_restore',
					filename: file
				}
			}).done(function (data) {
				$('#fwfm-import-files').find('button').attr('disabled', false);
				if (data.msg) {
					fwfm_alert(data.msg);
				}
			});
		}
	}).on('click', '.btn-danger', function() {
		var $row = $(this).closest('tr');
		var file = $(this).closest('td').prev().find('a').html();
		if (confirm('<?php echo fwfmText::_('FWFM_ARE_YOU_SURE_BACKUP_DELETE', true); ?> '+file)) {
			$row.find('button').attr('disabled', true);
			$.ajax({
				dataType: 'json',
				data: {
					format: 'json',
					view: 'data',
					layout: 'backup_delete',
					filename: file
				}
			}).done(function (data) {
				$row.find('button').attr('disabled', false);
				if (data.result) {
					$row.remove();
				}
				if (data.msg) {
					fwfm_alert(data.msg);
				}
			});
		}
	});
	$('#fwfm-data-export').click(function() {
		var $btn = $(this);
		var $form = $(this.form);

		if ($form.find('input:checked').length) {
			$btn.attr('disabled', true);
			fwfm_alert('<?php echo fwfmText::_('FWFM_EXPORT_DATABASE_DATA', true); ?>');
			$.ajax({
				dataType: 'json',
				data: {
					format: 'json',
					view: 'data',
					layout: 'export_data',
					cids: $form.find('select[name="cids[]"]').val()
				}
			}).done(function(data) {
				if (data.result) {
					var images = $form.find('input[name="pimages"]:checked').length;
					var pdf = $form.find('input[name="ppdf"]:checked').length;
					fwfm_alert(images?'<?php echo fwfmText::_('FWFM_ZIPPING_DATA_IMAGES', true); ?>':'<?php echo fwfmText::_('FWFM_ZIPPING_DATA', true); ?>');
					$.ajax({
						dataType: 'json',
						data: {
							format: 'json',
							view: 'data',
							layout: 'store_export_data',
							images: images,
							pdf: pdf,
							cids: $form.find('select[name="cids[]"]').val(),
							folder: data.result
						}
					}).done(function(data) {
						$btn.attr('disabled', false);
						if (data.result) {
							fwfm_alert('<?php echo fwfmText::_('FWFM_EXPORT_FILE_CREATED', true); ?> <a href="<?php echo fwfmURI::root(true); ?>/media/com_fwfoodmenu/backups/'+data.result+'">'+data.result+'</a>');
							var $row = $('<tr>\
	<td><a href="<?php echo fwfmURI::root(true); ?>/media/com_fwfoodmenu/backups/'+data.result+'">'+data.result+'</a></td>\
	<td>\
		<button type="button" class="btn btn-primary"><?php echo fwfmText::_('FWFM_RESTORE', true); ?></button>\
		<button type="button" class="btn btn-danger"><?php echo fwfmText::_('FWFM_DELETE', true); ?></button>\
	</td>\
</tr>');
							$('#fwfm-import-files').append($row);
						}
						if (data.msg) {
							fwfm_alert(data.msg);
						}
					});
				}
				if (data.msg) {
					fwfm_alert(data.msg);
				}
			});
		} else {
			fwfm_alert('<?php echo fwfmText::_('FWFM_SELECT_WHAT_TO_EXPORT', true); ?>');
		}
	});
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
