<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');
fwfmHtml::_('jquery.framework');
fwfmHtml::_('formbehavior.chosen');
fwFoodMenuHelper::colorpicker();

$listDirn = 'asc';
$listOrder = 'ordering';
fwfmHtml::_('sortablelist.sortable', 'fwfm-sizes', 'adminForm', strtolower($listDirn), '', false, true);

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_MEALSEDIT_TOOLBAR_TITLE'), ' fal fa-utensils');

fwfmButtonsHelper::apply('apply', 'FWFM_DOC_ADMIN_MEALSEDIT_TOOLBAR_BTN_SAVE');
fwfmButtonsHelper::save('save', 'FWFM_DOC_ADMIN_MEALSEDIT_TOOLBAR_BTN_SAVECLOSE');
fwfmButtonsHelper::save2New('save2new', 'FWFM_DOC_ADMIN_MEALSEDIT_TOOLBAR_BTN_SAVENEW');
fwfmButtonsHelper::save2Copy('save2copy', 'FWFM_DOC_ADMIN_MEALSEDIT_TOOLBAR_BTN_SAVECOPY');
fwfmButtonsHelper::cancel('cancel', 'FWFM_DOC_ADMIN_MEALSEDIT_TOOLBAR_BTN_CANCEL');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => $this->object->id?fwfmText::sprintf('FWFM_ADMIN_MEALSEDIT_EDIT', $this->object->name):fwfmText::_('FWFM_ADMIN_MEALSEDIT_ADD'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
$editor = fwFoodMenuHelper::getEditor();
?>
<form id="adminForm" name="adminForm" method="post" action="index.php?option=com_fwfoodmenu&view=items" enctype="multipart/form-data">
	<div class="fwa-filter-bar fwa-filter-bar-float row">
<?php
$this->app->triggerEvent('onShowLanguageFiltersEdit', array('com_fwfoodmenu', $this));
?>
    </div>
	<div class="row fwa-mb-cardbox">
		<div class="col-lg-6 col-sm-12">
			<div class="card">
				<div class="card-header">
					<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS'); ?></h4>
				</div>
				<div class="card-body">
					<div class="form-group row">
						<label class="col-sm-5 col-form-label clearfix">
							<?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_PUBLISHED'); ?>
							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_PUBLISHED_HINT')); ?>"></i>
						</label>
						<div class="col-sm-7">
							<?php echo fwfmHtml::_('fwView.radioGroup', 'published', $this->object->id?$this->object->published:1, array(
								'wrapper_class' => 'mr-2',
								'buttons' => array(array(
									'active_class' => 'btn-success',
									'title' => fwfmText::_('JYES'),
									'value' => 1
								), array(
									'active_class' => 'btn-danger',
									'title' => fwfmText::_('JNO'),
									'value' => 0
								))
							)); ?>
						</div>
					</div>
					<div class="form-group row">
						<label class="col-sm-5 col-form-label clearfix" for="fwfm-category-id">
							<?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_CATEGORY'); ?>
							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_CATEGORY_HINT')); ?>"></i>
						</label>
						<div class="col-sm-7">
							<?php echo fwfmHtml::_('fwfCategory.parent', (object)array('category_id'=>$this->object->category_id), 'category_id', 'class="form-control advancedSelect"', ''); ?>
						</div>
					</div>
					<div class="form-group row">
						<label class="col-sm-5 col-form-label clearfix" for="fwfm-name">
							<?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_NAME'); ?>
							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_NAME_HINT')); ?>"></i>
						</label>
						<div class="col-sm-7">
							<input class="form-control mb-0" value="<?php echo $this->escape($this->object->name); ?>" id="fwfm-name" type="text" name="name"/>
						</div>
					</div>
					<div class="form-group row">
						<div class="col-sm-5 col-form-label clearfix">
							<?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_ALIGNMENT'); ?>
							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_ALIGNMENT_HINT')); ?>"></i>
						</div>
						<div class="col-sm-7">
							<?php echo fwfmHtmlfwView::radioGroup('params[meal_text_alignment]', $this->object->params->get('meal_text_alignment', 'def'), array(
								'wrapper_class' => 'mr-2',
								'buttons' => array(array(
									'active_class' => 'btn-success',
									'title' => fwfmText::_('FWFM_DEFAULT'),
									'value' => 'def'
								), array(
									'active_class' => 'btn-success',
									'title' => fwfmText::_('FWFM_LEFT'),
									'value' => 'left'
								), array(
									'active_class' => 'btn-success',
									'title' => fwfmText::_('FWFM_CENTER'),
									'value' => 'center'
								), array(
									'active_class' => 'btn-success',
									'title' => fwfmText::_('FWFM_RIGHT'),
									'value' => 'right'
								))
							)); ?>
						</div>
					</div>

<?php
$prices = '';
$this->app->triggerEvent('onGetMenuEditPrices', array('com_fwfoodmenu', $this, &$prices));
if ($prices) {
	echo $prices;
} else {
?>
                    <div class="form-group row">
                        <label class="col-sm-5 col-form-label clearfix" for="fwfm-name">
                            <?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_PRICE'); ?>
                            <i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top"
                                data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DETAILS_PRICE_HINT')); ?>"></i>
                        </label>
                        <div class="col-sm-7">
                            <div class="input-group input-group-sm">
<?php
	if (!$this->params->get('currency_after')) {
?>
								<div class="input-group-prepend">
	                                <span class="input-group-text"><?php echo $this->params->get('currency'); ?></span>
								</div>
<?php
	}
?>
                                <input name="prices[0][price]" class="form-control" value="<?php if (!empty($this->object->_prices[0]->price)) echo $this->escape($this->object->_prices[0]->price); ?>" />
<?php
	if ($this->params->get('currency_after')) {
?>
								<div class="input-group-prepend">
	                                <span class="input-group-text"><?php echo $this->params->get('currency'); ?></span>
								</div>
<?php
	}
?>
                            </div>
                        </div>
                    </div>
<?php
}
?>

                </div>
            </div>
            <div class="card">
				<div class="card-header">
					<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DESCRIPTION'); ?></h4>
					<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_MEALSEDIT_SECTION_DESCRIPTION_DESCRIPTION_HINT'); ?></div>
				</div>
				<div class="card-body">
                    <?php echo $editor->display('description', $this->object->description, '100%', 200, 60, 10, $buttons = false); ?>
                </div>
    		</div>
		</div>
		<div class="col-lg-6 col-sm-12">
<?php
$this->app->triggerEvent('onShowMenuEditExtraCardsRight', array('com_fwfoodmenu', $this));
?>
		</div>
	</div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="id" value="<?php echo $this->object->id; ?>" />
    <input type="hidden" name="limitstart" value="<?php echo $this->input->getInt('limitstart'); ?>" />
<?php
foreach ($this->fields as $field) {
    if ($this->$field) {
?>
    <input type="hidden" name="<?php echo $field; ?>" value="<?php echo $this->escape($this->$field); ?>" />
<?php
    }
}
?>
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('button.btn-outline-secondary:has(".fa-paint-brush")').click(function() {
        $(this).closest('.row').find('input').focus();
    });
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
