<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_DASHBOARD_TOOLBAR_TITLE'), ' fal fa-tachometer-alt');

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
$update_code = $this->obj->params->get('update_code');
$verified_code = $this->obj->params->get('verified_code');
?>
<form id="adminForm" name="adminForm" method="post" action="index.php?option=com_fwfoodmenu&view=menu" enctype="multipart/form-data">
	<div class="row fwa-mb-cardbox">
		<div class="col-lg-6 col-sm-12">
            <div class="card">
    			<div class="card-header">
    				<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_COMPONENT_NOPARAMS'); ?></h4>
    				<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_COMPONENT_HINT'); ?></div>
    			</div>
    			<div class="card-body">
<?php
$addons_installed = $addons_total = $main_has_update = $addon_has_update = $addon_has_install = 0;
$comp_version = '';
if ($this->addons) {
	foreach ($this->addons as $row) {
        if ($row->type and !$row->installed and !empty($row->installable)) {
            $addon_has_install = 1;
        }
        if ($row->type and $row->update_name != FWA_UPDATE_NAME) {
            $addons_total++;
        }
        if ($row->loc_version and $row->rem_version and $row->loc_version != 'x.x.x' and $row->loc_version != $row->rem_version) {
            $addon_has_update = true;
        }
        if ($row->installed and $row->update_name != FWA_UPDATE_NAME) {
            $addons_installed++;
        }
    }

	foreach ($this->addons as $row) {
		if ($row->update_name == FWA_UPDATE_NAME) {
            $comp_version = $row->loc_version;
            $main_has_update = ($row->loc_version and $row->rem_version and $row->loc_version != 'x.x.x' and $row->loc_version != $row->rem_version);
?>
<div class="row fws-extensions-item-info" data-ext="<?php echo $this->escape($row->update_name); ?>">
	<div class="col-md-3 p-0 fws-ext-item-img">
		<img src="<?php echo $row->image; ?>" />
	</div>
	<div class="col-md-6 fws-ext-stats">
		<div class="fws-ext-latest">
			<i class="fa-fw fal fa-code-branch mr-1"></i>
			<?php echo fwfmText::_('FWFM_ADMIN_DASHBOARD_COMPONENT_INSTALLEDVERSION'); ?>
			<span class="badge badge-<?php if ($main_has_update) { ?>warning<?php } else { ?>success<?php } ?>"><?php echo $row->loc_version; ?></span>
		</div>
		<div class="fws-show-addons-owned">
			<i class="fa-fw fal fa-puzzle-piece mr-1"></i>
			<?php echo fwfmText::sprintf('FWFM_ADDONS_OWNED_OF', $addons_installed, $addons_total); ?>
		</div>

<?php
            if ($main_has_update) {
                $release = $descr = '';
                if (strpos($row->rem_version, '.0.0')) {
                    $release = 'FWA_MAJOR_RELEASE_TITLE';
                    $descr = 'FWA_MAJOR_RELEASE_IMPACT';
                } elseif (strpos($row->rem_version, '.0.')) {
                    $release = 'FWA_MINOR_RELEASE_TITLE';
                    $descr = 'FWA_MINOR_RELEASE_IMPACT';
                } else {
                    $release = 'FWA_MAINTENACE_RELEASE_TITLE';
                    $descr = 'FWA_MAINTENACE_RELEASE_IMPACT';
                }
?>
        <div class="fws-ext-update">
            <button type="button" class="btn btn-warning fwfm-addon-update"><?php echo fwfmText::_('FWFM_UPDATE_TO'); ?> <?php echo $row->rem_version; ?></button>
    		<div class="text-warning fws-ext-download-tooltip" data-toggle="tooltip" data-original-title="<?php echo $this->escape(fwfmText::_($descr)); ?>">
    			<span>
    				<?php echo fwfmText::_($release); ?>
    				<i class="far fa-info-circle ml-1"></i>
    			</span>
    		</div>
        </div>
<?php
            }
?>

    </div>
    <div class="col-md-3 p-0 fws-ext-links">
        <div>
    		<a href="https://fastw3b.net/joomla-extensions/product/2-fw-real-estate" target="_blank">
    			<i class="fa-fw fal fa-cube mr-1"></i>
    			<?php echo fwfmText::_('FWFM_PRODUCT_PAGE') ?>
    		</a>
        </div>
        <div>
            <a href="javascript:">
                <i class="fa-fw fal fa-file-alt mr-1"></i>
                <?php echo fwfmText::_('FWFM_CHANGELOG'); ?>
            </a>
        </div>
        <div>
            <a href="https://fastw3b.net/documentation/fw-real-estate" target="_blank">
                <i class="fa-fw fal fa-book mr-1"></i>
                <?php echo fwfmText::_('FWFM_DOCUMENTATION'); ?>
            </a>
        </div>
    </div>
</div>
<?php
			break;
		}
	}
}
?>
    			</div>
	        </div>
    		<div class="card fwa-stats">
    			<div class="card-header">
    				<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS'); ?></h4>
    				<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_HINT'); ?></div>
    			</div>
    			<div class="card-body">
    				<div class="row">
    					<div class="col text-center">
    						<i class="fal fa-folders fa-3x" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_CATEGORIES_HINT')); ?>"></i>
    						<br><a href="index.php?option=com_fwfoodmenu&view=category"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_CATEGORIES'); ?></a>
    						<br> <?php echo $this->locstat->cp; ?> / <?php echo $this->locstat->ct; ?>
    					</div>
    					<div class="col text-center">
    						<i class="fal fa-image fa-3x" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_MEALS_HINT')); ?>"></i>
    						<br><a href="index.php?option=com_fwfoodmenu&view=items"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_MEALS'); ?></a>
    						<br> <?php echo $this->locstat->mp; ?> / <?php echo $this->locstat->mt; ?>
    					</div>
    					<div class="col text-center">
    						<i class="fal fa-hdd fa-3x" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_FILES_HINT')); ?>"></i>
    						<br><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_STATS_FILES'); ?>
    						<br><?php echo fwFoodMenuHelper::humanFileSize($this->locstat->fs); ?>
    					</div>
    				</div>
    			</div>
    		</div>
    		<div class="card fwa-check check-<?php if ($this->qch->test_passed) { ?>success<?php } else { ?>fail<?php } ?>">
    			<div class="card-header">
    				<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_CHECK_NOPARAMS'); ?> - <?php echo fwfmText::_($this->qch->test_passed?'FWFM_PASSED':'FWFM_FAILED'); ?></h4>
    				<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_CHECK_HINT'); ?></div>
    			</div>
    			<div class="card-body">
                    <div class="table-responsive">
    				<table class="table table-striped">
    					<tbody><tr>
    						<td><?php echo fwfmText::_('FWFM_JOOMLA_MEDIA_FOLDER'); ?></td>
    						<td>
<?php
if ($this->qch->media_folder_exists) {
?>
    							<i class="fal fa-check-circle"></i> <?php echo fwfmText::_('FWFM_EXISTS_SMALL'); ?>
<?php
} else {
?>
    							<i class="fal fa-times-circle"></i> <?php echo fwfmText::_('FWFM_NOT_EXISTS_SMALL'); ?>
<?php
}
?>
    						</td>
    					</tr>
    					<tr>
    						<td><?php echo fwfmText::_('FWFM_IMAGES_FOLDER'); ?></td>
    						<td>
<?php
if ($this->qch->gallery_folder_exists) {
?>
    							<i class="fal fa-check-circle"></i> <?php echo fwfmText::_('FWFM_EXISTS_SMALL'); ?>
<?php
} else {
?>
    							<i class="fal fa-times-circle"></i> <?php echo fwfmText::_('FWFM_NOT_EXISTS_SMALL'); ?>
<?php
}
?>
    						</td>
    					</tr>
    					<tr>
    						<td><?php echo fwfmText::_('FWFM_IMAGES_FOLDER'); ?></td>
    						<td>
<?php
if ($this->qch->gallery_folder_writeable) {
?>
    							<i class="fal fa-check-circle"></i> <?php echo fwfmText::_('FWFM_WRITABLE_SMALL'); ?>
<?php
} else {
?>
    							<i class="fal fa-times-circle"></i> <?php echo fwfmText::_('FWFM_NOT_WRITABLE_SMALL'); ?>
<?php
}
?>
    						</td>
    					</tr>
    					<tr>
    						<td><?php echo fwfmText::_('FWFM_MAX_TOTAL_POST_SIZE'); ?></td>
    						<td><?php echo fwFoodMenuHelper::humanFileSize(fwFoodMenuHelper::getIniSize('post_max_size')); ?></td>
    					</tr>
    					<tr>
    						<td><?php echo fwfmText::_('FWFM_MAX_FILE_SIZE'); ?></td>
    						<td><?php echo fwFoodMenuHelper::humanFileSize(fwFoodMenuHelper::getIniSize('upload_max_filesize')); ?></td>
    					</tr>
    					<tr>
    						<td><?php echo fwfmText::_('FWFM_MAX_FILES_PER_POST'); ?></td>
    						<td><?php echo ini_get('max_file_uploads'); ?></td>
    					</tr>
    				</tbody></table></div>
    			</div>
    		</div>
<?php
if (class_exists('JVersion')) {
?>
    		<div class="card">
    			<div class="card-header">
    				<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_REVIEW_NOPARAMS'); ?></h4>
    				<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_REVIEW_HINT'); ?></div>
    			</div>
    			<div class="card-body">
    				<p><?php echo fwfmText::_('FWFM_SPREAD_THE_LOVE_HINT'); ?></p>
    				<div class="text-center">
    					<a href="https://extensions.joomla.org/extensions/extension/vertical-markets/food-a-beverage/fw-food-menu/" target="_blank" class="btn btn-success text-center"><i class="fal fa-heart mr-1"></i> <?php echo fwfmText::_('FWFM_ADMIN_DASHBOARD_REVIEW_LEAVE'); ?></a>
    				</div>
    			</div>
    		</div>
<?php
}
?>
		</div>
		<div class="col-lg-6 col-sm-12">
<?php
$count_addons = 0;
if ($this->addons) {
    $have_services = false;
    $count_services = 0;
    foreach ($this->addons as $row) {
        if ($row->subtype == 'service') {
            $have_services = true;
            $count_services++;
        } elseif (!((!$row->installed and !$row->installable) or !$row->type or $row->update_name == FWA_UPDATE_NAME))  { $count_addons++ ;}
    }
    if ($have_services) {
?>
        <div class="card">
			<div class="card-header">
                <h4 class="card-title">
                    <?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_SERVICES_NOPARAMS'); ?>
                    <span class="float-right badge badge-default"><i class="fal fa-cog mr-1"></i>  <?php echo $count_services.' '.fwfmText::_('FWFM_ADMIN_DASHBOARD_SERVICES_AVAILABLE'); ?></span>
                </h4>
                <div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_SERVICES_HINT'); ?></div>
			</div>
			<div class="card-body fwa-services">
                <div class="table-responsive">
                <table class="table table-striped">
<?php
        foreach ($this->addons as $row) {
            if ($row->subtype == 'service') {
                $image = $row->image?$row->image:(fwfmURI::root(true).'/administrator/components/com_fwfoodmenu/assets/images/'.$row->update_name.'.jpg');
?>
                    <tr>
                        <td>
                            <img class="img-thumbnail" src="<?php echo $image; ?>" alt="<?php echo $this->escape($row->name); ?>">
                        </td>
                        <td>
                            <div class="fwa-service-name"><?php echo $this->escape($row->name); ?></div>
                            <div class="text-muted fwa-service-description"><?php echo $row->description; ?></div>
                        </td>
                        <td class="text-center">
                            <div>
                                <a class="btn btn-sm btn-outline-secondary active" href="<?php echo $row->link; ?>" target="_blank">
                                    <i class="fal fa-cog mr-1"></i> <?php echo fwfmText::_('FWFM_ADMIN_DASHBOARD_PREORDER_SERVICE'); ?>
                                </a>
                            </div>
                            <div class="mt-1">
                                <span class="font-weight-bold">$<?php echo ((int)$row->price) ? number_format($row->price, 2) : 'TBD'; ?></span>,
                                <?php echo ($row->days) ? $row->days.' '.fwfmText::_('FWA_DAYS') : 'TBD'; ?>
                            </div>
                        </td>
                    </tr>
				
<?php
            }
        }
?>
                </table>
                </div>
            </div>
        </div>
<?php
    }
}
if ($count_addons) {
?>
		<div class="card">
			<div class="card-header">
				<h4 class="card-title">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS'); ?>
                    <span class="float-right badge badge-default"><i class="fal fa-puzzle-piece mr-1"></i>  <?php echo $count_addons.' '.fwfmText::_('FWFM_ADMIN_DASHBOARD_ADDONS_ADDONS'); ?></span>
				</h4>
				<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_HINT'); ?></div>
			</div>
			<div class="card-body">
<?php
    if ($this->addons) {
        if ($addon_has_install or $addon_has_update) {
?>
                <div class="alert alert-info">
<?php
            if ($addon_has_install) {
?>
                    <button type="button" class="btn btn-warning" id="fwfm-install-all"><?php echo fwfmText::_('FWFM_INSTALL_ALL'); ?></button>
<?php
            }
            if ($addon_has_update) {
?>
                    <button type="button" class="btn btn-warning" id="fwfm-update-all"><?php echo fwfmText::_('FWFM_UPDATE_ALL'); ?></button>
<?php
            }
?>
                </div>
<?php
        }
?>
                <div class="table-responsive">
                <table class="table table-striped">
                    <tr>
                        <th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_IMAGE_HINT')); ?>">
                            <?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_IMAGE'); ?>
                        </th>
                        <th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_ADDON_HINT')); ?>">
                            <?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_ADDON'); ?>
                        </th>
                        <th class="text-center" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_ACTIONS_HINT')); ?>">
                            <?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_ACTIONS'); ?>
                        </th>
<?php
        if (class_exists('JVersion')) {
?>
                        <th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_TYPE_HINT')); ?>">
                            <?php echo fwfmText::_('FWFM_DOC_ADMIN_DASHBOARD_ADDONS_COLUMN_TYPE'); ?>
                        </th>
<?php
        }
?>
                    </tr>
<?php
        foreach ($this->addons as $row) {
            if ((!$row->installed and !$row->installable) or !$row->type or $row->update_name == FWA_UPDATE_NAME) continue;
            $addon_type = strtolower(str_replace(' ', '-', $row->type));
            $main_has_update = (!empty($row->rem_version) and $row->loc_version != 'x.x.x' and $row->rem_version != $row->loc_version);
?>
                    <tr class="fws-extension-addon fwshop-item type-<?php echo $addon_type; ?>" data-ext="<?php echo $this->escape($row->update_name); ?>">
                        <td>
                            <a href="javascript:"
                                data-lightbox="html" data-lightbox-title="<?php echo $this->escape($row->name); ?> <?php echo $this->escape(fwfmText::_('FWA_ADDON')); ?>">
                                <img class="img-thumbnail" src="<?php echo $row->image; ?>" alt="<?php echo $this->escape($row->name); ?>" />
                            </a>
                        </td>
                        <td>
                            <div class="fws-extension-addon-title" title="<?php echo $row->name; ?>"><?php echo $row->name; ?></div>
<?php
            if (!empty($row->_required)) {
?>
		                    <div class="fws-extension-addon-required small text-danger"><i class="fal fa-exclamation-triangle"></i> <?php echo implode(', ', $row->_required); ?> <?php echo fwfmText::_('FWFM_REQUIRED'); ?></div>
<?php
            }
            if ($row->installed) {
?>
                            <div class="fws-extension-addon-version">
                                <i class="fal fa-code-branch mr-1"></i>
                                <?php echo fwfmText::_('FWFM_ADMIN_DASHBOARD_COMPONENT_INSTALLEDVERSION'); ?>
                                <span class="badge badge-<?php if ($main_has_update) { ?>warning<?php } else { ?>success<?php } ?>"><?php echo $row->loc_version; ?></span>
                            </div>
<?php
            }
            if (!empty($row->_comp_version)) {
                $version_match = true;
                $buff1 = explode('.', $comp_version, 3);
                $buff2 = explode('.', $row->_comp_version, 3);
                if (count($buff1) > 2 and count($buff2) > 2 and $buff1[0] != 'x' and ($buff1[0] < $buff2[0] or ($buff1[0] == $buff2[0] and $buff1[1] < $buff2[1]))) {
                    $version_match = false;
                }
?>
                            <div>
                                <?php echo fwfmText::_('FWFM_MAIN_COMPONENT_REQUIRED_VERSION'); ?>: <span class="badge badge-<?php if ($version_match) { ?>success<?php } else { ?>danger<?php } ?>"><?php echo $row->_comp_version; ?></span>
                            </div>
<?php
            }
            if (!empty($row->doc_link) or !empty($row->frontend_demo_link)) {
?>
		                    <div class="fws-extension-addon-links">
<?php
                if (!empty($row->doc_link)) {
?>
                                <a href="<?php echo $row->doc_link; ?>" target="_blank">
                                    <i class="fal fa-book mr-1"></i>
                                    <?php echo fwfmText::_('FWFM_DOCUMENTATION'); ?>
                                </a>
<?php
                }
                if (!empty($row->frontend_demo_link)) {
?>
                                <a href="<?php echo $row->frontend_demo_link; ?>" target="_blank">
                                    <i class="fal fa-presentation mr-1"></i>
                                    <?php echo fwfmText::_('FWFM_DEMO_LINK'); ?>
                                </a>
<?php
                }
?>
                            </div>
<?php
            }
?>
                        </td>
                        <td class="text-center">
<?php
            if ($main_has_update) {
                if ($row->installed) {
?>
                            <button type="button" class="btn btn-warning fwfm-addon-update"><?php echo fwfmText::_('FWFM_UPDATE_TO'); ?> <?php echo $row->rem_version; ?></button>
<?php
                } else {
?>
                            <button type="button" class="btn btn-warning fwfm-addon-install"><?php echo fwfmText::_('FWFM_INSTALL_VERSION'); ?> <?php echo $row->rem_version; ?></button>
<?php
                }
            }
            if ($row->installed) {
                if ($row->enabled) {
?>
                            <button type="button" class="btn btn-danger fwfm-addon-disable"><?php echo fwfmText::_('FWFM_DISABLE'); ?></button>
<?php
                } else {
?>
                            <button type="button" class="btn btn-success fwfm-addon-enable"><?php echo fwfmText::_('FWFM_ENABLE'); ?></button>
<?php
                }
            }
?>
                        </td>
<?php
            if (class_exists('JVersion')) {
?>
                        <td>
                            <div class="fwshop-item-type" title="<?php echo $row->type; ?>"><?php echo substr($row->type, 0, 1); ?></div>
                        </td>
<?php
            }
?>
                    </tr>
<?php
        }
?>
                </table>
                </div>
            </div>
<?php
    }
?>
        </div>
<?php
}
?>
	</div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="id" value="1" />
</form>
<div class="modal" tabindex="-1" role="dialog" id="fwfm-changelog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title"><?php echo fwfmText::_('FWFM_CHANGELOG'); ?></h5>
        <button type="button" class="close" data-dismiss="modal">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-outline-secondary" data-dismiss="modal"><?php echo fwfmText::_('FWFM_CLOSE'); ?></button>
      </div>
    </div>
  </div>
</div>
<div id="fwa-addon-description" class="modal fade" data-animation="false">
  <div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title"></h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body"></div>
    </div>
  </div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    $('#fwa-addon-description').on('show', function() {
        $(this).addClass('show');
    }).on('hide', function() {
        $(this).removeClass('show');
    });
	$('#fwfm-changelog').on('show', function() {
		$(this).addClass('show');
	}).on('hide', function() {
		$(this).removeClass('show');
	});
    $('#fwfm-install-all').click(function() {
        var $btn = $(this);
        var $wrp = $btn.parent();
        $btn.remove();
        if (!$wrp.find('button').length) {
            $wrp.remove();
        }
        $('.fwfm-addon-install').click();
    });
    $('#fwfm-update-all').click(function() {
        var $btn = $(this);
        var $wrp = $btn.parent();
        $btn.remove();
        if (!$wrp.find('button').length) {
            $wrp.remove();
        }
        $('.fwfm-addon-update').click();
    });
	$('.fws-extensions-item-info a:has(".fa-file-alt")').click(function(ev) {
        ev.stopPropagation();
		var $btn = $(this).attr('disabled', true);
		$.ajax({
			'url': '',
			'method': 'post',
			dataType: 'json',
			'data': {
				'format': 'json',
				'view': 'menu',
				'layout': 'get_changelog'
			}
		}).done(function(data) {
			$btn.attr('disabled', false);
			var $popup = $('#fwfm-changelog');
			$popup.find('.modal-body').html(data.result?data.result:data.msg?data.msg:'<?php echo fwfmText::_('FWFM_NO_CHANGELOG', true); ?>');
			$popup.modal('show');
		});
	});
    $('.fwshop-item a[data-lightbox="html"]').click(function(ev) {
        ev.preventDefault();
        var $link = $(this);
        var $wrapper = $link.closest('.fwshop-item');
        var name = $wrapper.data('ext');
        var $popup = $('#fwa-addon-description');
        $popup.find('.modal-title').html($link.data('lightbox-title'));
        $popup.find('.modal-body').html('');
        $popup.modal('show');

        $.ajax({
            url: '',
            type: 'post',
            dataType: 'json',
            data: {
                format: 'json',
                view: 'addon',
                layout: 'load_addon_description',
                update_name: name
            }
        }).done(function(data) {
            if (data.html) {
                $popup.find('.modal-body').html(data.html);
            } else {
                $popup.modal('hide');
            }
            if (data.msg) {
                alert(data.msg)
            }
        });
    });
    $('.fws-extension-addon,.fws-ext-update').on('click', '.fwfm-addon-install,.fwfm-addon-update,.fwfm-addon-enable,.fwfm-addon-disable', function() {
        var $btn = $(this);
        if ($btn.attr('disabled')) return;

        var action = '';
        if ($btn.hasClass('fwfm-addon-install')) {
            action = 'install';
        } else if ($btn.hasClass('fwfm-addon-enable')) {
            action = 'enable';
        } else if ($btn.hasClass('fwfm-addon-disable')) {
            action = 'disable';
        } else if ($btn.hasClass('fwfm-addon-update')) {
            action = 'update';
        }

        if (action == '') return;

        $btn.attr('disabled', true);

        var $wrp = $btn.closest('*[data-ext]');
		var $img = $('<img/>', {
			'src' : '<?php echo fwfmURI::root(true); ?>/components/com_fwfoodmenu/assets/images/ajax-loader.gif',
			'style': 'height:auto;width:auto;position:absolute;margin:9px -65px;'
		});
		$btn.after($img);
		$.ajax({
			dataType: 'json',
			data: {
				format: 'json',
				view: 'addon',
				layout: action,
				ext: [$wrp.data('ext')]
			}
		}).done(function(data) {
			$btn.attr('disabled', false);
			$img.remove();
            var msg_title = '';
            switch (action) {
                case 'install' :
                msg_title = '<?php echo fwfmText::_('FWFM_INSTALLING_RESULT', true); ?>';
                break;
                case 'enable' :
                msg_title = '<?php echo fwfmText::_('FWFM_ENABLING_RESULT', true); ?>';
                break;
                case 'disable' :
                msg_title = '<?php echo fwfmText::_('FWFM_DISABLING_RESULT', true); ?>';
                break;
                case 'update' :
                msg_title = '<?php echo fwfmText::_('FWFM_UDPATING_RESULT', true); ?>';
                break;
            }

			if (data.result) {
				var row = data.result;
                $btn.html(row.button);
                switch (action) {
                    case 'install' :
                    $btn.removeClass('fwfm-addon-install btn-warning').addClass('fwfm-addon-disable btn-danger').html('<?php echo fwfmText::_('FWFM_DISABLE', true); ?>');
                    break;
                    case 'enable' :
                    $btn.removeClass('fwfm-addon-enable').addClass('fwfm-addon-disable').removeClass('btn-success').addClass('btn-danger').html('<?php echo fwfmText::_('FWFM_DISABLE', true); ?>');
                    break;
                    case 'disable' :
                    $btn.removeClass('fwfm-addon-disable').addClass('fwfm-addon-enable').removeClass('btn-danger').addClass('btn-success').html('<?php echo fwfmText::_('FWFM_ENABLE', true); ?>');
                    break;
                    case 'update' :
                    $btn.remove();
                    break;
                }
			}
			if (data.msg) {
                fwfm_alert(data.msg);
			}
		});
    });
<?php
if ($addon_has_update or $main_has_update) {
?>
    fwfm_alert('<?php echo fwfmText::_('FWFM_PLEASE_CHECK_UPDATES', true); ?>');
<?php
}
?>
    })(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
