<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined('_FWFM_EXEC') or die('Restricted access');

class menuViewOrders extends fwfmViewLegacy {
    function display($tmpl = null) {
        $this->menu = 'orders';
        $model = $this->getModel();

        fwfmHtml::_('behavior.core');
        $this->app = fwfmFactory::getApplication();
		$this->params = fwfmComponentHelper::getParams('com_fwfoodmenu');

        $this->plugin_installed = fwFoodMenuHelper::pluginInstalled('cart');
        $this->plugin_enabled = fwFoodMenuHelper::pluginEnabled('cart');

		$this->fields = array('search', 'limit', 'limitstart');

        switch ($this->getLayout()) {
            case 'edit' :
			$this->object = $model->loadObject();
            foreach ($this->fields as $field) {
                $this->$field = $this->app->input->getString($field);
            }
			fwFoodMenuHelper::triggerEvent('onLoadMainMenu', array('com_fwfoodmenu', 'order', $this));
            break;
            default:
			$this->list = $model->loadList();
			$this->pagination = $model->getPagination();
			$this->extra_link = '';
            foreach ($this->fields as $field) {
                $this->$field = $this->app->input->getString($field);
				if (is_string($this->$field)) {
					$this->extra_link .= '&amp;'.$field.'='.urlencode($this->$field);
    				$this->pagination->setAdditionalUrlParam($field, $this->$field);
    			}
            }
			fwFoodMenuHelper::triggerEvent('onLoadMainMenu', array('com_fwfoodmenu', 'orders', $this));
        }
        parent::display($tmpl);
    }
}
