<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_SETTINGS_TOOLBAR_TITLE'), ' fal fa-sliders-h');
fwfmButtonsHelper::apply('apply', 'FWFM_DOC_ADMIN_SETTINGS_TOOLBAR_BTN_SAVE');
fwFoodMenuHelper::colorpicker();

echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_SETTINGS'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
?>
<form id="adminForm" name="adminForm" method="post" action="index.php?option=com_fwfoodmenu&view=settings" enctype="multipart/form-data">
    <div class="fwa-filter-bar">
        <ul class="nav nav-tabs" role="tablist">
            <li class="nav-item" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_HINT')); ?>">
                <a class="nav-link active" data-toggle="tab" href="#fwfm-settings-general" role="tab">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL'); ?></a>
            </li>
            <li class="nav-item" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_HINT')); ?>">
                <a class="nav-link" data-toggle="tab" href="#fwfm-settings-design" role="tab">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN'); ?></a>
            </li>
            <li class="nav-item" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_ADDONS_HINT')); ?>">
                <a class="nav-link" data-toggle="tab" href="#fwfm-settings-plugins" role="tab">
					<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_ADDONS'); ?></a>
            </li>
        </ul>
    </div>
    <div class="tab-content">
        <div class="tab-pane active" id="fwfm-settings-general" role="tabpanel">
        	<div class="fwa-mb-cardbox">
				<div class="card">
					<div class="card-header">
						<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON'); ?></h4>
					</div>
					<div class="card-body">
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_BOOTSTRAP'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_BOOTSTRAP_HINT')); ?>"></i>
							</div>
							<div class="col-sm-7">
								<?php echo fwfmHtmlfwView::radioGroup('config[do_not_load_bootstrap]', (int)$this->object->params->get('do_not_load_bootstrap'), array(
									'wrapper_class' => 'mr-2',
									'buttons' => array(array(
										'active_class' => 'btn-success',
										'title' => fwfmText::_('JYES'),
										'value' => 0
									), array(
										'active_class' => 'btn-danger',
										'title' => fwfmText::_('JNO'),
										'value' => 1
									))
								)); ?>
							</div>
						</div>
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FA'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FA_HINT')); ?>"></i>
							</div>
							<div class="col-sm-7">
								<?php echo fwfmHtmlfwView::radioGroup('config[do_not_load_awesome]', (int)$this->object->params->get('do_not_load_awesome'), array(
									'wrapper_class' => 'mr-2',
									'buttons' => array(array(
										'active_class' => 'btn-success',
										'title' => fwfmText::_('JYES'),
										'value' => 0
									), array(
										'active_class' => 'btn-danger',
										'title' => fwfmText::_('JNO'),
										'value' => 1
									))
								)); ?>
							</div>
						</div>
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FONT'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_FONT_HINT')); ?>"></i>
							</div>
							<div class="col-3">
								<div class="input-group input-group-sm">
									<input class="form-control" value="<?php echo (int)$this->object->params->get('font_size', 16); ?>" id="fwfm-currency_code" type="text" name="config[font_size]">
									<div class="input-group-append">
										<span class="input-group-text" id="basic-addon2">px</span>
									</div>
								</div>								
							</div>
						</div>
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_PRICEZEROS'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_PRICEZEROS_HINT')); ?>"></i>
							</div>
							<div class="col-sm-7">
								<?php echo fwfmHtmlfwView::radioGroup('config[hide_ending_ziro]', (int)$this->object->params->get('hide_ending_ziro'), array(
									'wrapper_class' => 'mr-2',
									'buttons' => array(array(
										'active_class' => 'btn-success',
										'title' => fwfmText::_('FWFM_SHOW'),
										'value' => 0
									), array(
										'active_class' => 'btn-success',
										'title' => fwfmText::_('FWFM_HIDE'),
										'value' => 1
									))
								)); ?>
							</div>
						</div>
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_ADDONS'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_COMMON_ADDONS_HINT')); ?>"></i>
							</div>
							<div class="col-sm-7">
								<?php echo fwfmHtmlfwView::radioGroup('config[show_addons_menu_settings]', (int)$this->object->params->get('show_addons_menu_settings'), array(
									'wrapper_class' => 'mr-2',
									'buttons' => array(array(
										'active_class' => 'btn-success',
										'title' => fwfmText::_('FWFM_SHOW'),
										'value' => 1
									), array(
										'active_class' => 'btn-danger',
										'title' => fwfmText::_('FWFM_HIDE'),
										'value' => 0
									))
								)); ?>
							</div>
						</div>
					</div>
				</div>

				<div class="card">
					<div class="card-header">
						<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_LOCAL'); ?></h4>
					</div>
					<div class="card-body">
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_LOCAL_CURSYMBOL'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_LOCAL_CURSYMBOL_HINT')); ?>"></i>
							</div>
							<div class="col-3">
								<input class="form-control" value="<?php echo $this->object->params->get('currency'); ?>" id="fwfm-currency" type="text" name="config[currency]">
							</div>
							<div class="col-4">
								<?php echo fwfmHtmlfwView::radioGroup('config[currency_after]', $this->object->params->get('currency_after'), array(
									'wrapper_class' => 'mr-2',
									'buttons' => array(array(
										'active_class' => 'btn-info',
										'title' => fwfmText::_('FWFM_SETTINGS_Before'),
										'value' => 0
									), array(
										'active_class' => 'btn-default btn-warning',
										'title' => fwfmText::_('FWFM_SETTINGS_After'),
										'value' => 1
									))
								)); ?>
							</div>
						</div>
						<div class="form-group row">
							<div class="col-sm-5">
								<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_LOCAL_DATEFORMAT'); ?>
								<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_GENERAL_SECTION_LOCAL_DATEFORMAT_HINT')); ?>"></i>
							</div>
							<div class="col-sm-7">
								<?php echo fwfmHtml::_('select.genericlist', array(
									fwfmHtml::_('select.option', 'm/d/Y', 'm/d/Y', 'id', 'name'),
									fwfmHtml::_('select.option', 'd/m/Y', 'd/m/Y', 'id', 'name'),
									fwfmHtml::_('select.option', 'd.m.Y', 'd.m.Y', 'id', 'name'),
									fwfmHtml::_('select.option', 'Y-m-d', 'Y-m-d', 'id', 'name')
								), 'config[date_format]', ' class="form-control"', 'id', 'name', $this->object->params->get('date_format', 'm/d/Y')); ?>
							</div>
						</div>
					</div>
				</div>
            </div>
        </div>
        <div class="tab-pane" id="fwfm-settings-design" role="tabpanel">
            <div class="fwa-main-body">
                <div class="fwa-mb-cardbox">
					<div class="card">
        				<div class="card-header">
        					<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY'); ?></h4>
        					<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_HINT'); ?></div>
        				</div>
        				<div class="card-body">
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_THEME'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_THEME_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtml::_('select.genericlist', fwFoodMenuHelper::getThemesList(), 'config[template]', ' class="form-control"', 'id', 'name', $this->object->params->get('template')); ?>
        						</div>
        					</div>
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_SHOWTITLE'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_SHOWTITLE_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[display_category_title]', $this->object->params->get('display_category_title', '1'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('JYES'),
        									'value' => '1'
        								), array(
        									'active_class' => 'btn-danger',
        									'title' => fwfmText::_('JNO'),
        									'value' => '0'
        								))
        							)); ?>
        						</div>
        					</div>
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_SHORTDESCRIPTION'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_SHORTDESCRIPTION_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[display_category_shortdescription]', $this->object->params->get('display_category_shortdescription', '1'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_SHOW'),
        									'value' => '1'
        								), array(
        									'active_class' => 'btn-danger',
        									'title' => fwfmText::_('FWFM_HIDE'),
        									'value' => '0'
        								))
        							)); ?>
        						</div>
        					</div>
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_POSITION'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_POSITION_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[category_descr_position]', $this->object->params->get('category_descr_position', 'top'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_TOP'),
        									'value' => 'top'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_LEFT'),
        									'value' => 'left'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_RIGHT'),
        									'value' => 'right'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_BOTTOM'),
        									'value' => 'bottom'
        								))
        							)); ?>
        						</div>
        					</div>
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_ALIGNMENT'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_CATEGORY_ALIGNMENT_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[category_text_alignment]', $this->object->params->get('category_text_alignment', 'left'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_LEFT'),
        									'value' => 'left'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_CENTER'),
        									'value' => 'center'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_RIGHT'),
        									'value' => 'right'
        								))
        							)); ?>
        						</div>
        					</div>
<?php
$this->app->triggerEvent('onShowSettingsCategoryExtraFields', array('com_fwfoodmenu', $this));
?>
        				</div>
        			</div>
        			<div class="card">
        				<div class="card-header">
        					<h4 class="card-title"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_MEALLAYOUT'); ?></h4>
        					<div class="card-subtitle"><?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_MEALLAYOUT_HINT'); ?></div>
        				</div>
        				<div class="card-body">
							<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_MEALLAYOUT_MEALCONTENT'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_SETTINGS_TAB_DESIGN_SECTION_MEALLAYOUT_MEALCONTENT_HINT')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[meal_text_alignment]', $this->object->params->get('meal_text_alignment', 'left'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_LEFT'),
        									'value' => 'left'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_CENTER'),
        									'value' => 'center'
        								), array(
        									'active_class' => 'btn-success',
        									'title' => fwfmText::_('FWFM_RIGHT'),
        									'value' => 'right'
        								))
        							)); ?>
        						</div>
        					</div>
<?php
$this->app->triggerEvent('onShowSettingsMenuExtraFields', array('com_fwfoodmenu', $this));
?>
<?php /*
        					<div class="form-group row">
        						<div class="col-sm-5">
        							<?php echo fwfmText::_('FWFM_ALIGN_BY'); ?>
        							<i class="pull-right fal fa-question-circle" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_ALIGN_BY_DESCR')); ?>" title="<?php echo $this->escape(fwfmText::_('FWFM_ALIGN_BY_TITLE')); ?>"></i>
        						</div>
        						<div class="col-sm-7">
        							<?php echo fwfmHtmlfwView::radioGroup('config[align_by]', $this->object->params->get('align_by', 'meal'), array(
        								'wrapper_class' => 'mr-2',
        								'buttons' => array(array(
        									'active_class' => 'btn-success',
        									'title' => 'meal',
        									'value' => fwfmText::_('FWFM_MEALS')
        								), array(
        									'active_class' => 'btn-success',
        									'title' => 'category',
        									'value' => fwfmText::_('FWFM_CATEGORIES')
        								))
        							)); ?>
        						</div>
        					</div>
*/ ?>
        				</div>
        			</div>
                </div>
            </div>
        </div>
        <div class="tab-pane" id="fwfm-settings-plugins" role="tabpanel">
            <div class="fwa-main-body">
                <div class="fwa-mb-cardbox fwa-settings-plugins-list">

<?php
$this->app->triggerEvent('onShowSettingsExtraCardsRight', array('com_fwfoodmenu', $this));

?>
                </div>
            </div>
        </div>
    </div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="id" value="1" />
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
	(function($) {
    $('button.btn-outline-secondary:has(".fa-paint-brush")').click(function() {
        $(this).closest('.row').find('input').focus();
    });
	})(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
