<?php
/**
 * FW Food menu 4.4.1
 * @copyright C 2019 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

fwfmHtml::_('behavior.core');
fwfmHtml::_('formbehavior.chosen');

fwfmToolBarHelper::title(fwfmText::_('FWFM_ADMIN_LANG_TOOLBAR_TITLE'), ' fal fa-globe');
fwfmButtonsHelper::apply('apply', 'FWFM_DOC_ADMIN_LANG_TOOLBAR_BTN_SAVE');
fwfmButtonsHelper::custom('fal fa-copy', '', 'FWFM_DOC_ADMIN_LANG_TOOLBAR_BTN_OVERRIDES', 'copy', true);
fwfmButtonsHelper::custom('fal fa-download', '', 'FWFM_DOC_ADMIN_LANG_TOOLBAR_BTN_BACKUP', 'download', false);
if (!file_exists($this->path)) {
    fwfmButtonsHelper::custom('fal fa-upload', '', 'FWFM_DOC_ADMIN_LANG_TOOLBAR_BTN_INSTALLNATIVELANGUAGE', 'request', false);
}
echo fwfmLayoutHelper::render('common.menu_begin', array(
    'title' => fwfmText::_('FWFM_DOC_ADMIN_LANG'),
    'title_hint' => fwfmText::_('FWFM_DOC_ADMIN_LANG_HINT'),
	'view' => $this
), FWFM_PATH_COMPONENT);
?>
<form action="index.php?option=com_fwfoodmenu&view=translation" method="post" class="form-validate" name="adminForm" id="adminForm" enctype="multipart/form-data">
	<div class="fwa-filter-bar fwa-filter-bar-float clearfix">
		<div class="float-left w-25">
			<div class="input-group">
				<input class="form-control" placeholder="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_FILTER_SEARCH')); ?>" type="text" name="search" value="<?php echo $this->escape($this->search); ?>" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_FILTER_SEARCH_HINT')); ?>">
				<div class="input-group-append">
					<button class="btn btn-outline-secondary" type="button" onclick="with(this.form){search.value='';task.value='';submit();}" title="<?php echo $this->escape(fwfmText::_('FWFM_CLEAR')); ?>" data-toggle="tooltip"><i class="fal fa-times"></i></button>
				</div>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit" onclick="with(this.form){task.value='';submit();}" title="<?php echo $this->escape(fwfmText::_('FWFM_SEARCH')); ?>" data-toggle="tooltip"><i class="fal fa-search"></i></button>
				</div>
			</div>
		</div>
        <div class="float-left ml-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_FILTER_LANG_HINT')); ?>">
			<div class="select-style">
				<?php echo fwfmHtml::_('select.genericlist', $this->languages, 'lang', 'class="form-control form-control-sm advancedSelect" onchange="this.form.task.value=\'\';this.form.limitstart.value=0;this.form.submit();" style="float:none;"', 'id', 'name', $this->language); ?>
			</div>
		</div>
		<div class="float-left ml-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_FILTER_ADDON_HINT')); ?>">
			<div class="select-style">
				<?php echo fwfmHtml::_('select.genericlist', $this->extensions, 'extension', 'class="form-control form-control-sm advancedSelect" onchange="this.form.task.value=\'\';this.form.submit();"', 'element', 'name', $this->extension); ?>
			</div>
		</div>
<?php
if ($this->obj->type == 'component') {
?>
		<div class="float-left ml-3" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_FILTER_ADMINSITE_HINT')); ?>">
			<?php echo fwfmHtmlfwView::radioGroup('type', $this->type, array(
				'wrapper_class' => 'mr-2',
				'buttons' => array(array(
					'active_class' => 'btn-success',
					'title' => fwfmText::_('FWFM_FRONTEND'),
					'value' => 1
				), array(
					'active_class' => 'btn-success',
					'title' => fwfmText::_('FWFM_BACKEND'),
					'value' => 0
				))
			)); ?>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    $('input[name="type"]').change(function() {
        this.form.submit();
    });
    })(jQuery);
});
</script>
		</div>
<?php
}
?>
	</div>
    <div class="pt-4">
    <div class="alert alert-info mx-3">
        <?php echo fwfmText::_('FWFM_LANGUAGE_FILE_PATH'); ?>: <?php echo $this->path; ?>
    </div>
    <div class="alert alert-danger mx-3">
    <?php echo fwfmText::_('FWFM_LANGUAGE_OVERRIDES_FILE_PATH'); ?>: <?php echo $this->path_overrides; ?>
    </div>
    <div class="table-responsive">
	<table class="table table-striped">
		<thead>
			<tr>
                <th width="20px"><input name="toggle" value="" onclick="Joomla.checkAll(this);" type="checkbox" /></th>
				<th width="25%" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_SOURCE_HINT')); ?>"><?php echo fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_SOURCE'); ?> (en-GB)</th>
                <th width="30px" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_OVERRIDES_HINT')); ?>"><?php echo fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_OVERRIDES'); ?></th>
				<th data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_OUTCOME_HINT')); ?>"><?php echo fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_OUTCOME'); ?> (<?php echo $this->languages[$this->language]->tag; ?>)</th>
                <th width="10%" class="text-center" data-container="body" data-trigger="hover" data-toggle="popover" data-placement="top" data-content="<?php echo $this->escape(fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_TOOVERRIDES_HINT')); ?>"><?php echo fwfmText::_('FWFM_DOC_ADMIN_LANG_COLUMN_TOOVERRIDES') ?></th>
			</tr>
		</thead>
		<tbody id="fwre-translations-list">
<?php
$num = 0;
foreach ($this->data as $const=>$row) {
?>
			<tr>
                <td><?php echo fwfmHtml::_('grid.id', $num, $const); ?></td>
				<td>
                    <?php echo $row['src']; ?>
                    <div class="small text-muted mt-1">
                        <?php echo $this->escape($const); ?>
                    </div>
                </td>
                <td class="text-center"><?php if (isset($row['override'])) { ?><span data-trigger="hover" data-toggle="tooltip" data-placement="top" title="<?php echo fwfmText::_('FWFM_OVERRIDES_HINT'); ?>"><i class="text-danger fas fa-exclamation-triangle"></i></span><?php } ?></td>
				<td><input type="text" class="form-control" style="width:100%" name="lang_data[<?php echo $const; ?>]" value="<?php echo htmlspecialchars($row['trg']); ?>" /></td>
                <td class="text-center"><button class="btn btn-danger" type="button"><i class="far fa-copy mr-1"></i> <?php echo fwfmText::_('FWFM_BTN_TO_OVERRIDES') ?></button></td>
			</tr>
<?php
}
?>
		</tbody>
	</table>
    </div>
	<div class="row">
		<div class="col-md-2 mt-4 text-center">
			<?php echo $this->pagination->getResultsCounter(); ?>
		</div>
		<div class="col-md-8">
			<?php echo $this->pagination->getListFooter(); ?>
		</div>
		<div class="col-md-2 mt-4 text-center pagination-limit">
			<div class="d-inline-block mr-3">
				<?php echo $this->pagination->getLimitBox(); ?>
			</div>
		</div>
	</div>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="format" value="html" />
	<input type="hidden" name="layout" value="default" />
	<input type="hidden" name="boxchecked" value="0" />
    </div>
</form>
<script>
document.addEventListener('DOMContentLoaded', function() {
    (function($) {
    Joomla.submitbutton = function(pressbutton) {
        if (pressbutton) {
            with (document.adminForm) {
                if (pressbutton == 'download') {
                    layout.value = 'download';
                    format.value = 'raw';
                    task.value = '';
                    document.adminForm.submit();
                    layout.value = 'deafult';
                    format.value = 'html';
                } else if (pressbutton == 'request') {
                    var $wait = $('<i class="fas fa-sync fa-spin" style="font-size:1rem;vertical-align:middle;"></i>');
                    var $btn = $('#toolbar-upload .button-upload').attr('disabled', true).after($wait);
                    $.ajax({
                        dataType: 'json',
                        data: {
                            format: 'json',
                            view: 'translation',
                            layout: 'request_translation',
                            extension: '<?php echo $this->extension; ?>',
                            lang: '<?php echo $this->language ?>',
                            type: $('input[name="type"]').val()
                        }
                    }).done(function(data) {
                        $btn.attr('disabled', false);
                        $wait.remove();
                        if (data.msg) {
                            alert(data.msg);
                        }
                        if (data.result) {
                            location = 'index.php?option=com_fwfoodmenu&view=translation&extension=<?php echo $this->extension; ?>&type='+$('input[name="type"]').val();
                        }
                    });
                } else {
                    layout.value = 'deafult';
                    format.value = 'html';
                    task.value = pressbutton;
                    document.adminForm.submit();
                }
            }
        }
    }
    $('#fwre-translations-list button:has(".fa-copy")').click(function() {
        var $btn = $(this).attr('disabled', true);
        var $row = $btn.closest('tr');

        var id = $row.find('input[type="text"]').attr('name').replace('lang_data[', '').replace(']', '');
        var lang_data = {};
        lang_data[id] = $row.find('input[type="text"]').val();
        $.ajax({
            dataType: 'json',
            data: {
                format: 'json',
                view: 'translation',
                layout: 'copy_to_overrides',
                lang: '<?php echo $this->language ?>',
                type: $('input[name="type"]').val(),
                cid: [id],
                lang_data: lang_data
            }
        }).done(function(data) {
            $btn.attr('disabled', false);
            if (data.result) {
                var $icon = $('<i class="text-danger fal fa-exclamation-triangle"></i>');
                $btn.parent().prev().prev().html('<span data-trigger="hover" data-toggle="tooltip" data-placement="top" title="<?php echo fwfmText::_('FWFM_OVERRIDES_HINT', true); ?>"><i class="text-danger fas fa-exclamation-triangle"></i></span>');
            }
            if (data.msg) {
                alert(data.msg);
            }
        });
    });
    })(jQuery);
});
</script>
<?php
echo fwfmLayoutHelper::render('utilites.quick_categories', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('utilites.quick_meals', array('view'=>$this), FWFM_PATH_COMPONENT);
echo fwfmLayoutHelper::render('common.menu_end', array(), FWFM_PATH_COMPONENT);
