<?php
/*
 Plugin Name: FW Food Menu
 Description: Food Menu plugin
 Version: 4.4.1
 Author: Fastw3b
 Author URI: https://fastw3b.net/
 Plugin URI: https://fastw3b.net/products/food-menu
 */

@session_start();

define('FWFM_DIR', plugin_dir_path(__FILE__));
define('FWFM_URL', plugin_dir_url(__FILE__));

require_once('helpers/connector.php');
require_once(FWFM_DIR.'site/helpers/helper.php');

register_activation_hook( __FILE__, 'fw_plugin_activation');

if (is_admin()) {
	require_once('wp/admin.php');
} else {
	require_once('wp/site.php');
}

function fw_plugin_activation() {
	$db = fwfmFactory::getDBO();
	$path = FWFM_PATH_COMPONENT_ADMINISTRATOR.'/install.sql';
	if (file_exists($path)) {
		$buff = file_get_contents($path);
		$queries = fwFoodMenuHelper::splitSql($buff);
		foreach ($queries as $query) {
			if (trim($query)) {
				$db->setQuery($query);
				if (!$db->execute()) {
                    echo $db->getError();
                }
			}
		}
	}
	$path = FWFM_PATH_COMPONENT_ADMINISTRATOR.'/install.script.php';
	if (file_exists($path)) {
		include_once($path);
		$adaptor = null;
		$installer = new com_fwfoodmenuInstallerScript($adaptor);
		$installer->update($adaptor);
	}
    $tables = $db->getTableList();
    if (!in_array($db->getPrefix().'extensions', $tables)) {
        $db->setQuery('
CREATE TABLE `#__extensions` (
    `extension_id` Int( 11 ) AUTO_INCREMENT NOT NULL,
    `name` VarChar( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `type` VarChar( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `element` VarChar( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `folder` VarChar( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `client_id` TinyInt( 3 ) NOT NULL,
    `enabled` TinyInt( 3 ) NOT NULL DEFAULT 1,
    `access` Int( 10 ) UNSIGNED NOT NULL DEFAULT 1,
    `protected` TinyInt( 3 ) NOT NULL DEFAULT 0,
    `manifest_cache` Text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `params` Text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `custom_data` Text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `system_data` Text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
    `checked_out` Int( 10 ) UNSIGNED NOT NULL DEFAULT 0,
    `checked_out_time` DateTime NOT NULL DEFAULT \'0000-00-00 00:00:00\',
    `ordering` Int( 11 ) NULL DEFAULT 0,
    `state` Int( 11 ) NULL DEFAULT 0,
    PRIMARY KEY ( `extension_id` ),
    INDEX `element_clientid` ( `element`, `client_id` ),
    INDEX `element_folder_clientid` ( `element`, `folder`, `client_id` ),
    INDEX `extension` ( `type`, `element`, `folder`, `client_id` )
)');
        $db->execute();
    }

    $db->setQuery('SELECT COUNT(*) FROM `#__extensions` WHERE `element` = \'com_fwfoodmenu\'');
	if (!$db->loadResult()) {
		$db->setQuery('
INSERT INTO `#__extensions`(
    `name`,
    `type`,
    `element`,
    `folder`,
    `client_id`,
    `enabled`,
    `access`,
    `protected`,
    `manifest_cache`,
    `params`,
    `custom_data`,
    `system_data`,
    `checked_out`,
    `checked_out_time`,
    `ordering`,
    `state`
) VALUES (
    \'FW Food Menu\',
    \'component\',
    \'com_fwfoodmenu\',
    \'\',
    1,
    1,
    0,
    0,
    \'{"author":"Fastw3b - Websites & Mobile Apps"}\',
    \'{"additional_css":"#navbarTogglerTop .fwfm-mod-cart.fwcss {\r\n\tz-index: 1000;\r\n}\r\n.post-inner {\r\n\tmargin: 0 2rem;\r\n}"}\',
    \'\',
    \'\',
    0,
    \'2000-01-01 00:00:00\',
    0,
    0
 )');
		$db->execute();
	}
}
