<?php

if (!class_exists('fwfmHtmlSelect')) {
	class fwfmHtmlSelect {
		static function genericlist($arr, $name, $attribs = null, $key = 'value', $text = 'text', $selected = NULL, $idtag = false, $translate = false) {
			if (is_array($arr)) {
				reset($arr);
			}
	
			if (is_array($attribs)) {
				$attribs = fwfmArrayHelper::toString($attribs);
			 }
	
			$id = $name;
	
			if ($idtag) {
				$id = $idtag;
			}
	
			$id		= str_replace(array('[', ']'),'',$id);
	
			$html	= '<select name="'. $name .'" id="'. $id .'" '. $attribs .'>';
			$html	.= fwfmHtmlSelect::options($arr, $key, $text, $selected, $translate);
			$html	.= '</select>';
	
			return $html;
		}
		static function option($id, $name, $key = 'value', $val = 'text') {
			return (object)array(
				$key=>$id,
				$val=>$name
			);
		}
		static function options($arr, $key = 'value', $text = 'text', $selected = null, $translate = false) {
			$html = '';
	
			foreach ($arr as $i => $option) {
				$element =& $arr[$i]; // since current doesn't return a reference, need to do this
	
				$isArray = is_array($element);
				$extra	 = '';
				if ($isArray) {
					$k 		= $element[$key];
					$t	 	= $element[$text];
					$id 	= (isset($element['id']) ? $element['id'] : null);
					if(isset($element['disable']) && $element['disable']) {
						$extra .= ' disabled="disabled"';
					}
				} else {
					$k 		= $element->$key;
					$t	 	= $element->$text;
					$id 	= (isset($element->id) ? $element->id : null);
					if(isset($element->disable) && $element->disable) {
						$extra .= ' disabled="disabled"';
					}
				}
	
				// This is real dirty, open to suggestions,
				// barring doing a propper object to handle it
				if ($k === '<OPTGROUP>') {
					$html .= '<optgroup label="' . $t . '">';
				} else if ($k === '</OPTGROUP>') {
					$html .= '</optgroup>';
				} else {
					//if no string after hypen - take hypen out
					$splitText = explode(' - ', $t, 2);
					$t = $splitText[0];
					if(isset($splitText[1])){ $t .= ' - '. $splitText[1]; }
	
					//$extra = '';
					//$extra .= $id ? ' id="' . $arr[$i]->id . '"' : '';
					if (is_array($selected)) {
						foreach ($selected as $val) {
							$k2 = is_object($val) ? $val->$key : $val;
							if ($k == $k2) {
								$extra .= ' selected="selected"';
								break;
							}
						}
					} else {
						$extra .= ((string)$k == (string)$selected  ? ' selected="selected"' : '');
					}
	
					//if flag translate text
					if ($translate) {
						$t = fwfmText::_($t);
					}
	
					// ensure ampersands are encoded
					$k = fwfmFilterOutput::ampReplace($k);
					$t = fwfmFilterOutput::ampReplace($t);
	
					$html .= '<option value="'. $k .'" '. $extra .'>' . $t . '</option>';
				}
			}
			return $html;
		}
		public static function booleanlist($name, $attribs = array(), $selected = null, $yes = 'JYES', $no = 'JNO', $id = false) {
			$arr = array(
				fwfmHtml::_('select.option', '0', fwfmText::_($no)),
				fwfmHtml::_('select.option', '1', fwfmText::_($yes))
			);
	
			return fwfmHtml::_('select.radiolist', $arr, $name, $attribs, 'value', 'text', (int) $selected, $id);
		}
		public static function integerlist($start, $end, $inc, $name, $attribs = null, $selected = null, $format = '') {
			$start = (int) $start;
			$end   = (int) $end;
			$inc   = (int) $inc;
	
			$data = array();
	
			for ($i = $start; $i <= $end; $i += $inc) {
				$data[$i] = (object)array('id'=>$i, 'name'=>($format ? sprintf($format, $i) : $i));
			}
	
			return fwfmHtml::_('select.genericlist', $data, $name, $attribs, 'id', 'name', $selected);
		}
		public static function radiolist($data, $name, $attribs = null, $optKey = 'value', $optText = 'text', $selected = null, $idtag = false, $translate = false) {
			reset($data);
	
			if (is_array($attribs)) {
				$attribs = fwfmArrayHelper::toString($attribs);
			}
	
			$id_text = $idtag ? $idtag : $name;
	
			$html = '<div class="controls">';
	
			foreach ($data as $obj) {
				$k = $obj->$optKey;
				$t = $translate ? fwfmText::_($obj->$optText) : $obj->$optText;
				$id = (isset($obj->id) ? $obj->id : null);
	
				$extra = '';
				$id = $id ? $obj->id : $id_text . $k;
	
				if (is_array($selected)) {
					foreach ($selected as $val) {
						$k2 = is_object($val) ? $val->$optKey : $val;
	
						if ($k == $k2) {
							$extra .= ' selected="selected" ';
							break;
						}
					}
				} else {
					$extra .= ((string) $k == (string) $selected ? ' checked="checked" ' : '');
				}
	
				//$html .= "\n\t" . '<label for="' . $id . '" id="' . $id . '-lbl" class="radio btn">';
				$html .= "\n\t\n\t" . '<input type="radio" name="' . $name . '" id="' . $id . '" value="' . $k . '" ' . $extra
					. $attribs . ' >' . $t;
				//$html .= "\n\t" . '</label>';
			}
	
			$html .= "\n";
			$html .= '</div>';
			$html .= "\n";
	
			return $html;
		}
	}
}