<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

define('FWA_UPDATE_NAME', 'com_fwfoodmenu');
define('FWA_UPDATE_SERVER', 'https://fastw3b.net');

/* WP integration */
if (!defined('FWFM_LANGUAGE_SITE')) {
	define('FWFM_LANGUAGE_SITE', FWFM_PATH_SITE);
}
if (!defined('FWFM_LANGUAGE_ADMINISTRATOR')) {
	define('FWFM_LANGUAGE_ADMINISTRATOR', FWFM_PATH_ADMINISTRATOR);
}
if (!defined('FWFM_COMPONENT_SITE')) {
	define('FWFM_COMPONENT_SITE', FWFM_PATH_SITE.'/components/com_fwfoodmenu');
}
if (!defined('FWFM_COMPONENT_ADMINISTRATOR')) {
	define('FWFM_COMPONENT_ADMINISTRATOR', FWFM_PATH_ADMINISTRATOR.'/components/com_fwfoodmenu');
}
if (!defined('FWFM_ASSETS_URI')) {
	define('FWFM_ASSETS_URI', fwfmURI::root(true).'/components/com_fwfoodmenu/assets/');
}
if (!defined('FWFM_ADMIN_ASSETS_URI')) {
	define('FWFM_ADMIN_ASSETS_URI', fwfmURI::root(true).'/administrator/components/com_fwfoodmenu/assets/');
}

define('FWFM_ASSETS_PATH', FWFM_COMPONENT_SITE.'/assets/');


fwfmPluginHelper::importPlugin('fwfoodmenu');
fwfmPluginHelper::importPlugin('fwfoodmenutmpl');
fwfmPluginHelper::importPlugin('fwfoodmenutype');

if (!class_exists('fwfmParams')) {
	class fwfmParams {
		var $params = null;
		var $parent_categories = null;
		function __construct($params, $parent_categories=null) {
			$this->params = clone($params);
			if ($parent_categories) {
				$this->parent_categories = $parent_categories;
			}
		}
		function set($key, $val) {
			$this->params->set($key, $val);
		}
		function get($key, $def=null) {
			$val = $this->params->get($key, 'def');
			$is_size = in_array($key, array('image_size_x', 'image_size_y'));
			if ($is_size and !$val) {
				$val = 'def';
			}
			if ($val == 'def') {
				if ($this->parent_categories) {
					foreach ($this->parent_categories as $category) {
						$val = $category->params->get($key, 'def');
						if ($is_size and !$val) {
							$val = 'def';
						}
						if ($val != 'def') {
							return $val;
						}
					}
				}
				$app = fwfmFactory::getApplication();
				if ($app->isClient('site') and $app->input->getCmd('option') == 'com_fwfoodmenu') {
					$val = $app->getParams()->get($key, $def);
					if ($val == 'def') {
						$val = fwfmComponentHelper::getParams('com_fwfoodmenu')->get($key, $def);
					}
				} else {
					$val = fwfmComponentHelper::getParams('com_fwfoodmenu')->get($key, $def);
				}
			}
			return $val;
		}
	}
}

if (!class_exists('fwfmView')) {
	class fwfmView {
		var $layout = 'default';
		function getLayout() {
			return $this->layout;
		}
		function setLayout($layout) {
			$this->layout = $layout;
		}
		function loadTemplate($tmpl='') {
			$app = fwfmFactory::getApplication();
			if ($tmpl) $tmpl = '_'.$tmpl;
			$path = FWFM_PATH_SITE.'/templates/'.$app->getTemplate().'/html/com_fwfoodmenu/menu/'.$this->layout.$tmpl.'.php';
			ob_start();
			if (file_exists($path)) {
				include($path);
			} else {
				$path = FWFM_PATH_SITE.'/components/com_fwfoodmenu/views/menu/tmpl/'.$this->layout.$tmpl.'.php';
				include($path);
			}
			return ob_get_clean();
		}
		function display() {
			echo $this->loadTemplate();
		}
		function escape($text) {
			return htmlspecialchars($text);
		}
	}
}

jimport('joomla.plugin.plugin');

class fwfmfwfmPlugin extends fwfmPlugin {
	var $errors = array();
	function setError($msg) {
		$this->errors[] = $msg;
	}
	function getError($i = NULL, $toString = true) {
		if ($this->errors) {
			return $this->errors[count($this->errors) - 1];
		}
	}
	function getErrors() {
		return $this->errors;
	}
}

class fwfmMessages {
	static function getInstance() {
		static $instance = null;
		if (is_null($instance)) {
			$instance = new fwfmMessages();
		}
		return $instance;
	}
	function add($msg, $status='warning') {
		$messages = $this->getAll();
		$messages[] = (object)array(
			'msg' => $msg,
			'status' => $status
		);
		$this->set($messages);
	}
	function getLast() {
		if ($messages = $this->getAll()) {
			return $messages[count($messages)-1];
		}
	}
	function clearAll() {
		$this->set(array());
	}
	function set($messages) {
		fwfmFactory::getApplication()->setUserState('com_fwfoodmenu.messages', $messages);
	}
	function getAll() {
		return fwfmFactory::getApplication()->getUserState('com_fwfoodmenu.messages', array());
	}
}

class fwfmButtons {
	var $buttons = array();
	static function getInstance() {
		static $btns;
		if (!is_object($btns)) {
			$btns = new fwfmButtons;
		}
		return $btns;
	}
	function addButton($icon, $color, $alt, $task, $listSelect) {
		$btn = (object)array(
			'icon' => $icon,
			'color' => $color,
			'alt' => fwfmText::_($alt),
			'task' => $task,
			'listSelect' => $listSelect
		);
		$this->buttons[] = $btn;
	}
	function getButtons() {
		return $this->buttons;
	}
}
class fwfmButtonsHelper {
	static function addNew($task='add', $alt="JTOOLBAR_APPLY") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-plus-circle', $color='green', $alt, $task, $listSelect=false);
	}
	static function custom($icon, $color, $alt, $task, $listSelect) {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon, $color, $alt, $task, $listSelect);
	}
	static function editList($task='edit', $alt="JTOOLBAR_EDIT") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-edit', $color='', $alt, $task, $listSelect=true);
	}
	static function deleteList($listSelect='', $task='remove', $alt="JTOOLBAR_DELETE") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-trash-alt', $color='red', $alt, $task, $listSelect);
	}
	static function publish($task='publish', $alt="JTOOLBAR_PUBLISH", $listSelect=true) {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-check-circle', $color='', $alt, $task, $listSelect);
	}
	static function unpublish($task='unpublish', $alt="JTOOLBAR_UNPUBLISH", $listSelect=true) {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-times-circle', $color='', $alt, $task, $listSelect);
	}
	static function apply($task='apply', $alt="JTOOLBAR_APPLY") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-edit', $color='green', $alt, $task, $listSelect=false);
	}
	static function save($task='save', $alt="JTOOLBAR_SAVE") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-save', $color='', $alt, $task, $listSelect=false);
	}
	static function save2New($task='save2new', $alt="JTOOLBAR_SAVE_NEW") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-save', $color='', $alt, $task, $listSelect=false);
	}
	static function save2Copy($task='save2copy', $alt="JTOOLBAR_SAVE_COPY") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-save', $color='', $alt, $task, $listSelect=false);
	}
	static function cancel($task='cancel', $alt="JTOOLBAR_CANCEL") {
		$btns = fwfmButtons::getInstance();
		$btns->addButton($icon='fal fa-times', $color='', $alt, $task, $listSelect=false);
	}
}

class fwFoodMenuHelper {
	static function triggerEvent($event, $params) {
		$data = fwfmFactory::getApplication()->triggerEvent($event, $params);
		static $modals = array();
		$plugins = array(
			'plg_fwfoodmenu_cart',
			'plg_fwfoodmenu_cascading',
			'plg_fwfoodmenu_categorypdf',
			'plg_fwfoodmenu_color',
			'plg_fwfoodmenu_columns',
			'plg_fwfoodmenu_image',
			'plg_fwfoodmenu_mealbadges',
			'plg_fwfoodmenu_multilingual',
			'plg_fwfoodmenu_prices',
			'plg_fwfoodmenu_seobooster',
		);
		$path = FWFM_COMPONENT_ADMINISTRATOR.'/layouts/addons/';
		foreach ($plugins as $plugin) {
			$buff = explode('_', $plugin);
			if (!fwFoodMenuHelper::pluginEnabled($buff[count($buff) - 1]) and file_exists($path.$plugin.'/'.strtolower($event).'.php')) {
				if (!isset($modals[$plugin])) {
					if (file_exists($path.$plugin.'/modal_advert.php')) {
?>
<div class="modal fade" id="fwfm-modal-advert-<?php echo esc_attr($plugin); ?>" tabindex="-1" role="dialog" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel"><?php echo fwfmText::_('FWFM_ADDON_'.$plugin); ?></h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <?php include($path.$plugin.'/modal_advert.php'); ?>
      </div>
    </div>
  </div>
</div>
<script>
document.addEventListener('DOMContentLoaded', function () {
    (function ($) {
		$('#fwfm-modal-advert-<?php echo esc_js($plugin); ?>').on('show', function() {
			$(this).addClass('show');
		}).on('hide', function() {
			$(this).removeClass('show');
		});
    })(jQuery);
});
</script>
<?php
					}
					$modals[$plugin] = true;
				}
?>
<div class="fwa-modal-advert" data-target="#fwfm-modal-advert-<?php echo esc_attr($plugin); ?>" data-toggle="modal"><?php include($path.$plugin.'/'.strtolower($event).'.php'); ?></div>
<?php
			}
		}
		return $data;
	}
	static function stripTags($text, $limit=null, $show_counter=false) {
		if (!$limit) return;
		$text = strip_tags(preg_replace(array('#\{[^\}]+\}#', '#^<p>|</p>$#', '#\r\n\r\n#', '#\n\n#', '#\&nbsp;#'), array('', '', "\n", "\n", ' '), trim($text)));
		if (is_numeric($limit) and $limit > 0 and mb_strlen($text) > $limit) {
			$text = rtrim(mb_substr($text, 0, $limit), '.').'&hellip;'.($show_counter?(' ['.mb_strlen($text).']'):'');
		}
		return nl2br($text);
	}
	static function messageEscape($text) {
		return addcslashes(str_replace(array("\r\n", "\n", "\r"), '<br/>', $text), "'");
	}
	static function addMessage($msg, $status='warning') {
		$messages = fwfmMessages::getInstance();
		$messages->add($msg, $status);
	}
	static function getMessage() {
		$messages = fwfmMessages::getInstance();
		return $messages->getLast();
	}
	static function getMessages() {
		$messages = fwfmMessages::getInstance();
		return $messages->getAll();
	}
	static function clearMessages() {
		$messages = fwfmMessages::getInstance();
		return $messages->clearAll();
	}
	static function encodeDate($date) {
		if (!$date) return;
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$buff = explode(' ', $date, 2);
		$encoded_date = '';
		switch ($params->get('date_format')) {
			case 'd/m/Y' :
				$parts = explode('/', $buff[0]);
				if (count($parts) == 3) {
					$encoded_date = $parts[2].'-'.$parts[1].'-'.$parts[0];
				}
			break;
			case 'd.m.Y' :
				$parts = explode('.', $buff[0]);
				if (count($parts) == 3) {
					$encoded_date = $parts[2].'-'.$parts[1].'-'.$parts[0];
				}
			break;
			case 'Y-m-d' :
				$parts = explode('-', $buff[0]);
				if (count($parts) == 3) {
					$encoded_date = $parts[0].'-'.$parts[1].'-'.$parts[2];
				}
			break;
			default :
				$parts = explode('/', $buff[0]);
				if (count($parts) == 3) {
					$encoded_date = $parts[2].'-'.$parts[0].'-'.$parts[1];
				}
		}
		return $encoded_date.(empty($buff[1])?'':(' '.$buff[1]));
	}
	static function colorpicker() {
		fwfmHtml::_('jquery.framework');
		fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/jquery.minicolors.css');
		fwfmHtml::script('components/com_fwfoodmenu/assets/js/jquery.minicolors.min.js');
		fwfmFactory::getDocument()->addScriptDeclaration('
		document.addEventListener(\'DOMContentLoaded\', function() {
			(function($) {
			$(\'.minicolors\').each(function() {
				$(this).minicolors({
					control: $(this).attr(\'data-control\') || \'hue\',
					format: $(this).attr(\'data-validate\') === \'color\'
						? \'hex\'
						: ($(this).attr(\'data-format\') === \'rgba\'
							? \'rgb\'
							: $(this).attr(\'data-format\'))
						|| \'hex\',
					keywords: $(this).attr(\'data-keywords\') || \'\',
					opacity: $(this).attr(\'data-format\') === \'rgba\' ? true : false || false,
					position: $(this).attr(\'data-position\') || \'default\',
					theme: \'bootstrap\'
				});
			});
			})(jQuery);
		});');
	}
	static function getEditor() {
		$editor = fwfmFactory::getConfig()->get('editor');
		return fwfmEditor::getInstance($editor);
	}
	static function splitSql($sql) {
		$start = 0;
		$open = false;
		$char = '';
		$end = strlen($sql);
		$queries = array();

		for ($i = 0; $i < $end; $i++)
		{
			$current = substr($sql, $i, 1);

			if (($current == '"' || $current == '\''))
			{
				$n = 2;

				while (substr($sql, $i - $n + 1, 1) == '\\' && $n < $i)
				{
					$n++;
				}

				if ($n % 2 == 0)
				{
					if ($open)
					{
						if ($current == $char)
						{
							$open = false;
							$char = '';
						}
					}
					else
					{
						$open = true;
						$char = $current;
					}
				}
			}

			if (($current == ';' && !$open) || $i == $end - 1)
			{
				$queries[] = substr($sql, $start, ($i - $start + 1));
				$start = $i + 1;
			}
		}

		return $queries;
	}
	static function checkClientContacts() {
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$update_code = $params->get('update_code');
		$verified_code = $params->get('verified_code');

		$user_name = $params->get('user_name');
		$user_avatar = $params->get('user_avatar');
		$user_email = $params->get('user_email');

		if ($update_code and $update_code == $verified_code and (!$user_name or !$user_avatar or !$user_email)) {
			if ($buff = fwFoodMenuHelper::request(FWA_UPDATE_SERVER.'/index.php?option=com_fwsales&view=updates&layout=verify_code&format=raw&package='.FWA_UPDATE_NAME.'&code='.urlencode($update_code))) {
				$tmp = json_decode($buff);
				if ($tmp) {
					if (!empty($tmp->msg)) {
						fwfmFactory::getApplication()->enqueueMessage($tmp->msg, 'error');
					}
					$params->set('user_name', empty($tmp->user_name)?'':$tmp->user_name);
					$params->set('user_avatar', empty($tmp->user_avatar)?'':$tmp->user_avatar);
					$params->set('user_email', empty($tmp->user_email)?'':$tmp->user_email);
					fwFoodMenuHelper::storeConfig($params);
				}
			}
		}
	}
	static function getCategory($cid) {
		$cats = fwFoodMenuHelper::loadCategories();
		foreach ($cats as $cat) {
			if ($cat->id == $cid) {
				return $cat;
			}
		}
	}
	static function getCategoryParams($cid) {
		static $data = array();
		if (!isset($data[$cid])) {
			$cats = fwFoodMenuHelper::loadCategories();
			$params = null;
			if ($cid) {
				foreach ($cats as $cat) {
					if ($cat->id == $cid) {
						$data[$cid] = new fwfmParams($cat->params, fwFoodMenuHelper::getParentCategories($cat->parent));
						break;
					}
				}
			}
			if (!isset($data[$cid])) {
				$data[$cid] = new fwfmParams(new fwfmRegistry);
			}
		}
		return $data[$cid];
	}
	static function getParentCategories($id) {
		$categories = fwFoodMenuHelper::loadCategories();
		$data = array();
		if ($id) {
			foreach ($categories as $category) {
				if ($category->id == $id) {
					$data[$category->parent] = $category;
				}
			}
			do {
				$found = false;
				$ids = array_keys($data);
				foreach ($categories as $category) {
					if (!isset($data[$category->parent]) and in_array($category->id, $ids)) {
						$data[$category->parent] = $category;
						$found = true;
					}
				}
			} while($found);
		}
		return $data;
	}
	static function getInstalledLanguages() {
		static $languages;
		if (!is_array($languages)) {
			$buff = fwfmLanguageHelper::getKnownLanguages();
			foreach ($buff as $row) {
				$lang = new stdclass;
				$lang->id = $row['tag'];
				$lang->tag = $row['tag'];
				$lang->name = $row['name'];
				$languages[$row['tag']] = $lang;
			}
		}
		return $languages;
	}
	static function getLanguage() {
		static $lang = null;
		if (!$lang) {
			$db = fwfmFactory::getDBO();
			$app = fwfmFactory::getApplication();
			$lang = $app->getUserStateFromRequest('com_fwfoodmenu.language', 'lang');
			if ($lang and strlen($lang) == 2) {
				$db->setQuery('SELECT `lang_code` FROM `#__languages` WHERE `sef` = '.$db->quote($lang));
				$lang = $db->loadResult();
			}
			if (!$lang) {
				$lang  = fwfmFactory::getLanguage()->getTag();
			}
			if (!$lang or ($lang and !in_array($lang, array_keys(fwFoodMenuHelper::getInstalledLanguages())))) {
				$db->setQuery('SELECT `lang_code` FROM `#__languages` WHERE `published` = 1 AND `ordering` = 1');
				$lang = $db->loadResult();
				if (!$lang) {
					$lang = 'en-GB';
				}
			}
		}
		return $lang;
	}
	static function getJoomlaLanguage() {
		$lang = fwFoodMenuHelper::getLanguage();
		return fwfmLanguage::getInstance($lang);
	}
	static function storeConfig($params) {
		$cache = fwfmFactory::getCache('_system', 'callback');
    	$cache->clean();

    	$db = fwfmFactory::getDBO();
    	$db->setQuery('UPDATE `#__extensions` SET params = '.$db->quote($params->toString()).' WHERE `element` = \'com_fwfoodmenu\' AND `type` = \'component\'');
    	return $db->execute();
	}
    static function loadPlugins() {
        static $plugins;
        if (!is_array($plugins)) {
			$plugins = array();

            $db = fwfmFactory::getDBO();
            $db->setQuery('
SELECT
    `element`,
    `enabled`,
	`folder`
FROM
    `#__extensions`
WHERE
    `type` = \'plugin\'
    AND
    `folder` IN (\'fwfoodmenu\', \'fwfoodmenutmpl\')');
            if ($data = $db->loadObjectList()) {
				foreach ($data as $row) {
					if (!isset($plugins[$row->folder])) {
						$plugins[$row->folder] = array();
					}
					$plugins[$row->folder][$row->element] = $row;
				}
			}
        }
        return $plugins;
    }
    static function pluginInstalled($name, $type = 'fwfoodmenu') {
        $plugins = fwFoodMenuHelper::loadPlugins();
        return isset($plugins[$type][$name]);
    }
    static function pluginEnabled($name, $type = 'fwfoodmenu') {
        $plugins = fwFoodMenuHelper::loadPlugins();
        if (!empty($plugins[$type][$name])) {
            return $plugins[$type][$name]->enabled;
        }
	}
	static function pluginDisabledViaMenu($plugin) {
		$app = fwfmFactory::getApplication();
		if ($app->isClient('administrator')) return;
		$params = $app->getParams();
		if ($params->get('show_addons_menu_settings')) {
			$disabled_addons = $params->get('plugins', array($plugin=>1));
			return empty($disabled_addons[$plugin]);
		}
	}
	static function getThemesList() {
		$themes = array(
			fwfmHtml::_('select.option', 'common', fwfmText::_('FWFM_THEME_DEFAULT'), 'id', 'name')
		);
		$db = fwfmFactory::getDBO();
		$db->setQuery("SELECT name, `element` FROM `#__extensions` WHERE `type` = 'plugin' AND `folder` = 'fwfoodmenutmpl' AND `enabled` = 1");
		if ($list = $db->loadObjectList()) {
			$lang = fwfmFactory::getLanguage();
			foreach ($list as $row) {
				$lang->load('plg_fwfoodmenutmpl_'.$row->element);
				$themes[] = fwfmHtml::_('select.option', $row->element, fwfmText::_($row->name), 'id', 'name');
			}
		}
		return $themes;
	}
	static function loadAdminStyles() {
		fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/bootstrap.css', array('version'=>'v=100'));
		fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/all.min.css', array('version'=>'v=101'));
		fwfmHtml::stylesheet('administrator/components/com_fwfoodmenu/assets/css/fw-back-end.css', array('version'=>'v=103'));
		fwfmHtml::stylesheet('administrator/components/com_fwfoodmenu/assets/css/fwfm-admin.css', array('version'=>'v=107'));
		$doc = fwfmFactory::getDocument();
		if (method_exists($doc, 'getWebAssetManager')) {
			$doc->getWebAssetManager()->useScript('bootstrap.modal');
			$doc->getWebAssetManager()->useScript('bootstrap.popover');
		}
	}
	static function loadSiteStyles() {
		if (!defined('FWFM_STYLES_LOADED')) {
			define('FWFM_STYLES_LOADED', true);
			$com_params = fwfmComponentHelper::getParams('com_fwfoodmenu');
			if (!$com_params->get('do_not_load_bootstrap')) {
				fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/bootstrap.css', array('version'=>'v=100'));
				fwfmHtml::_('jquery.framework');
/*					fwfmHtml::script('components/com_fwfoodmenu/assets/js/tether.min.js');
				fwfmHtml::script('components/com_fwfoodmenu/assets/js/popper.js');
				fwfmHtml::script('components/com_fwfoodmenu/assets/js/bootstrap.min.js');*/
			}
			if (!$com_params->get('do_not_load_awesome')) {
				fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/all.min.css');
			}
			fwfmHtml::stylesheet('components/com_fwfoodmenu/assets/css/fwfm-design-styles.css', array('version'=>'v=104'));
			$buff = $com_params->get('additional_css');
			$font_size = (int)$com_params->get('font_size', 16);
			if (!$font_size) $font_size = 16;
			$buff = 'html {font-size: '.$font_size.'px;}'.$buff;
			$doc = fwfmFactory::getDocument();
			$doc->addStyleDeclaration($buff);
			if (method_exists($doc, 'getWebAssetManager')) {
				$doc->getWebAssetManager()->useScript('bootstrap.modal');
				$doc->getWebAssetManager()->useScript('bootstrap.popover');
			}
		}
	}
    static function loadTemplate($view, $displayData, $path=null) {
        $app = fwfmFactory::getApplication();

        $tmpl = '';
		$com_path = FWFM_COMPONENT_SITE.'/layouts/';
		if (is_null($path)) {
			$path = FWFM_PATH_SITE.'/plugins/fwfoodmenutmpl/';
			$tmpl = $app->input->getCmd('t', $displayData['view']->params->get('template'));
/*echo $tmpl.' '.$view;*/
			if (!$tmpl or ($tmpl and !is_dir($path.$tmpl))) {
				$tmpl = 'common';
				$path = $com_path;
			}
			fwFoodMenuHelper::loadSiteStyles();
			if (file_exists($path.$tmpl.'/assets/css/fwfm-design-styles.css')) {
				fwfmHtml::stylesheet('plugins/fwfoodmenutmpl/'.$tmpl.'/assets/css/fwfm-design-styles.css');
			}
		}

        $buff = explode('.', $view);
        $filename = array_pop($buff).'.php';
        $view_path = implode('/', $buff);

        $full_path = $path.$tmpl.'/'.$view_path.'/'.$filename;
        $tmpl_found = file_exists($full_path);
        if (!$tmpl_found and $tmpl != 'common') {
            $full_path = $com_path.'common/'.$view_path.'/'.$filename;
            $tmpl_found = file_exists($full_path);
        }
        if ($tmpl_found) {
            ob_start();
            include($full_path);
            return ob_get_clean();
        } else {
            return 'template '.$tmpl.', view '.$view.' not found';
        }
    }
	static function fixDescriptionImagesLinks($text) {
		if (preg_match_all('#(src\=")(images/)#', $text, $matches, PREG_SET_ORDER)) {
			$base = fwfmURI::root(true).'/';
			foreach ($matches as $match) {
				$text = str_replace($match[0], $match[1].$base.$match[2], $text);
			}
		}
		return $text;
	}
	static function escape($text) {
		return htmlspecialchars($text);
	}
	static function straightenTree($cat, $level = 1) {
		$result = array();

		$header_added = false;

		if (!empty($cat->_children)) {
			foreach ($cat->_children as $child) {
				if (!$child->published) {
					continue;
				}
				if ($buff = fwFoodMenuHelper::straightenTree($child, $level + 1)) {
					if (!$header_added and $level > 1) {
						$header_added = true;
						$result[] = (object)array(
							'id' => $cat->id,
							'parent' => $cat->parent,
							'image' => $cat->image,
							'type' => 'category',
							'level' => min($level, 4),
							'name' => $cat->name,
							'alias' => $cat->alias,
							'_menu_qty' => $cat->_menu_qty,
							'pdf_menu' => $cat->pdf_menu,
							'published' => $cat->published,
							'description' => $cat->description,
							'short_description' =>$cat->short_description,
							'params' => $cat->params
						);
					}
					$result = array_merge($result, $buff);
				}
			}
		}

		if (!$header_added and $level > 1) {
			$result[] = (object)array(
				'id' => $cat->id,
				'parent' => $cat->parent,
				'image' => $cat->image,
				'type' => 'category',
				'level' => min($level, 4),
				'name' => $cat->name,
				'alias' => $cat->alias,
				'_menu_qty' => $cat->_menu_qty,
				'pdf_menu' => $cat->pdf_menu,
				'published' => $cat->published,
				'description' => $cat->description,
				'short_description' =>$cat->short_description,
				'params' => $cat->params
			);
		}
		if (!empty($cat->_items)) {
			foreach ($cat->_items as $item) {
				$result[] = $item;
			}
		}
		return $result;
	}
	static function loadCategoriesTree($sel_cats) {
		static $cats;
		if (!is_array($cats)) {
			$items = fwFoodMenuHelper::loadCategories();
			$children = array();
		    foreach($items as $i=>$item) {
//				$items[$i]->params = new fwfmRegistry($item->params);
		        $children[$item->parent][] = $item;
			}
		    foreach($items as $item) {
				if (isset($children[$item->id])) {
					$item->_children = $children[$item->id];
				}
			}
		    $cats = $children[0];
		}
		if ($sel_cats and !in_array(0, $sel_cats)) {
			return fwFoodMenuHelper::getSelectedCategories($cats, $sel_cats);
		} else {
			return $cats;
		}
	}
	static function getCategoriesIdBelow($cats, $ids) {
		foreach ($cats as $cat) {
			if (!in_array($cat->id, $ids)) {
				$ids[] = $cat->id;
			}
			if (!empty($cat->_children) and $buff = fwFoodMenuHelper::getCategoriesIdBelow($cat->_children, array())) {
				$ids = array_merge($ids, $buff);
			}
		}
		return $ids;
	}
	static function getSelectedCategories($cats, $sel_cats) {
		$data = array();
		if ($cats) {
			foreach ($cats as $cat) {
				if (in_array($cat->id, $sel_cats)) {
					$data[] = $cat;
				} elseif (!empty($cat->_children) and $buff = fwFoodMenuHelper::getSelectedCategories($cat->_children, $sel_cats)) {
					$data = array_merge($data, $buff);
				}
			}
		}
		return $data;
	}
	static function loadCategories() {
		static $cats;
		if (!is_array($cats)) {
			$db = fwfmFactory::getDBO();
			$db->setQuery('
SELECT
    c.*,
	(SELECT COUNT(*) FROM #__fwfoodmenu_category AS cc WHERE cc.parent = c.id) AS _cats_qty,
	(SELECT COUNT(*) FROM #__fwfoodmenu_menu AS m WHERE m.category_id = c.id) AS _menu_qty
FROM
    #__fwfoodmenu_category AS c
ORDER BY
	`parent`,
	ordering');
			if ($cats = $db->loadObjectList('id')) {
				$ids = array();
				foreach ($cats as $i=>$row) {
					$ids[$row->id] = $row->id;
					$cats[$i]->params = new fwfmRegistry($row->params);
				}
				fwfmFactory::getApplication()->triggerEvent('onCalculateCategoryListExtraFields', array('com_fwfoodmenu', &$cats, $ids));
			}
		}
		return $cats;
	}
	static function countCategoriesQty($cid) {
		$cats = fwFoodMenuHelper::loadCategories();
		$qty = 0;
		foreach ($cats as $cat) {
			if ($cat->id == $cid) {
				$qty += $cat->_cats_qty;
			}
			if ($cat->parent == $cid) {
				$qty += fwFoodMenuHelper::countCategoriesQty($cat->id);
			}
		}
		return $qty;
	}
	static function countMealsQty($cid) {
		$cats = fwFoodMenuHelper::loadCategories();
		$qty = 0;
		foreach ($cats as $cat) {
			if ($cat->id == $cid) {
				$qty += $cat->_menu_qty;
			}
			if ($cat->parent == $cid) {
				$qty += fwFoodMenuHelper::countMealsQty($cat->id);
			}
		}
		return $qty;
	}
	static function checkPrevCategory($c) {
		$items = fwFoodMenuHelper::loadCategories();
		$cats = array();
		foreach ($items as $item) {
			if ($item->parent == $c->parent) {
				$cats[$item->id] = $item;
			}
		}

		$prev_id = 0;
		foreach ($cats as $cat) {
			if ($cat->id == $c->id) {
				return !(!$prev_id or ($prev_id and $cats[$prev_id]->parent != $cat->parent));
			}
			$prev_id = $cat->id;
		}
	}
	static function checkNextCategory($c) {
		$items = fwFoodMenuHelper::loadCategories();
		$cats = array();
		foreach ($items as $item) {
			if ($item->parent == $c->parent) {
				$cats[$item->id] = $item;
			}
		}

		$ids = array_keys($cats);
		$next_id = 0;
		for ($i = count($ids) - 1; $i >= 0; $i--) {
			if ($cats[$ids[$i]]->id == $c->id) {
				return !(!$next_id or ($next_id and $cats[$next_id]->parent != $cats[$ids[$i]]->parent));
			}
			$next_id = $cats[$ids[$i]]->id;
		}
	}
	static function findUnicFilename($path, $ext) {
		$filename = '';
		do {
			$filename = md5(microtime().rand()).'.'.$ext;
		} while(file_exists($path.$filename));
		return $filename;
	}
	static function humanFileSize($val) {
		if ($val > 1073741824) return round($val / 1073741824, 2).' Gb';
		if ($val > 1048576) return round($val / 1048576, 2).' Mb';
		elseif ($val > 1024) return round($val / 1024, 2).' Kb';
		elseif ($val and is_numeric($val)) return $val.' b';
		else return $val;
	}
	static function getIniSize($name) {
		$val = ini_get($name);
		if (preg_match('/^(\d+)([MK])$/', $val, $matches)) {
			if ($matches[2] == 'M') $val = $matches[1] * 1024 * 1024;
			elseif ($matches[2] == 'K') $val = $matches[1] * 1024;
		}
		return $val;
	}
	static function formatPrice($price) {
		if (!is_numeric($price)) return $price;
		$params = fwfmComponentHelper::getParams('com_fwfoodmenu');
		$currency = $params->get('currency');
		if (!$currency) return number_format($price, 2);
		if ($params->get('currency_after')) {
			if ($params->get('hide_ending_ziro')) {
				return rtrim(rtrim(number_format($price, 2), '0'), '.,').' '.$currency;
			} else {
				return number_format($price, 2).' '.$currency;
			}
		} else {
			if ($params->get('hide_ending_ziro')) {
				return $currency.rtrim(rtrim(number_format($price, 2), '0'), '.,');
			} else {
				return $currency.number_format($price, 2);
			}
		}
	}
	static function checkMenuImage($menu) {
		return ($menu->image and file_exists(FWFM_PATH_SITE.'/media/com_fwfoodmenu/menu/'.$menu->image));
	}
	static function getMenuImageUrl($menu, $direct_link=false) {
		if (fwFoodMenuHelper::checkMenuImage($menu)) {
			return ($direct_link?fwfmURI::root(false):(fwfmURI::root(true).'/')).'media/com_fwfoodmenu/menu/'.$menu->image;
		}
		return 'data:image/svg+xml;charset=UTF-8,%3C%3Fxml-stylesheet%20rel%3D%22stylesheet%22%20href%3D%22http%3A%2F%2Fnetdna.bootstrapcdn.com%2Ffont-awesome%2F4.1.0%2Fcss%2Ffont-awesome.min.css%22%3F%3E%0A%3C%3Fxml-stylesheet%20rel%3D%22stylesheet%22%20href%3D%22http%3A%2F%2Ffonts.googleapis.com%2Fcss%3Ffamily%3DPacifico%22%3F%3E%3Csvg%20width%3D%22400%22%20height%3D%22400%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20viewBox%3D%220%200%20400%20400%22%20preserveAspectRatio%3D%22none%22%3E%3Cdefs%3E%3Cstyle%20type%3D%22text%2Fcss%22%3E%23holder_1690f886afe%20text%20%7B%20fill%3A%23AAAAAA%3Bfont-weight%3Abold%3Bfont-family%3AArial%2C%20Helvetica%2C%20Open%20Sans%2C%20sans-serif%2C%20monospace%3Bfont-size%3A20pt%20%7D%20%3C%2Fstyle%3E%3C%2Fdefs%3E%3Cg%20id%3D%22holder_1690f886afe%22%3E%3Crect%20width%3D%22400%22%20height%3D%22400%22%20fill%3D%22%23EEEEEE%22%3E%3C%2Frect%3E%3Cg%3E%3Ctext%20x%3D%22148.0234375%22%20y%3D%22209%22%3E400x400%3C%2Ftext%3E%3C%2Fg%3E%3C%2Fg%3E%3C%2Fsvg%3E';
	}
	static function getItemid($view='menu', $id=null) {
		$menu = fwfmMenu::getInstance('site');
		$item = null;
		if ($items = $menu->getItems('link', 'index.php?option=com_fwfoodmenu&view='.$view)) {
			if (!is_null($id)) {
				foreach ($items as $menuItem) {
					if (in_array($id, (array)$menuItem->params->get('category_id'))) {
						$item = $menuItem;
						break;
					}
				}
			}
			if (!$item) $item = $items[0];
		}

		if ($item) return $item->id;
	}
	static function request($url, $method='get', $data=null) {
		$method = strtolower($method);
		if (!in_array($method, array('get', 'post', 'put', 'delete'))) {
			$method = 'get';
		}
		if ($data and in_array($method, array('get', 'delete'))) {
			$buff = http_build_query($data);
			$url .= (strpos($url, '?')===false?'?':'&').$buff;
		}
		$http = fwfmHttpFactory::getHttp();
		$result = '';
		switch ($method) {
			case 'get' :
				$result = $http->get($url);
			break;
			case 'post' :
				$result = $http->post($url, $data);
			break;
			case 'put' :
				$result = $http->put($url, $data);
			break;
			case 'delete' :
				$result = $http->delete($url);
			break;
		}
		return $result?$result->body:'';
	}
	static function getCategoryAlias($id, $name) {
		$lang = fwFoodMenuHelper::getJoomlaLanguage();
		$name = fwfmFilterOutput::stringURLSafe($lang?$lang->transliterate($name):$name);
		if (!$name) return '';
		$db = fwfmFactory::getDBO();
		$index = 0;
		$alias = '';
		do {
			$alias = $name.($index?('-'.$index):'');
			$db->setQuery('SELECT COUNT(*) FROM `#__fwfoodmenu_category` WHERE alias = '.$db->quote($alias).' AND id <> '.(int)$id);
			$index++;
		} while ($db->loadResult());
		return $alias;
	}
}
if (!class_exists('fwfmStringHelper')) {
	class fwfmStringHelper {
		public static function strcasecmp($str1, $str2, $locale = false)
		{
			if ($locale)
			{
				// Get current locale
				$locale0 = setlocale(LC_COLLATE, 0);
	
				if (!$locale = setlocale(LC_COLLATE, $locale))
				{
					$locale = $locale0;
				}
	
				// See if we have successfully set locale to UTF-8
				if (!stristr($locale, 'UTF-8') && stristr($locale, '_') && preg_match('~\.(\d+)$~', $locale, $m))
				{
					$encoding = 'CP' . $m[1];
				}
				elseif (stristr($locale, 'UTF-8') || stristr($locale, 'utf8'))
				{
					$encoding = 'UTF-8';
				}
				else
				{
					$encoding = 'nonrecodable';
				}
	
				// If we successfully set encoding it to utf-8 or encoding is sth weird don't recode
				if ($encoding == 'UTF-8' || $encoding == 'nonrecodable')
				{
					return strcoll(utf8_strtolower($str1), utf8_strtolower($str2));
				}
	
				return strcoll(
					static::transcode(utf8_strtolower($str1), 'UTF-8', $encoding),
					static::transcode(utf8_strtolower($str2), 'UTF-8', $encoding)
				);
			}
	
			return utf8_strcasecmp($str1, $str2);
		}
		public static function strcmp($str1, $str2, $locale = false)
		{
			if ($locale)
			{
				// Get current locale
				$locale0 = setlocale(LC_COLLATE, 0);
	
				if (!$locale = setlocale(LC_COLLATE, $locale))
				{
					$locale = $locale0;
				}
	
				// See if we have successfully set locale to UTF-8
				if (!stristr($locale, 'UTF-8') && stristr($locale, '_') && preg_match('~\.(\d+)$~', $locale, $m))
				{
					$encoding = 'CP' . $m[1];
				}
				elseif (stristr($locale, 'UTF-8') || stristr($locale, 'utf8'))
				{
					$encoding = 'UTF-8';
				}
				else
				{
					$encoding = 'nonrecodable';
				}
	
				// If we successfully set encoding it to utf-8 or encoding is sth weird don't recode
				if ($encoding == 'UTF-8' || $encoding == 'nonrecodable')
				{
					return strcoll($str1, $str2);
				}
	
				return strcoll(static::transcode($str1, 'UTF-8', $encoding), static::transcode($str2, 'UTF-8', $encoding));
			}
	
			return strcmp($str1, $str2);
		}
		public static function transcode($source, $fromEncoding, $toEncoding)
		{
			if (\is_string($source))
			{
				switch (ICONV_IMPL)
				{
					case 'glibc':
						return @iconv($fromEncoding, $toEncoding . '//TRANSLIT,IGNORE', $source);
	
					case 'libiconv':
					default:
						return iconv($fromEncoding, $toEncoding . '//IGNORE//TRANSLIT', $source);
				}
			}
		}
	}
}
if (!class_exists('fwfmArrayHelper')) {
	class fwfmArrayHelper {
		protected static $sortCase;
		protected static $sortDirection;
		protected static $sortKey;
		protected static $sortLocale;
		static function toInteger(&$data, $default=0) {
			foreach ($data as $i=>$val) {
				$data[$i] = is_numeric($val)?(int)$val:$default;
			}
		}
		static function toString($data) {
			return implode(' ', (array)$data);
		}
		static function getValue($data, $name, $default='') {
			if (isset($data[$name])) return $data[$name];
			else return $default;
		}
		public static function sortObjects(&$a, $k, $direction = 1, $caseSensitive = true, $locale = false) {
			if (!is_array($locale) || !is_array($locale[0]))
			{
				$locale = array($locale);
			}
	
			self::$sortCase = (array) $caseSensitive;
			self::$sortDirection = (array) $direction;
			self::$sortKey = (array) $k;
			self::$sortLocale = $locale;
	
			usort($a, array(__CLASS__, '_sortObjects'));
	
			self::$sortCase = null;
			self::$sortDirection = null;
			self::$sortKey = null;
			self::$sortLocale = null;
	
			return $a;
		}
		protected static function _sortObjects(&$a, &$b)
		{
			$key = self::$sortKey;
	
			for ($i = 0, $count = count($key); $i < $count; $i++)
			{
				if (isset(self::$sortDirection[$i]))
				{
					$direction = self::$sortDirection[$i];
				}
	
				if (isset(self::$sortCase[$i]))
				{
					$caseSensitive = self::$sortCase[$i];
				}
	
				if (isset(self::$sortLocale[$i]))
				{
					$locale = self::$sortLocale[$i];
				}
	
				$va = $a->{$key[$i]};
				$vb = $b->{$key[$i]};
	
				if ((is_bool($va) || is_numeric($va)) && (is_bool($vb) || is_numeric($vb)))
				{
					$cmp = $va - $vb;
				}
				elseif ($caseSensitive)
				{
					$cmp = fwfmStringHelper::strcmp($va, $vb, $locale);
				}
				else
				{
					$cmp = fwfmStringHelper::strcasecmp($va, $vb, $locale);
				}
	
				if ($cmp > 0)
				{
					return $direction;
				}
	
				if ($cmp < 0)
				{
					return -$direction;
				}
			}
	
			return 0;
		}
	}
}
if (!function_exists('esc_attr')) {
	function esc_attr($text) {
		return htmlspecialchars($text);
	}
}
if (!function_exists('esc_html')) {
	function esc_html($text) {
		return $text;
	}
}
if (!function_exists('esc_js')) {
	function esc_js($text) {
		return addcslashes($text, "'");
	}
}
if (!function_exists('esc_textarea')) {
	function esc_textarea($text) {
		return htmlspecialchars($text, ENT_QUOTES);
	}
}
if (!function_exists('esc_url')) {
	function esc_url($text) {
		return urlencode($text);
	}
}
if (!function_exists('esc_url_raw')) {
	function esc_url_raw($text) {
		return rawurlencode($text);
	}
}
