<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

$view = $displayData['view'];

$row = $view->row;

$additional_classes = ' fwfm-menu-item-'.$row->id;

$text_align = $row->params->get('meal_text_alignment');
if (!$text_align or $text_align == 'def') {
	$text_align = $view->params->get('meal_text_alignment');
}
if (in_array($text_align, array('center', 'right'))) {
	$additional_classes .= ' fwfm-menu-item-align-'.$text_align;
}
$view->app->triggerEvent('onCollectMenuStatus', array('com_fwfoodmenu', $view, $row, &$additional_classes));

$additional_styles = '';
$view->app->triggerEvent('onCollectMenuCustomStyles', array('com_fwfoodmenu', $view, $row, &$additional_styles));


$price_block = '';
$view->app->triggerEvent('onGetMenuPriceBlock', array('com_fwfoodmenu', $view, $row, &$price_block));

ob_start();
$view->app->triggerEvent('onShowMenuItemHeader', array('com_fwfoodmenu', $view, $row));
$buff = ob_get_clean();

?>
<div class="fwfm-menu-item <?php echo $additional_classes; ?>" data-cat="<?php echo $row->category_id; ?>"<?php if ($additional_styles) { ?> style="<?php echo $additional_styles; ?>"<?php } ?> data-name="<?php echo $view->escape($row->name); ?>" data-description="<?php echo $view->escape(strip_tags($row->description)); ?>">
<?php
if ($buff) {
?>
    <table>
        <tr>
            <td><?php echo $buff; ?></td>
            <td>
<?php
}
?>
	<div class="fwfm-menu-item-text">
    	<a name="<?php echo $view->escape(urlencode($row->name)); ?>"></a>
<?php
$view->app->triggerEvent('onShowMenuPromoTopBadges', array('com_fwfoodmenu', $view, $row));

$additional_styles = '';
$view->app->triggerEvent('onCollectMenuTitleCustomStyles', array('com_fwfoodmenu', $view, $row, &$additional_styles));
?>
		<div class="fwfm-menu-item-title"<?php if ($additional_styles) { ?> style="<?php echo $additional_styles; ?>"<?php } ?>>
			<span><?php echo $row->name; ?></span>
<?php
$view->app->triggerEvent('onShowMenuPromoHeaderIcons', array('com_fwfoodmenu', $view, $row));
?>

			<div class="fwfm-menu-item-price">
<?php
if ($price_block) {
	echo $price_block;
} elseif (!empty($row->_prices[0]->price)) {
?>
				<div class="fwfm-item-price-block">
					<div class="fwfm-item-price-row">
						<span class="fwfm-item-price"><?php echo fwFoodMenuHelper::formatPrice($row->_prices[0]->price); ?></span>
					</div>
				</div>
<?php
}
$view->app->triggerEvent('onShowMenuPriceOptions', array('com_fwfoodmenu', $view, $row));
?>
			</div>
		</div>
<?php
$view->app->triggerEvent('onShowMenuPromoBlock', array('com_fwfoodmenu', $view, $row));
?>
		<div class="fwfm-menu-item-description">
			<?php echo $row->description; ?>
		</div>
<?php
$view->app->triggerEvent('onShowMenuPromoBottom', array('com_fwfoodmenu', $view, $row));
?>
	</div>
<?php
if ($buff) {
?>
            </td>
        </tr>
    </table>
<?php
}
?>
</div>
