<?php
/**
 * FW Food menu 4.4.1
 * @copyright (C) 2020 Fastw3b
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.fastw3b.net/ Official website
 **/

defined( '_FWFM_EXEC' ) or die( 'Restricted access' );

class MenuViewMenu extends fwfmViewLegacy {
	function display($tmpl=null) {
		$model = $this->getModel();

		$this->direct_link = false;

		$this->category = $model->loadCategory();
		if ($this->category->id and !$this->category->published) {
			return;
			// throw new Exception(fwfmText::_('FWFM_CATEGORY_NOT_PUBISHED', $name, $type, $prefix), 500);
		}

		$this->app = fwfmFactory::getApplication();
		if ($this->category->id) {
			$this->params = new fwfmParams($this->category->params, fwFoodMenuHelper::getParentCategories($this->category->parent));
			$this->params->set('category_id', array($this->category->id));
		} else {
			$this->params = new fwfmParams(new fwfmRegistry);
		}
		$this->params->set('col_qty', 1);
		$this->app->triggerEvent('onBeforeMenuLoad', array('com_fwfoodmenu', $this));

		$this->link = fwfmURI::getInstance()->toString();
		$this->list = $model->loadList($this->params);

		$this->app->triggerEvent('onBeforeMenuDisplay', array('com_fwfoodmenu', $this, $this->list));

		if ($title = $this->params->get('page_title')) {
			fwfmFactory::getDocument()->setTitle($title);
		}
		if ($this->params->get('show_page_heading') and !$this->params->get('page_heading')) {
			if ($this->category->id) {
				$this->params->set('page_heading', $this->category->name);
			} else {
				$this->params->set('page_heading', $this->params->get('page_title'));
			}
		}
		parent::display($tmpl);
	}
}
