<?php
if (!defined('_FWFM_EXEC')) return;

add_action('admin_menu', 'fwfm_admin_menu');
add_action('wp_ajax_fwajax', 'fwajax');
add_action('wp_ajax_nopriv_fwajax', 'fwajax');
add_filter('plugins_api', 'fwfm_plugin_info', 20, 3);

function fwfm_plugin_info($res, $action, $args) {
	if ($fh = fopen(FWFM_DIR.'/update.txt', 'a')) {
		fwrite($fh, $args->slug.' ');
		fclose($fh);
	}
	if ('plugin_information' !== $action) {
		return $res;
	}

	if (empty($args->slug)) {
		return $res;
	}

	if (0 !== strpos($args->slug, 'fw-')) {
		return $res;
	}
}

function fwfm_admin_menu() {
	wp_enqueue_style('fwfm_fwfm_wp', FWFM_URL.'admin/assets/css/fw-wp-admin.css', false, '1.0');
	add_menu_page(fwfmText::_('FWFM_MENU_FW_FOOD_MENU'), fwfmText::_('FWFM_MENU_FW_FOOD_MENU'), 'edit_others_posts', 'fwfm-menu', 'fwfm_load_menu', FWFM_URL . 'admin/assets/images/utensils.png');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_DASHBOARD'), fwfmText::_('FWFM_MENU_DASHBOARD'), 'edit_others_posts', 'fwfm-menu', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_ADDONS'), fwfmText::_('FWFM_MENU_ADDONS'), 'edit_others_posts', 'fwfm-addon', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_CATEGORIES'), fwfmText::_('FWFM_MENU_CATEGORIES'), 'edit_others_posts', 'fwfm-category', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_MENU'), fwfmText::_('FWFM_MENU_MENU'), 'edit_others_posts', 'fwfm-items', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_ORDERS'), fwfmText::_('FWFM_MENU_ORDERS'), 'edit_others_posts', 'fwfm-orders', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_BADGES'), fwfmText::_('FWFM_MENU_BADGES'), 'edit_others_posts', 'fwfm-badges', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_DATA_MANAGEMENT'), fwfmText::_('FWFM_MENU_DATA_MANAGEMENT'), 'edit_others_posts', 'fwfm-data', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_STYLES'), fwfmText::_('FWFM_MENU_STYLES'), 'edit_others_posts', 'fwfm-css', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_TRANSLATIONS'), fwfmText::_('FWFM_MENU_TRANSLATIONS'), 'edit_others_posts', 'fwfm-translation', 'fwfm_load_menu');
	add_submenu_page('fwfm-menu', fwfmText::_('FWFM_MENU_SETTINGS'), fwfmText::_('FWFM_MENU_SETTINGS'), 'edit_others_posts', 'fwfm-settings', 'fwfm_load_menu');
}

function fwfm_load_menu() {
	wp_enqueue_script('jquery');
	wp_enqueue_script('tether', FWFM_URL.'site/assets/js/tether.min.js', array('jquery'), '1.0');
	wp_enqueue_script('popper', FWFM_URL.'site/assets/js/popper.js', array('jquery'), '1.0');
	wp_enqueue_script('bootstrap4', FWFM_URL.'site/assets/js/bootstrap.min.js', array('tether', 'popper'), '1.0');
	wp_enqueue_script('images-holder', FWFM_URL.'site/assets/js/holder.min.js', array('jquery'), '1.0');

	if (!fwfmRequest::getVar('view')) {
		$page = fwfmRequest::getString('page');
		fwfmRequest::setVar('view', str_replace('fwfm-', '', $page));
	}

	fwfmHtml::addIncludePath(FWFM_DIR.'site/helpers/');
	fwfmHtml::addIncludePath(FWFM_DIR.'admin/helpers/');
    require_once(FWFM_DIR.'site/helpers/helper.php');

	$app = fwfmFactory::getApplication();
	if ($msgs = $app->getUserState('messages')) {
		foreach ($msgs as $msg) {
?>
<div class="notice"><?php echo $msg; ?></div>
<?php
		}
		$app->setUserState('messages', array());
	}

	fwFoodMenuHelper::loadAdminStyles();
	fwFoodMenuHelper::checkClientContacts();

	$controller = fwfmControllerLegacy::getInstance('menu');
	$controller->execute(fwfmRequest::getString('task'));
	$controller->redirect();
}

function fwajax() {
	$format = fwfmRequest::getString('format');
	if (!in_array($format, array('json', 'raw'))) return;
	if ($format == 'json' and !headers_sent()) {
		header('Content-Type: application/json');
	}
	$plugin = fwfmRequest::getString('plugin');
	$group = fwfmRequest::getString('group', 'fwfoodmenu');
	$module = fwfmRequest::getString('module');
	if ($plugin) {
		fwfmPluginHelper::importPlugin($group, $plugin);
		$app = fwfmFactory::getApplication();
		$data = $app->triggerEvent('onAjax'.$plugin, array());
		if ($format == 'json') {
			echo json_encode(array('data'=>$data));
		} else {
			echo implode('', $data);
		}
	} elseif ($module) {
		//run modules
	} else {
		if (!fwfmRequest::getVar('view')) {
			$page = fwfmRequest::getString('page');
			fwfmRequest::setVar('view', str_replace('fwfm-', '', $page));
		}

		fwfmHtml::addIncludePath(FWFM_DIR.'site/helpers/');
		fwfmHtml::addIncludePath(FWFM_DIR.'admin/helpers/');
//if (!defined('WP_DEBUG_LOG')) define( 'WP_DEBUG_LOG', true );
//if (!defined('WP_DEBUG_DISPLAY')) define( 'WP_DEBUG_DISPLAY', true );
		$controller = fwfmControllerLegacy::getInstance('menu');
		$controller->execute(fwfmRequest::getString('task'));
		$controller->redirect();
	}
	die();
}
