<?php
if (!defined('_FWFM_EXEC')) return;

add_shortcode('fwfm_categories', 'fwfm_load_categories_list');
add_shortcode('fwfm_menu', 'fwfm_load_menu_list');
add_shortcode('fwfm_mod_cart', 'fwfm_load_mod_cart');
add_shortcode('fwfm_mod_categories', 'fwfm_load_mod_categories');
add_shortcode('fwfm_mod_mealcategory', 'fwfm_load_mod_mealcategory');
add_shortcode('fwfm_mod_mealpromo', 'fwfm_load_mod_mealpromo');
add_action('wp_ajax_fwajax', 'fwajax');

function fwfm_load_categories_list($attrs) {
	if (!is_array($attrs)) {
		$attrs = array();
	}
    if (!empty($attrs['category_id'])) {
        $attrs['category_id'] = explode(',', $attrs['category_id']);
    }
    if (!empty($attrs['categories'])) {
		$db = fwfmFactory::getDBO();
		$buff = explode('|', $attrs['categories']);
		if (!isset($attrs['category_id'])) {
			$attrs['category_id'] = array();
		}
		foreach ($buff as $id) {
			$db->setQuery('SELECT id FROM `#__fwfoodmenu_category` AS c WHERE name = '.$db->quote($id).' OR EXISTS(SELECT * FROM `#__fwfoodmenu_translations` AS tr WHERE tr.obj_id = c.id AND tr.`key` = \'category.name\' AND tr.text = '.$db->quote($id).')');
			if ($cid = $db->loadResult()) {
				$attrs['category_id'][] = $cid;
			}
		}
	}
	if (!empty($attrs['addons'])) {
		$attrs['plugins'] = $attrs['addons'];
	}
    if (!empty($attrs['plugins'])) {
		$buff = explode('|', $attrs['plugins']);
		$attrs['plugins'] = array();
		foreach ($buff as $row) {
			$cols = explode(':', $row, 2);
			$attrs['plugins'][$cols[0]] = (empty($cols[1]) or (!empty($cols[1]) and strtolower($cols[1]) != 'off'))?1:0;
		}
	}
	if (!isset($attrs['plugins'])) {
		$attrs['plugins'] = array();
	}
	$plugins = fwFoodMenuHelper::loadPlugins();
	if (!empty($plugins['fwfoodmenu'])) {
		foreach ($plugins['fwfoodmenu'] as $plugin) {
			if ($plugin->enabled and !isset($attrs['plugins'][$plugin->element])) {
				$attrs['plugins'][$plugin->element] = 1;
			}
		}
	}

    if (!empty($attrs['add_params'])) {
		$buff = explode('|', $attrs['add_params']);
		$attrs['add_params'] = array();
		foreach ($buff as $row) {
			$cols = explode(':', $row, 2);
			if (!empty($cols[1])) {
				if (strtolower($cols[1]) == 'off') {
					$cols[1] = 0;
				} elseif (strtolower($cols[1]) == 'on') {
					$cols[1] = 1;
				}
				$attrs['add_params'][$cols[0]] = $cols[1];
			}
		}
	}
    ob_start();
    fwfm_component_loading('category', $attrs);
    return ob_get_clean();
}
function fwfm_load_menu_list($attrs) {
	if (!is_array($attrs)) {
		$attrs = array();
	}
    if (!empty($attrs['category_id'])) {
        $attrs['category_id'] = explode(',', $attrs['category_id']);
    }
    if (!empty($attrs['categories'])) {
		$db = fwfmFactory::getDBO();
		$buff = explode('|', $attrs['categories']);
		if (!isset($attrs['category_id'])) {
			$attrs['category_id'] = array();
		}
		foreach ($buff as $id) {
			$db->setQuery('SELECT id FROM `#__fwfoodmenu_category` AS c WHERE name = '.$db->quote($id).' OR EXISTS(SELECT * FROM `#__fwfoodmenu_translations` AS tr WHERE tr.obj_id = c.id AND tr.`key` = \'category.name\' AND tr.text = '.$db->quote($id).')');
			if ($cid = $db->loadResult()) {
				$attrs['category_id'][] = $cid;
			}
		}
	}
	if (!isset($attrs['category_id'])) {
		$attrs['category_id'] = null;
	}
	if (!empty($attrs['addons'])) {
		$attrs['plugins'] = $attrs['addons'];
	}
    if (!empty($attrs['plugins'])) {
		$buff = explode('|', $attrs['plugins']);
		$attrs['plugins'] = array();
		foreach ($buff as $row) {
			$cols = explode(':', $row, 2);
			$attrs['plugins'][$cols[0]] = (empty($cols[1]) or (!empty($cols[1]) and strtolower($cols[1]) != 'off'))?1:0;
		}
	}
	if (!isset($attrs['plugins'])) {
		$attrs['plugins'] = array();
	}
	$plugins = fwFoodMenuHelper::loadPlugins();
	if (!empty($plugins['fwfoodmenu'])) {
		foreach ($plugins['fwfoodmenu'] as $plugin) {
			if ($plugin->enabled and !isset($attrs['plugins'][$plugin->element])) {
				$attrs['plugins'][$plugin->element] = 1;
			}
		}
	}
    if (!empty($attrs['add_params'])) {
		$buff = explode('|', $attrs['add_params']);
		$attrs['add_params'] = array();
		foreach ($buff as $row) {
			$cols = explode(':', $row, 2);
			if (!empty($cols[1])) {
				if (strtolower($cols[1]) == 'off') {
					$cols[1] = 0;
				} elseif (strtolower($cols[1]) == 'on') {
					$cols[1] = 1;
				}
				$attrs['add_params'][$cols[0]] = $cols[1];
			}
		}
	} else {
		$attrs['add_params'] = null;
	}
	ob_start();
    fwfm_component_loading('menu', $attrs);
    return ob_get_clean();
}

function fwfm_load_mod_cart($attrs) {
    ob_start();
    fwfm_module_loading('mod_fwfm_cart', $attrs);
    return ob_get_clean();
}
function fwfm_load_mod_categories($attrs) {
	if (!is_array($attrs)) {
		$attrs = array();
	}
    if (!empty($attrs['category_id'])) {
        $attrs['category_id'] = explode(',', $attrs['category_id']);
    }
    if (!empty($attrs['categories'])) {
		$db = fwfmFactory::getDBO();
		$buff = explode('|', $attrs['categories']);
		if (!isset($attrs['category_id'])) {
			$attrs['category_id'] = array();
		}
		foreach ($buff as $id) {
			$db->setQuery('SELECT id FROM `#__fwfoodmenu_category` AS c WHERE name = '.$db->quote($id).' OR EXISTS(SELECT * FROM `#__fwfoodmenu_translations` AS tr WHERE tr.obj_id = c.id AND tr.`key` = \'category.name\' AND tr.text = '.$db->quote($id).')');
			if ($cid = $db->loadResult()) {
				$attrs['category_id'][] = $cid;
			}
		}
	}
    ob_start();
    fwfm_module_loading('mod_fwfm_categories', $attrs);
    return ob_get_clean();
}
function fwfm_load_mod_mealcategory($attrs) {
	if (!is_array($attrs)) {
		$attrs = array();
	}
    if (!empty($attrs['category_id'])) {
        $attrs['category_id'] = explode(',', $attrs['category_id']);
    }
    if (!empty($attrs['categories'])) {
		$db = fwfmFactory::getDBO();
		$buff = explode('|', $attrs['categories']);
		if (!isset($attrs['category_id'])) {
			$attrs['category_id'] = array();
		}
		foreach ($buff as $id) {
			$db->setQuery('SELECT id FROM `#__fwfoodmenu_category` AS c WHERE name = '.$db->quote($id).' OR EXISTS(SELECT * FROM `#__fwfoodmenu_translations` AS tr WHERE tr.obj_id = c.id AND tr.`key` = \'category.name\' AND tr.text = '.$db->quote($id).')');
			if ($cid = $db->loadResult()) {
				$attrs['category_id'][] = $cid;
			}
		}
	}
    ob_start();
    fwfm_module_loading('mod_fwfm_mealcategory', $attrs);
    return ob_get_clean();
}
function fwfm_load_mod_mealpromo($attrs) {
	if (!is_array($attrs)) {
		$attrs = array();
	}
    if (!empty($attrs['meal'])) {
		$db = fwfmFactory::getDBO();

		$db->setQuery('SELECT id FROM `#__fwfoodmenu_menu` AS c WHERE name = '.$db->quote($attrs['meal']).' OR EXISTS(SELECT * FROM `#__fwfoodmenu_translations` AS tr WHERE tr.obj_id = c.id AND tr.`key` = \'meal.name\' AND tr.text = '.$db->quote($attrs['meal']).')');
		if ($cid = $db->loadResult()) {
			$attrs['meal_id'] = $cid;
		}
	}

    ob_start();
    fwfm_module_loading('mod_fwfm_promo', $attrs);
    return ob_get_clean();
}
function fwfm_module_loading($module_name, $params=array()) {
	$path = FWFM_DIR.'modules/'.$module_name;
    if (is_dir($path)) {
		$lang = fwfmFactory::getLanguage();
		$lang->load($module_name);
        $module = (object)array(
            'id' => $module_name,
            'name' => $module_name,
        );
        $params = new fwfmRegistry($params);
        $lang = new fwfmLanguage;
        ob_start();
        require($path.'/'.$module_name.'.php');
        echo fwfmRoute::fwwpFixLinks(ob_get_clean());
    }
}

function fwfm_component_loading($view, $params=array()) {
	if (!fwfmRequest::getVar('view')) {
		fwfmRequest::setVar('view', $view);
	}

	wp_enqueue_script('jquery');
	wp_enqueue_script('tether', FWFM_URL.'site/assets/js/tether.min.js', array('jquery'), '1.0');
	wp_enqueue_script('bootstrap4', FWFM_URL.'site/assets/js/bootstrap.min.js', array('tether'), '1.0');
	wp_enqueue_script('images-holder', FWFM_URL.'site/assets/js/holder.min.js', array('jquery'), '1.0');
	wp_enqueue_script('popper', FWFM_URL.'site/assets/js/popper.js', array('jquery'), '1.0');

	fwfmHtml::addIncludePath(FWFM_DIR.'site/helpers/');
	fwfmHtml::addIncludePath(FWFM_DIR.'admin/helpers/');
    require_once(FWFM_DIR.'site/helpers/helper.php');

	$app = fwfmFactory::getApplication();
    if ($params) {
        $app->params->loadArray($params);
		$menu = fwfmMenu::getInstance('site');
		$menu->item->params->loadArray($params);
	}
	if ($msgs = $app->getUserState('messages')) {
		foreach ($msgs as $msg) {
?>
<div class="notice"><?php echo $msg; ?></div>
<?php
		}
		$app->setUserState('messages', array());
	}

	$controller = fwfmControllerLegacy::getInstance('menu');
	$controller->execute(fwfmRequest::getString('task'));
	$controller->redirect();
	fwfmRequest::setVar('view', null);
}

function fwajax() {
	$format = fwfmRequest::getString('format');
	if (!in_array($format, array('json', 'raw'))) return;
	if ($format == 'json' and !headers_sent()) {
		header('Content-Type: application/json');
	}
	$plugin = fwfmRequest::getString('plugin');
	$group = fwfmRequest::getString('group', 'fwfoodmenu');
	$module = fwfmRequest::getString('module');
	if ($plugin) {
		fwfmPluginHelper::importPlugin($group, $plugin);
		$app = fwfmFactory::getApplication();
		$data = $app->triggerEvent('onAjax'.$plugin, array());
		if ($format == 'json') {
			echo json_encode(array('data'=>$data));
		} else {
			echo implode('', $data);
		}
	} elseif ($module) {
		//run modules
	} else {
		if (!fwfmRequest::getVar('view')) {
			$page = fwfmRequest::getString('page');
			fwfmRequest::setVar('view', str_replace('fwfm-', '', $page));
		}

		fwfmHtml::addIncludePath(FWFM_DIR.'site/helpers/');
		fwfmHtml::addIncludePath(FWFM_DIR.'admin/helpers/');
if (!defined('WP_DEBUG_LOG')) define( 'WP_DEBUG_LOG', true );
if (!defined('WP_DEBUG_DISPLAY')) define( 'WP_DEBUG_DISPLAY', true );
		$controller = fwfmControllerLegacy::getInstance('menu');
		$controller->execute(fwfmRequest::getString('task'));
		$controller->redirect();
	}
    die();
}
